<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


/**
  * Wochen-Kalender
	*/
function ko_res_cal_woche($woche, $jahr, $mode="html", $output=TRUE) {
  global $smarty, $ko_path;
	global $access;
  
	if($access['reservation']['MAX'] < 1) return FALSE;
  
  //Find beginning and end date of selected week
	$start = add2date("01.01.$jahr", "tag", (7*($woche-1)));
	$week_start = ko_get_setting('res_pdf_week_start');
	$inc = -1; $back = 0;
	while((int)strftime("%w", mktime(1,1,1, $start[1], $start[0], $start[2])) != $week_start) {
		$start = add2date(implode(".", $start), "tag", $inc);
		$back++;
		if($back > 2) $inc = 1;
	}
  $ende = add2date(implode(".", $start), "tag", 6);
  
  $smarty->assign("tpl_cal_titel", getLL("time_week")." ".strftime("%V", mktime(1, 1, 1, $start[1], $start[0], $start[2])));
  
  //Heute
  get_heute($h_tag, $h_monat, $h_jahr);
  $h_week = strftime("%V", mktime(1,1,1, $h_monat, $h_tag, $h_jahr));
  
  $w_prev = add2date(implode(".", $start), "tag", -7);
  $prev_week = strftime("%V", mktime(1,1,1, $w_prev[1], $w_prev[0], $w_prev[2]));
  $prev_year = strftime("%G", mktime(1,1,1, $w_prev[1], $w_prev[0], $w_prev[2]));
  $w_next = add2date(implode(".", $start), "tag", 7);
  $next_week = strftime("%V", mktime(1,1,1, $w_next[1], $w_next[0], $w_next[2]));
  $next_year = strftime("%G", mktime(1,1,1, $w_next[1], $w_next[0], $w_next[2]));
	$tpl_prev_link = "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_week,set_year,sesid', 'setwoche,$prev_week,$prev_year,".session_id()."', do_element);";
	$tpl_next_link = "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_week,set_year,sesid', 'setwoche,$next_week,$next_year,".session_id()."', do_element);";
	$tpl_today_link = "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_week,set_year,sesid', 'setwoche,$h_week,$h_jahr,".session_id()."', do_element);";
  $smarty->assign("tpl_prev_link", $tpl_prev_link);
  $smarty->assign("tpl_next_link", $tpl_next_link);
  $smarty->assign("tpl_today_link", $tpl_today_link);
  
	//Herausfinden, ob neue Reservationen angelegt werden drfen
  $set_new_date = FALSE;
	apply_res_filter($z_where, $z_limit, 'immer', 'immer');

	//Personen-Daten anzeigen oder nicht
	$show_persondata = ($_SESSION["ses_userid"] != ko_get_guest_id() || ko_get_setting("res_show_persondata"));
  
  $hour_start = ko_get_setting("cal_woche_start");
  $hour_end = ko_get_setting("cal_woche_end");
  for($h = $hour_start; $h < $hour_end; $h++) {
    $hour[$h]["name"] = str_to_2($h)."-".str_to_2($h+1);
  } 

	ko_get_resitems($resitems);
  
  for($t_inc = 0; $t_inc < 7; $t_inc++) {
    $tag = add2date(implode(".", array($start[0], $start[1], $start[2])), "tag", $t_inc);
    $tag_str = implode(".", $tag);
    $col[$t_inc] = 0;
    
    //Datum setzen
    $daynames[$t_inc] = strftime("%A<br />".$GLOBALS["DATETIME"]["dmY"], mktime(1,1,1, $tag[1], $tag[0], $tag[2]));
    
    //new_date nur setzen, falls mindestens fr eine Termingruppe neue Termine angelegt werden drfen
    if($set_new_date) $new_date = $tag_str;
		else $new_date = "";

    //Alle Reservationen an diesem Tag finden
    ko_get_res_by_date($tag[0], $tag[1], $tag[2], $r_, FALSE, "res", $z_where);
		ko_get_eventgruppen($all_tgs);

		if(sizeof($r_) > 0) {
			//Reservationen zusammenfassen, wenn sie zu einem Termin gehren (falls Setting so gesetzt)
			if(ko_get_setting('show_dateres_combined') == 1) {
				//Alle Termine an diesem Tag finden, die Reservationen haben
				ko_get_events_by_date($tag[0], $tag[1], $tag[2], $d_, "AND `reservationen` != ''");
				foreach($d_ as $d_i => $d) {
					$tg = $all_tgs[$d["eventgruppen_id"]];
					if($tg["res_combined"] == 0) continue;

					//Neue Fake-ID fr Resitem erstellen
					$new_item_id = "d".$d_i;
					$new_item = array("id" => $new_item_id, "name" => getLL("res_cal_combined")." ".$tg["name"], "farbe" => $tg["farbe"]);
					unset($new_res);

					foreach(explode(",", $d["reservationen"]) as $res_id) {
						unset($res);
						ko_get_res_by_id($res_id, $res_); $res = $res_[$res_id];
						if(!in_array($res["item_id"], $_SESSION["show_items"])) continue;

						//Angaben aus der ersten Reservation holen
						if(!isset($new_res)) {
							$new_res = $res;
							$new_res["item_id"] = $new_item_id;
							$new_res["zweck"] = "";
						}
						$new_res["zweck"] .= $resitems[$res["item_id"]]["name"].", ";
						unset($r_[$res_id]);
					}//foreach(explode(d[reservationen]))
					$new_res["zweck"] = substr($new_res["zweck"], 0, -2);
					$resitems[$new_item_id] = $new_item;
					$legende_add[$new_item_id] = array("name" => $new_item["name"], "color" => $tg["farbe"]);
					$r_[] = $new_res;
				}//foreach(d_ as d_i => d)
			}


			foreach($r_ as $r_i => $r) {
				if(!$r["item_id"]) continue;
				$color = $resitems[$r["item_id"]]["farbe"];
				$resitem = $resitems[$r["item_id"]];

				//Res-Beschreibung
				$desc  = ko_html2($resitem["name"]) . "&lt;br /&gt;&lt;b&gt;".ko_html2($r["zweck"])."&lt;/b&gt;&lt;br /&gt;";
				if($r["startzeit"] == "00:00:00" && $r["endzeit"] == "00:00:00") {
					$desc .= getLL("time_all_day");
				} else if($r["startdatum"] != $r["enddatum"]) {  //Mehrtgige Reservation
					if($tag[0] == substr($r["startdatum"], 8, 2) && $tag[1] == substr($r["startdatum"], 5, 2))
						$desc .= getLL("time_from")." ".substr($r["startzeit"], 0, -3);
					else if($tag[0] == substr($r["enddatum"], 8, 2) && $tag[1] == substr($r["enddatum"], 5, 2))
						$desc .= getLL("time_to")." ".substr($r["endzeit"], 0, -3);
					else
						$desc .= getLL("time_all_day");
				} else {  //eintgig
					$desc .= substr($r["startzeit"], 0, -3) . "-" . substr($r["endzeit"], 0, -3);
				}
				if($show_persondata) {
					$desc .= ": " . ko_html2($r["name"]) . "&lt;br /&gt;";
					$desc .= format_email(ko_html2($r["email"])) . "&lt;br /&gt;";
				}

				//Anfangs- und Endstunden des Anlasses finden (als Dezimalbruch)
				if($r["startzeit"] == "00:00:00" && $r["endzeit"] == "00:00:00") {
					$h1 = "00";
					$h2 = "24";
				} else {
					$h1 = (substr($r["startdatum"], -2) != $tag[0]) ? $hour_start : ((int)substr($r["startzeit"], 0, 2) + ((int)substr($r["startzeit"], 3, 2)/60));
					$h2 = (substr($r["enddatum"], -2) != $tag[0]) ? $hour_end : ((int)substr($r["endzeit"], 0, 2) + ((int)substr($r["endzeit"], 3, 2)/60));
				}
				while($h1 < $hour_start) $h1++;
				while($h1 < $h2 && $h1 < $hour_end) {
					if(($h1+1) >= $h2 || ($h1+1) >= $hour_end) $last = TRUE;
					else $last = FALSE;

					//delete link
					if($access['reservation'][$r['item_id']] > 2 || ($_SESSION['ses_userid'] == $r['user_id'] && $_SESSION['ses_userid'] != ko_get_guest_id() && $access['reservation'][$r['item_id']] > 1)) {
						$del_link  = "javascript:c = confirm('".getLL("res_delete_res_confirm")."');if(!c) return false;";
						if($r["serie_id"]) $del_link .= "c2 = confirm('".getLL("res_delete_serie_confirm")."');set_hidden_value('mod_confirm', c2);";
						$del_link .= "set_action('delete_res');set_hidden_value('id', '$r_i');";
					} else {
						$del_link = "";
					}
					//edit link
					$click = ($access['reservation'][$r['item_id']] > 2 || ($_SESSION['ses_userid'] == $r['user_id'] && $_SESSION['ses_userid'] != ko_get_guest_id() && $access['reservation'][$r['item_id']] > 1)) ? "jumpToUrl('?action=edit_res&amp;id=".$r['id']."');" : '';

					//create entry
					$hour[$h1]['day'][$t_inc]['cols'][$col[$t_inc]] = array('color' => $color, 'last' => $last, 'desc' => $desc, 'click' => $click, 'del_link' => $del_link, 'mod' => FALSE, 'check_link' => '', 'item_id' => $r['item_id']);
					$h1++;
				}
				$col[$t_inc]++;
			}//foreach(r_ as r)
		}//if(sizeof(r_))


    for($h = $hour_start; $h < $hour_end; $h++) {
      $hour_stamp = mktime($h, 0, 0, $tag[1], $tag[0], $tag[2]);

      if(is_array($hour[$h]["day"][$t_inc]["cols"])) {
        $hour[$h]["day"][$t_inc]["col_width"] = 100/(int)$col[$t_inc]."%";
        for($i=0; $i<$col[$t_inc]; $i++) {
          if(!is_array($hour[$h]["day"][$t_inc]["cols"][$i])) {
            $hour[$h]["day"][$t_inc]["cols"][$i] = array("desc" => "");
            //Heute definieren
            if((int)$tag[0] == (int)$h_tag && (int)$tag[1] == (int)$h_monat && (int)$tag[2] == (int)$h_jahr) $hour[$h]["day"][$t_inc]["heute"] = TRUE;
            else $hour[$h]["day"][$t_inc]["heute"] = FALSE;
          }
        }
        ksort($hour[$h]["day"][$t_inc]["cols"]);
      }
      else {
        //Heute definieren
        if((int)$tag[0] == (int)$h_tag && (int)$tag[1] == (int)$h_monat && (int)$tag[2] == (int)$h_jahr) $hour[$h]["day"][$t_inc]["heute"] = TRUE;
        else $hour[$h]["day"][$t_inc]["heute"] = FALSE;

        $hour[$h]["day"][$t_inc]["col_width"] = "100%";
        $hour[$h]["day"][$t_inc]["empty"] = TRUE;
      }

			if($set_new_date) {
				$hour[$h]["day"][$t_inc]["mouseup"] = "jumpToUrl('?action=neue_reservation&amp;end_stamp=$hour_stamp&amp;start_stamp='+document.getElementsByName('new_event_start')[0].value);";
				$hour[$h]["day"][$t_inc]["mousedown"] = "set_hidden_value('new_event_start', '$hour_stamp');";
			}//if(set_new_date)

    }//for(h=hour_start..hour_end)
  }//for(t_inc=0..6)

	if($mode == "html") {
		//Footer
		//PDF-Export-Link anzeigen:
		$button_code  = '&nbsp;<span onclick="sendReq(\'../reservation/inc/ajax.php\', \'action,sesid\', \'respdfweek,'.session_id().'\', do_element);">';
		$button_code .= '<img src="'.$ko_path.'images/create_pdf.png" border="0" />&nbsp;'.getLL("res_list_footer_pdf_label").'</span>';
		$button_code .= '<span name="pdf_link" id="pdf_link">&nbsp;</span>';
		$list_footer[] = array("label" => "", "button" => $button_code);
		$smarty->assign("show_list_footer", TRUE);
		$smarty->assign("list_footer", $list_footer);

		//LL-Values
		$smarty->assign("label_cal_year", getLL("res_cal_year"));
		$smarty->assign("label_cal_month", getLL("res_cal_month"));
		$smarty->assign("label_cal_week", getLL("res_cal_week"));
		$smarty->assign("label_today", getLL("time_today"));
		$smarty->assign("label_delete", getLL("delete"));
		$smarty->assign("label_time", getLL("res_time"));
		$smarty->assign("label_confirm", getLL("res_mod_confirm"));

		$smarty->assign("daynames", $daynames);
		$smarty->assign("hour", $hour);
		if($output) {
		  $smarty->display('ko_cal_woche_gross.tpl');
		} else {
		  print $smarty->fetch('ko_cal_woche_gross.tpl');
		}
	} else if($mode == "pdf") {
		//Legende vorbereiten
		$legende = array_merge(array("titel" => getLL('res_reservations')), (array)$legende_add);
		foreach($_SESSION["show_items"] as $s) {
			if($resitems[$s]['name'] && $access['reservation'][$s] > 0) {
				$legende[$s] = array("color" => ko_get_resitem_farbe($s), "name" => $resitems[$s]["name"]);
			}
		}

		//PDF erstellen
		$filename = getLL("res_filename_pdf").str_to_2($woche)."_".$jahr."_".strftime("%d%m%Y_%H%M%S", time()).".pdf";
		$title = str_to_2($woche).'-'.$jahr;
		ko_export_cal_pdf_week($filename, $daynames, $hour, $legende, $title);
		return $filename;
	}
}//ko_res_cal_woche()




/**
  * Jahres-Kalender
	*/
function ko_res_cal_jahr($num=6, $start=1, $output=TRUE) {
	global $smarty, $ko_path;
	global $access;

	//Heute
  get_heute($h_tag, $h_monat, $h_jahr);
  $j = $_SESSION["cal_jahr_jahr"] ? $_SESSION["cal_jahr_jahr"] : $h_jahr;
  $t = 1;
  $m = $start;
  unset($day);

	//Monate
  unset($cal_month);
  for($i = $start; $i < ($start+$num); $i++) {
		$ii = $i > 12 ? ($i-12) : $i;
		$jj = ($ii != $i) ? ($j+1) : $j;
    $cal_month[] = array("code" => (str_to_2($ii)."-".$jj), "name" => strftime("%B", mktime(1,1,1, $ii, 1, $jj)));
  }
  $next = add2date("$t.$m.$j", "monat", $num);
  $prev = add2date("$t.$m.$j", "monat", "-$num");
  $today_start = 1;
  while( ((int)$today_start+$num-1) < $h_monat) {
    $today_start += $num;
  }

  $end_code = $next[2].str_to_2($next[1]).str_to_2($next[0]);

	$tpl_prev_link = "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_year,set_start,sesid', 'setjahr,".$prev[2].",".(int)$prev[1].",".session_id()."', do_element);";
	$tpl_next_link = "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_year,set_start,sesid', 'setjahr,".$next[2].",".(int)$next[1].",".session_id()."', do_element);";
	$tpl_today_link = "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_year,set_start,sesid', 'setjahr,$h_jahr,$today_start,".session_id()."', do_element);";


  $smarty->assign("tpl_cal_month", $cal_month);
  $smarty->assign("tpl_cal_month_width", (int)(90/$num));
  $smarty->assign("tpl_cal_titel", strftime("%Y", mktime(1,1,1, 1,1,$j)));

  $smarty->assign("tpl_prev_link", $tpl_prev_link);
  $smarty->assign("tpl_next_link", $tpl_next_link);
  $smarty->assign("tpl_today_link", $tpl_today_link);


	//Reservations-Gruppen Namen
	ko_get_resitems($_gruppen);
	$gruppen = array();
	foreach($_gruppen as $g) {
		if($access['reservation'][$g['id']] > 0 && in_array($g['id'], $_SESSION['show_items'])) $gruppen[$g['id']] = $g;
	}
	foreach($gruppen as $g_i => $g) {
    $day[$g_i]["name"] = ko_html($g["name"]);
    $day[$g_i]["tip"] = ko_html2($g["name"]);
  }

	//Personen-Daten anzeigen oder nicht
	$show_persondata = ($_SESSION["ses_userid"] != ko_get_guest_id() || ko_get_setting("res_show_persondata"));

	//Permanente Filter anwenden
	$z_where = "";
	$perm_filter_start = ko_get_setting("res_perm_filter_start");
	$perm_filter_ende  = ko_get_setting("res_perm_filter_ende");
	if($access['reservation']['MAX'] < 3) {
		if($perm_filter_start != "") {
			$z_where .= " AND startdatum >= '".$perm_filter_start."' ";
		}
		if($perm_filter_ende != "") {
			$z_where .= " AND startdatum <= '".$perm_filter_ende."' ";
		}
	}

	//Reservationen einfllen
  $day_code = $j.str_to_2($m).str_to_2($t);
  while($day_code < $end_code) {
	  //Wochentag vorausfllen
    $wt = strftime("%w", mktime(1,1,1, $m, $t, $j));
    if($wt == 0) $style = "background:#cccccc;";
    else if($wt == 6) $style = "background:#dddddd;";
    else $style = "";
    foreach($gruppen as $g_i => $g) {
      $day[(int)$g_i]["events"][$m]["days"][$t]["style"] = $style;
    }

		//Termine einfllen
    ko_get_res_by_date($t, $m, $j, $dates, TRUE, "res", $z_where);
    if(sizeof($dates) > 0) {
			foreach($gruppen as $g_i => $g) {
				$day_text = "";
				foreach($dates as $date) {
					if((int)$date["item_id"] == (int)$g_i) {

						$desc = "";
						if($date["startzeit"] == "00:00:00" && $date["endzeit"] == "00:00:00") {
              $desc .= getLL("time_all_day");
						} else if($date["startdatum"] != $date["enddatum"]) {  //Mehrtgige Termine
              if($t == substr($date["startdatum"], 8, 2) && $m == substr($date["startdatum"], 5, 2))
                $desc .= getLL("time_from")." ".substr($date["startzeit"], 0, -3);
              else if($t == substr($date["enddatum"], 8, 2) && $m == substr($date["enddatum"], 5, 2))
                $desc .= getLL("time_to")." ".substr($date["endzeit"], 0, -3);
              else
                $desc .= getLL("time_all_day");
            } else {  //eintgig
              $desc .= ($date["startzeit"] != "00:00:00" ? substr($date["startzeit"], 0, -3) : "") . (($date["endzeit"] != "00:00:00") ? ("-" . substr($date["endzeit"], 0, -3)) : "");
            }
            $day_text .= ($desc != "") ? "<br /><b>- ".$desc."</b>" : "<br />";


						if($show_persondata) $day_text .= ": ".($date["name"] ? (ko_html2($date["name"]).", ") : "");
						$day_text .= ($date["zweck"] ? "&quot;".ko_html2($date["zweck"])."&quot;" : "");
          }
	      }//foreach(dates)
				if($day_text) {
					$day[(int)$g_i]["events"][$m]["days"][$t]["tip"]  = "<b>".strftime($GLOBALS["DATETIME"]["DdMY"], mktime(1,1,1, $m,$t,$j))."</b><br />";
					$day[(int)$g_i]["events"][$m]["days"][$t]["tip"] .= ko_html2($g["name"]).$day_text;
          $day[(int)$g_i]["events"][$m]["days"][$t]["style"] = "background:#".$g["farbe"];
				}
      }//foreach(gruppen)
    }
    unset($dates);

    //Tag inkrementieren
    $datum = add2date("$t.$m.$j", "tag", 1);
    $t = (int)$datum[0];
    $m = (int)$datum[1];
		$j = (int)$datum[2];
    $day_code = $j.str_to_2($m).str_to_2($t);
  }

	//LL-Values
	$smarty->assign("label_cal_year", getLL("res_cal_year"));
	$smarty->assign("label_cal_month", getLL("res_cal_month"));
	$smarty->assign("label_cal_week", getLL("res_cal_week"));
	$smarty->assign("label_item", getLL("res_cal_object"));
	$smarty->assign("label_today", getLL("time_today"));

	//PDF-Export-Link anzeigen:
	$button_code  = '&nbsp;<span onclick="sendReq(\'../reservation/inc/ajax.php\', \'action\', \'pdfcalendar\', do_element);">';
	$button_code .= '<img src="'.$ko_path.'images/create_pdf.png" border="0" />&nbsp;'.getLL("res_list_footer_pdf_label").'</span>';
	$button_code .= '<span name="res_pdf_link" id="res_pdf_link">&nbsp;</span>';
	$list_footer[] = array("label" => "", "button" => $button_code);
	$smarty->assign("show_list_footer", TRUE);
	$smarty->assign("list_footer", $list_footer);

	$smarty->assign("tpl_day", $day);
	if($output) {
	  $smarty->display('ko_cal_jahr.tpl');
	} else {
	  print $smarty->fetch('ko_cal_jahr.tpl');
	}
}//ko_res_cal_jahr()





//Type ist entweder "res" fr eine Liste der normalen Reservationen
// oder "mod" fr eine Liste der zu moderierenden Reservationen
function ko_show_res_liste($type="res", $output=TRUE) {
	global $smarty, $DATETIME;
	global $access;
		
	if($access['reservation']['MAX'] < 1) return;

	//Set SQL filter for res and mod
	if($type=='res') {
		apply_res_filter($z_where, $z_limit);
	}
	else if($type=='mod') {
		if($_SESSION['ses_userid'] != ko_get_guest_id()) {
			$all_rights = ko_get_access_all('res_admin', '', $max_rights);
			if($all_rights == 4) {  //Moderator for all groups
				$z_where = ' AND 1=1 ';
			} else if($max_rights == 4) {  //Moderator for only a few groups/items
				$mod_items = array();
				foreach($access['reservation'] as $k => $v) {
					if(!intval($k) || $v < 4) continue;
					$mod_items[] = $k;
				}
				$z_where = " AND `user_id` = '".$_SESSION['ses_userid']."' OR `item_id` IN ('".implode("','", $mod_items)."') ";
			} else if($max_rights >= 1) {  //No moderator but new rights, so show his own moderations
				$z_where = ' AND user_id = \''.$_SESSION['ses_userid'].'\' ';
			} else {  //No right to create new reservations, so don't show anything
				$z_where = ' AND 1=2 ';
			}
		} else {
			$z_where = ' AND 1=2 ';
		}
	}

	//Personen-Daten anzeigen oder nicht
	$show_persondata = ($_SESSION["ses_userid"] != ko_get_guest_id() || ko_get_setting("res_show_persondata"));

	$rows = db_get_count( (($type=="res")?"ko_reservation":"ko_reservation_mod"), "id", $z_where);
	unset($es);
	ko_get_reservationen($es, $z_where, $z_limit, $type);

	//Statistik ber Suchergebnisse und Anzeige
  $stats_end = ($_SESSION["show_limit"]+$_SESSION["show_start"]-1 > $rows) ? $rows : ($_SESSION["show_limit"]+$_SESSION["show_start"]-1);
  $smarty->assign('tpl_stats', $_SESSION["show_start"]." - ".$stats_end." ".getLL("list_oftotal")." ".$rows);

	//Links fr Prev und Next-Page vorbereiten
	if($_SESSION["show_start"] > 1) {
		$smarty->assign("tpl_prevlink_link", "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_start,sesid', 'setstart,".(($_SESSION["show_start"]-$_SESSION["show_limit"] < 1) ? 1 : ($_SESSION["show_start"]-$_SESSION["show_limit"])).",".session_id()."', do_element);");
	} else {
    $smarty->assign('tpl_prevlink_link', '');
  }
  if(($_SESSION["show_start"]+$_SESSION["show_limit"]-1) < $rows) {
		$smarty->assign("tpl_nextlink_link", "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_start,sesid', 'setstart,".($_SESSION["show_limit"]+$_SESSION["show_start"]).",".session_id()."', do_element);");
  } else {
    $smarty->assign('tpl_nextlink_link', '');
  }


	//Header-Daten
	if($show_persondata) {
		$num_cols = 5;
		$show_cols = array(getLL("res_object"), getLL("res_date"), getLL("res_time"), getLL("res_zweck"), getLL("res_who"));
		$show_sort = array("item_id", "startdatum", "startzeit", "zweck", "name");
	} else {
		$num_cols = 4;
		$show_cols = array(getLL("res_object"), getLL("res_date"), getLL("res_time"), getLL("res_zweck"));
		$show_sort = array("item_id", "startdatum", "startzeit", "zweck");
	}
	for($i=0; $i<$num_cols;$i++) {
		$tpl_table_header[$i]["sort"] = $show_sort[$i];
		$tpl_table_header[$i]["name"] = $show_cols[$i];
  }
  $smarty->assign("tpl_table_header", $tpl_table_header);
	$smarty->assign("tpl_show_3cols", TRUE);
  $smarty->assign("sort", array("show" => TRUE,
																"action" => "setsortres",
																"akt" => $_SESSION["sort_item"],
																"akt_order" => $_SESSION["sort_item_order"])
	);
	$smarty->assign("module", "reservation");
	$smarty->assign("sesid", session_id());


	//Multiedit-Spalten definieren
	if(($type == 'res' && $access['reservation']['MAX'] > 2) || ($type == 'mod' && $access['reservation']['MAX'] > 3)) {
		$smarty->assign("tpl_show_editrow", TRUE);
		if($show_persondata) {
			$edit_columns = array("item_id", "startdatum,enddatum", "startzeit,endzeit", "zweck,comments", "name,email,telefon");
		} else {
			$edit_columns = array("item_id", "startdatum,enddatum", "startzeit,endzeit", "zweck,comments");
		}
		$smarty->assign("tpl_edit_columns", $edit_columns);
	} else {
		$smarty->assign("tpl_show_editrow", FALSE);
	}


	$guest_id = ko_get_guest_id();
	if(is_array($es)) {
		foreach($es as $e_i => $e) {

			if($type=="mod") {
				//Auf Doppelbelegung testen:
				if(!ko_res_check_double($e["item_id"], $e["startdatum"], $e["enddatum"], $e["startzeit"], $e["endzeit"], $error_txt)) {
					$double = TRUE;
					$double_error = $error_txt;
				} else {
					$double = FALSE;
				}
			}

			//Checkbox
			$tpl_list_data[$e_i]["show_checkbox"] = TRUE;

			//Fr Reservationen Edit- und Delete-Button ausgeben
			if($type=="res") {
				//Edit-Button
				if($access['reservation'][$e['item_id']] > 1) {  //Bearbeiten darf man seine eigenen immer, sprich wenn man den Code hat
					$tpl_list_data[$e_i]["show_edit_button"] = TRUE;
					$tpl_list_data[$e_i]["alt_edit"] = getLL("res_edit_res");

					//Andere darf man bearbeiten, wenn man das Recht dazu hat oder
					//Wenn einem die Reservation gehrt (ausser, wenn die Res dem ko_guest gehrt, denn das sind viele physische Leute!)
					if($access['reservation'][$e['item_id']] > 2 || ($_SESSION["ses_userid"] == $e["user_id"] && $_SESSION["ses_userid"] != $guest_id) ) {
						//Auf dieser Stufe darf man auch Reservationen anderer (also ohne Code) bearbeiten
						$tpl_list_data[$e_i]["onclick_edit"] = "javascript:set_action('edit_res');set_hidden_value('id', '$e_i');this.submit";
					} else {
						$tpl_list_data[$e_i]["onclick_edit"] = "javascript: p = prompt('".getLL("res_edit_code_text")."', '');if(!p) return false;set_hidden_value('res_code', p);set_hidden_value('id', '$e_i');set_action('check_edit_code');this.submit";
					}
				}

				//Delete-Button
				if($access['reservation'][$e['item_id']] > 1) {  //Lschen darf man seine eigenen immer, sprich wenn man den Code hat
					$tpl_list_data[$e_i]["show_delete_button"] = TRUE;
					$tpl_list_data[$e_i]["alt_delete"] = getLL("res_delete_res");
					if($access['reservation'][$e['item_id']] > 2 || ($_SESSION["ses_userid"] == $e["user_id"] && $_SESSION["ses_userid"] != $guest_id) ) {
						//Auf dieser Stufe drfen auch Reservationen anderer gelscht werden (also ohne Code).
						$del_link  = "javascript:c = confirm('".getLL("res_delete_res_confirm")."');if(!c) return false;";
						if($e["serie_id"]) $del_link .= "c2 = confirm('".getLL("res_delete_serie_confirm")."');set_hidden_value('mod_confirm', c2);";
						$del_link .= "set_action('delete_res');set_hidden_value('id', '$e_i');";
						$tpl_list_data[$e_i]["onclick_delete"] = $del_link;
					} else {
						$tpl_list_data[$e_i]["onclick_delete"] = "javascript:p = prompt('".getLL("res_edit_code_text")."', '');if(!p) return false;set_hidden_value('res_code', p);set_hidden_value('id', '$e_i');set_action('check_del_code');this.submit";
					}
				}

				//Mark sundays
				if(ko_get_setting("res_mark_sunday") && strftime("%w", strtotime($e["startdatum"])) == 0) {
					$tpl_list_data[$e_i]["rowclass"] = "ko_list_sunday";
				} else {
					$tpl_list_data[$e_i]["rowclass"] = "";
				}


			} elseif($type=="mod") { //Fr Mod-Liste einen Besttigungs- und einen Delete-Button ausgeben
				//Check-Button
				if($access['reservation'][$e['item_id']] > 3 && !$double) {  //Bei Doppelbelegung kein Check-Button anzeigen
					$tpl_list_data[$e_i]["show_check_button"] = TRUE;
					$tpl_list_data[$e_i]["alt_edit"] = getLL("res_mod_confirm");
					$tpl_list_data[$e_i]["onclick_edit"] = "javascript:c1 = confirm('".getLL("res_mod_confirm_confirm")."');if(!c1) return false;c = confirm('".getLL("res_mod_confirm_confirm2")."');set_hidden_value('mod_confirm', c);set_action('res_mod_approve');set_hidden_value('id', '$e_i');this.submit";
				}

				//Delete-Button
				if($access['reservation'][$e['item_id']] > 3 || ($_SESSION["ses_userid"] != ko_get_guest_id() && $e["user_id"] == $_SESSION["ses_userid"])) {
					$tpl_list_data[$e_i]["show_delete_button"] = TRUE;
					$tpl_list_data[$e_i]["alt_delete"] = getLL("res_mod_decline");
					$tpl_list_data[$e_i]["onclick_delete"] = "javascript:c1 = confirm('".getLL("res_mod_decline_confirm")."');if(!c1) return false;";
					if($access['reservation'][$e['item_id']] > 3) $tpl_list_data[$e_i]["onclick_delete"] .= "c = confirm('".getLL("res_mod_decline_confirm2")."');set_hidden_value('mod_confirm', c);";
					$tpl_list_data[$e_i]["onclick_delete"] .= "set_action('res_mod_delete');set_hidden_value('id', '$e_i');";
				}

			}//if(type==res)..elseif(type==mod)


			//Index
	    $tpl_list_data[$e_i]["id"] = $e_i;


			//Objekt
			if(!$double) {  //Falls keine Doppelbelegung vorliegt
				$tpl_list_data[$e_i][0] = ko_html($e["item_name"]);
			} else {  //Bei Doppelbelegung Meldung anzeigen
				$tpl_list_data[$e_i][0]  = '<a href="#" onmouseover="tooltip.show(\'&lt;b&gt;'.getLL("res_collision_text").'&lt;/b&gt;&lt;br /&gt;&lt;br /&gt;';
				$tpl_list_data[$e_i][0] .= ko_html2($double_error).'\')" OnMouseOut="tooltip.hide()">';
				$tpl_list_data[$e_i][0] .= "<b> ! ".ko_html($e["item_name"])." ! </b></a>";;
			}


			//Datum
			if($e["startdatum"] != $e["enddatum"]) {
				$datum = strftime($DATETIME["ddmy"], strtotime($e["startdatum"])) . "-" . strftime($DATETIME["ddmy"], strtotime($e["enddatum"]));
			} else {
				$datum = strftime($DATETIME["ddmy"], strtotime($e["startdatum"]));
			}
			$tpl_list_data[$e_i][1] = $datum;


			//Zeit
			if($e["startzeit"] == "00:00:00") {
				$zeit = getLL("time_all_day");
			} else if($e["endzeit"] != "" && $e["endzeit"] != "00:00:00") {
				$zeit = substr($e["startzeit"], 0, -3) . " - " . substr($e["endzeit"], 0, -3);
			} else {
				$zeit = substr($e["startzeit"], 0, -3);
			}
			$tpl_list_data[$e_i][2] = $zeit;


			//Zweck
			if($e["comments"]) {
				$tpl_list_data[$e_i][3] = "<a href=\"#\" onmouseover=\"return tooltip.show('&lt;b&gt;".getLL("kota_ko_reservation_comments")."&lt;/b&gt;: ".preg_replace("/(\r\n)+|(\n|\r)+/", "<br />", ko_html($e["comments"]))."');\" onmouseout=\"return tooltip.hide();\">".ko_html($e["zweck"])."</a>";
			} else {
				$tpl_list_data[$e_i][3] = ko_html($e["zweck"]);
			}



			//Wer
			if($show_persondata) {
				if($e["telefon"] || $e["email"]) {
					$tpl_list_data[$e_i][4] = "<a href=\"#\" onmouseover=\"return tooltip.show('".format_email(ko_html2($e["email"]))."&lt;br /&gt;".ko_html2($e["telefon"])."');\" onmouseout=\"return tooltip.hide();\">".ko_html($e["name"])."</a>";
				} else {
					$tpl_list_data[$e_i][4] = ko_html($e["name"]);
				}
			}


		}//foreach(es)
	}//if..else(is_array(es))

	if($show_persondata) {
		$smarty->assign('tpl_list_cols', array(0, 1, 2, 3, 4));
	} else {
		$smarty->assign('tpl_list_cols', array(0, 1, 2, 3));
	}

	//Footer
	if($type == 'res' && $access['reservation']['MAX'] > 2) {
		$list_footer[] = array("label" => getLL("res_list_footer_del_label"),
													 "button" => '<input type="submit" onclick="c=confirm('."'".getLL("res_list_footer_del_button_confirm")."'".');if(!c) return false;set_action(\'del_selected\');" value="'.getLL("res_list_footer_del_button").'" />');
		$smarty->assign("show_list_footer", TRUE);
		$smarty->assign("list_footer", $list_footer);
	}
	else if($type == "mod") {
		if($access['reservation']['MAX'] > 1) {
			$list_footer[] = array("label" => getLL("res_list_footer_del_label"),
														 "button" => '<input type="submit" onclick="c1 = confirm(\''.getLL("res_mod_decline_confirm").'\');if(!c1) return false;'.($access['reservation']['MAX'] > 3 ? 'c = confirm(\''.getLL("res_mod_decline_confirm2").'\');set_hidden_value(\'mod_confirm\', c);' : '').'set_action(\'res_mod_delete_multi\');" value="'.getLL("res_list_footer_del_button").'" />');
		}
		if($access['reservation']['MAX'] > 3) {
			$list_footer[] = array("label" => getLL("res_list_footer_confirm_label"),
														 "button" => '<input type="submit" onclick="c=confirm('."'".getLL("res_mod_confirm_confirm2")."'".');set_hidden_value(\'mod_confirm\', c);set_action(\'res_mod_approve_multi\');" value="'.getLL("ok").'" />');
		}
		$smarty->assign("show_list_footer", TRUE);
		$smarty->assign("list_footer", $list_footer);
	}

	if($type == "mod") {
		$smarty->assign("help", ko_get_help("reservation", "show_mod_res"));
		$smarty->assign('tpl_list_title', getLL("res_mod_list_title"));
	} else {
		$smarty->assign('tpl_list_title', getLL("res_list_title"));
	}

	$smarty->assign('tpl_list_data', $tpl_list_data);
	if($output) {
		$smarty->display('ko_list.tpl');
	} else {
		print $smarty->fetch('ko_list.tpl');
	}
}//ko_show_res_liste()




function ko_show_items_liste($output=TRUE) {
	global $smarty;
	global $access;
		
	if($access['reservation']['MAX'] < 4) return;

	$rows = db_get_count("ko_resitem");
	$z_limit = "LIMIT " . ($_SESSION["show_start"]-1) . ", " . $_SESSION["show_limit"];
	ko_get_resitems($res, $z_limit);

	//Sortierung auslesen und Links entsprechend setzen
	$smarty->assign("tpl_show_3cols", TRUE);
	$show_daten_cols = array(getLL("res_listheader_name"), getLL("res_listheader_group"), getLL("res_listheader_description"), getLL("res_listheader_moderation"));
	$daten_sort_cols = array("name", "gruppen_id", "beschreibung", "moderation");
	foreach($show_daten_cols as $c_i => $c) {
		$tpl_table_header[$c_i]["sort"] = $daten_sort_cols[$c_i];
		$tpl_table_header[$c_i]["name"] = $show_daten_cols[$c_i];
	}
	$smarty->assign("tpl_table_header", $tpl_table_header);
	$smarty->assign("sort", array("show" => TRUE,
																"action" => "setsortresgroups",
																"akt" => $_SESSION["sort_group"],
																"akt_order" => $_SESSION["sort_group_order"])
	);
	$smarty->assign("module", "reservation");
	$smarty->assign("sesid", session_id());


	//Multiedit-Spalten definieren
	$smarty->assign("tpl_show_editrow", TRUE);
	$edit_columns = $daten_sort_cols;
	$smarty->assign("tpl_edit_columns", $edit_columns);

	//Array mit Daten fr Smarty aufbauen
  foreach($res as $e_i => $e) {
 		//Checkbox
  	$tpl_list_data[$e_i]["show_checkbox"] = TRUE;

		//Edit-Button
		if($access['reservation'][$e_i] > 3) {
    	$tpl_list_data[$e_i]["show_edit_button"] = TRUE;
    	$tpl_list_data[$e_i]["alt_edit"] = getLL("res_edit_object");
    	$tpl_list_data[$e_i]["onclick_edit"] = "javascript:set_action('edit_item');set_hidden_value('id', '$e_i');this.submit";
  	} else {
    	$tpl_list_data[$e_i]["show_edit_button"] = FALSE;
		}
							    
		//Delete-Button
    if($access['reservation'][$e_i]) {
 	  	$tpl_list_data[$e_i]["show_delete_button"] = TRUE;
      $tpl_list_data[$e_i]["alt_delete"] = getLL("res_delete_object");
      $tpl_list_data[$e_i]["onclick_delete"] = "javascript:c = confirm('".getLL("res_delete_object_confirm")."');if(!c) return false;set_action('delete_item');set_hidden_value('id', '$e_i');";
    } else {
      $tpl_list_data[$e_i]["show_delete_button"] = FALSE;
    }
									    
		//Index
    $tpl_list_data[$e_i]["id"] = $e_i;

		//Name
		$tpl_list_data[$e_i]["1"] = $e["name"];
		if($e["linked_items"]) {
			$tpl_list_data[$e_i]["1"] .= " (+".sizeof(explode(",", $e["linked_items"])).")";
		}

		//Gruppe
		$tpl_list_data[$e_i]["2"] = $e["gruppen_name"];

		//Beschreibung
		$tpl_list_data[$e_i]["3"] = str_replace("<br />", "\n", $e["beschreibung"]);

		//Moderation
		switch($e["moderation"]) {
			case 0: $txt_moderation = getLL("res_mod_no"); break;
			case 1: $txt_moderation = getLL("res_mod_yes"); break;
			case 2: $txt_moderation = getLL("res_mod_yes_mail"); break;
		}
		$tpl_list_data[$e_i]["4"] = $txt_moderation;

	}//foreach(res as e_i => e)

	//Statistik ber Suchergebnisse und Anzeige
  $stats_end = ($_SESSION["show_limit"]+$_SESSION["show_start"]-1 > $rows) ? $rows : ($_SESSION["show_limit"]+$_SESSION["show_start"]-1);
  $smarty->assign('tpl_stats', $_SESSION["show_start"]." - ".$stats_end." ".getLL("list_oftotal")." ".$rows);

	//Links fr Prev und Next-Page vorbereiten
  if($_SESSION["show_start"] > 1) {
		$smarty->assign("tpl_prevlink_link", "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_start,sesid', 'setstart,".(($_SESSION["show_start"]-$_SESSION["show_limit"] < 1) ? 1 : ($_SESSION["show_start"]-$_SESSION["show_limit"])).",".session_id()."', do_element);");
  } else {
    $smarty->assign('tpl_prevlink_link', '');
  }
  if(($_SESSION["show_start"]+$_SESSION["show_limit"]-1) < $rows) {
		$smarty->assign("tpl_nextlink_link", "javascript:sendReq('../reservation/inc/ajax.php', 'action,set_start,sesid', 'setstart,".($_SESSION["show_limit"]+$_SESSION["show_start"]).",".session_id()."', do_element);");
  } else {
    $smarty->assign('tpl_nextlink_link', '');
	}

	$smarty->assign('tpl_list_title', getLL("res_items_list_title"));
	$smarty->assign('tpl_list_cols', array(1, 2, 3, 4));
  $smarty->assign('tpl_list_data', $tpl_list_data);
	if($output) {
	  $smarty->display('ko_list.tpl');
	} else {
	  print $smarty->fetch('ko_list.tpl');
	}
}//ko_show_items_liste()





/**
  * Erstellt das Formular zum Bearbeiten und Hinzufgen von Reservationen
	*/
function ko_formular_reservation($mode, $id, $data=array()) {
	global $smarty, $KOTA;
	global $access;

	//Falls eine Reservation editiert werden soll, diese auslesen und die Felder mit seinen Details fllen
	if($mode=="edit" && $id != 0) {
		if($access['reservation']['MAX'] < 2) return;

	  ko_get_res_by_id($id, $r_);
	  $r = $r_[$id];

		//Info ber Reservation fr Moderator
		if($access['reservation']['MAX'] > 3) {
			ko_get_login($r["user_id"], $res_login);
			$res_info  = getLL("res_info_cdate").": ".sqldatetime2datum($r["cdate"]);
			$res_info .= ", ".getLL("res_info_mdate").": ".sqldatetime2datum($r["last_change"]);
			$res_info .= ", ".getLL("res_info_user").": ".$res_login["login"]." (".$r["user_id"].")";
			$res_info .= ", ".getLL("res_info_code").": ".$r["code"];
		}
	}//if(mode==edit && id)
	//Falls eine Reservation an einem bestimmten Tag gemacht werden soll, dann das Datum schon vorgeben.
	else if($mode == "neu") {
		if($access['reservation']['MAX'] < 2) return;

		//fill in values if POST-Values are set
		if($_POST["submit"]) {
			$form_values = NULL;
			foreach($_POST["koi"]["ko_reservation"] as $col => $value) {
				if(isset($KOTA["ko_reservation"][$col])) {
					$form_values[$col] = $value[0];
				}
			}
			kota_assign_values("ko_reservation", $form_values);

		//Or else use Data of logged in user
		} else {
			$p = ko_get_logged_in_person();
			if($p['id'] || $p['email']) {
				kota_assign_values('ko_reservation', array('name' => $p['vorname'].' '.$p['nachname'], 'email' => $p['email'], 'telefon' => ($p['telg']?$p['telg']:$p['telp'])));
			}
		}

		//given as argument in Funktion (by GET-Values)
		if(isset($data["start_time"])) kota_assign_values("ko_reservation", array("startzeit" => $data["start_time"]));
		if(isset($data["end_time"])) kota_assign_values("ko_reservation", array("endzeit" => $data["end_time"]));
	}
	else return;

	//Wiederholungs-Auswahl wieder setzen
	$true = 0;
	switch($_POST["rd_wiederholung"]) {
		case "keine": $true = 0; break;
		case "taeglich": $true = 1; break;
		case "woechentlich": $true = 2; break;
		case "monatlich1": $true = 3; break;
		case "monatlich2": $true = 4; break;
		default: $true = 0;
	}
	for($i=0; $i<5; $i++) {
		$rd_wiederholung_checked[$i] = ($true == $i) ? 'checked="checked"' : "";
	}
	$smarty->assign("rd_wiederholung_checked", $rd_wiederholung_checked);
	$txt_repeat_tag = $_POST["txt_repeat_tag"] ? format_userinput($_POST["txt_repeat_tag"], "uint") : 1;
	$txt_repeat_woche = $_POST["txt_repeat_woche"] ? format_userinput($_POST["txt_repeat_woche"], "uint") : 1;
	$txt_repeat_monat2 = $_POST["txt_repeat_monat2"] ? format_userinput($_POST["txt_repeat_monat2"], "uint") : 1;


	//Select-Inputs fr Wiederholungen abfllen (Auswahl vom letzten Mal wieder setzen
	$values = array(1, 2, 3, 4);
	$output = array("1.", "2.", "3.", "4.");
	$value = format_userinput($_POST["sel_monat1_nr"], "uint", FALSE, 1);
	$sel1_code = "";
	foreach($values as $i => $v) {
		$sel = ($value == $v) ? ' selected="selected"' : '';
		$sel1_code .= '<option value="'.$v.'"'.$sel.'>'.$output[$i].'</option>';
	}

	$values = array(1, 2, 3, 4, 5, 6, 0);
	$output = NULL; $monday = date_find_last_monday(date("Y-m-d"));
	for($i=0; $i<7; $i++) $output[] = strftime("%A", strtotime(add2date($monday, "tag", $i, TRUE)));
	$value = format_userinput($_POST["sel_monat1_tag"], "uint", FALSE, 1);
	$sel2_code = "";
	foreach($values as $i => $v) {
		$sel = ($value == $v) ? ' selected="selected"' : '';
		$sel2_code .= '<option value="'.$v.'"'.$sel.'>'.$output[$i].'</option>';
	}

	$repeat_descs[] = getLL("daten_repeat_none");
	$repeat_descs[] = sprintf(getLL("daten_repeat_daily"), ' </label><input type="text" name="txt_repeat_tag" value="'.$txt_repeat_tag.'" size="2" /> ', '<label>');
	$repeat_descs[] = sprintf(getLL("daten_repeat_weekly"), ' </label><input type="text" name="txt_repeat_woche" value="'.$txt_repeat_woche.'" size="2" /> ', '<label>');
	$repeat_descs[] = sprintf(getLL("daten_repeat_monthly1"), ' </label><select name="sel_monat1_nr" size="0">'.$sel1_code.'</select><select name="sel_monat1_tag" size="0">'.$sel2_code.'</select></label>');
	$repeat_descs[] = sprintf(getLL("daten_repeat_monthly2"), ' </label><input type="text" name="txt_repeat_monat2" value="'.$txt_repeat_monat2.'" size="2" /> ', '<label>');


	//Repeat-Stop
	$values = array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31);
	$output = $values;
	$value = $_POST["sel_bis_tag"] ? format_userinput($_POST["sel_bis_tag"], "uint", FALSE, 2) : 31;
	$sel_day_code = "";
	foreach($values as $i => $v) {
		$sel = ($value == $v) ? ' selected="selected"' : '';
		$sel_day_code .= '<option value="'.$v.'"'.$sel.'>'.$output[$i].'</option>';
	}

	$values = array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
	$jan = date("Y-m-d", mktime(1,1,1, 1, 1, 2006));
	$output = NULL; for($i=0; $i<12; $i++) $output[] = strftime("%B", strtotime(add2date($jan, "monat", $i, TRUE)));
	$value = $_POST["sel_bis_monat"] ? format_userinput($_POST["sel_bis_monat"], "uint", FALSE, 2) : strftime("%m", time());
	$sel_month_code = "";
	foreach($values as $i => $v) {
		$sel = ($value == $v) ? ' selected="selected"' : '';
		$sel_month_code .= '<option value="'.$v.'"'.$sel.'>'.$output[$i].'</option>';
	}

	$values = array((int)strftime("%Y", time()), (int)strftime("%Y", time())+1, (int)strftime("%Y", time())+2);
	$value = $_POST["sel_bis_jahr"] ? format_userinput($_POST["sel_bis_jahr"], "uint", FALSE, 4) : strftime("%Y", time());
	$sel_year_code = "";
	foreach($values as $v) {
		$sel = ($value == $v) ? ' selected="selected"' : '';
		$sel_year_code .= '<option value="'.$v.'"'.$sel.'>'.$v.'</option>';
	}

	$repeat_stop  = '<select name="sel_bis_tag" size="0">'.$sel_day_code.'</select>&nbsp;&nbsp;';
	$repeat_stop .= '<select name="sel_bis_monat" size="0">'.$sel_month_code.'</select>&nbsp;&nbsp;';
	$repeat_stop .= '<select name="sel_bis_jahr" size="0">'.$sel_year_code.'</select>';
	$repeat_stop .= '<br />'.getLL("daten_repeat_or").'<br /><input type="text" name="txt_num_repeats" size="4" maxlength="3" onkeyup="repeat_disable(this.value);" />&nbsp;'.getLL("daten_repeat_iterations");



	//Formular aufbauen
	$mandatory = explode(",", ko_get_setting("res_mandatory"));
	$gc = 0;

	//add mandatory-flags
	foreach($KOTA["ko_reservation"] as $key => $kota_field) {
		if(in_array($key, $mandatory)) $KOTA["ko_reservation"][$key]["form"]["desc"] = getLL("kota_ko_reservation_".$key)." *";
	}

	//allow multiple objects to be reserved at once
	if($mode == "neu" && ($_SESSION["ses_userid"] != ko_get_guest_id() || ko_get_setting("res_allow_multires_for_guest")) ) {
		$KOTA["ko_reservation"]["item_id"]["form"]["type"] = "dyndoubleselect";
		$KOTA["ko_reservation"]["item_id"]["form"]["js_func_add"] = "resgroup_doubleselect_add";
	}
	$KOTA["ko_reservation"]["item_id"]["form"]["params"] = 'size="5" onchange="javascript:changeResItem(this.value);"';

	//get first part of form from kota
	$group = ko_multiedit_formular("ko_reservation", "", $id, "", "", TRUE);
	$group[$gc]["titel"] = "";
	$rowcounter = sizeof($group[$gc]["row"])+1;
	

	//Wiederholungen (nur bei Neu)
	if($mode == "neu") {
		$group[++$gc] = array("titel" => getLL("daten_repeat"), "state" => "closed", "colspan" => 'colspan="2"');
		$group[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("daten_repeat_title1"),
																 "type" => "radio",
																 "name" => "rd_wiederholung",
																 "values" => array("keine", "taeglich", "woechentlich", "monatlich1", "monatlich2"),
																 "descs" => $repeat_descs,
																 "separator" => "<br />",
																 "value" => isset($_POST["rd_wiederholung"]) ? $_POST["rd_wiederholung"] : "keine"
																 );
		$group[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("daten_repeat_title2"),
																 "type" => "html",
																 "value" => $repeat_stop
																 );
	}
	if($mode == "edit" && $r["serie_id"]) {
		$group[$gc]["row"][$rowcounter++]["inputs"][0] = array("type" => "   ");
		$group[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("res_serie_title"),
																 "type" => "checkbox",
																 "name" => "chk_serie",
																 "value" => "1",
																 "desc2" => getLL("res_serie_apply")." (".db_get_count("ko_reservation", "id", "AND `serie_id` = '".$r["serie_id"]."'").")",
																 "colspan" => 'colspan="2"',
																 );
	}
	if($access['reservation']['MAX'] > 3 && $mode == "edit") {
		$group[$gc]["row"][$rowcounter++]["inputs"][0] = array("type" => "   ");
		$group[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("res_info_title"),
																 "type" => "html",
																 "value" => $res_info,
																 "colspan" => 'colspan="2"',
																 );
	}




	$smarty->assign("tpl_titel", ( ($mode == "neu") ? getLL("res_new_res") : getLL("res_edit_res")) );
  $smarty->assign("tpl_submit_value", getLL("save"));
  $smarty->assign("tpl_id", $id);
  $smarty->assign("tpl_action", ( ($mode == "neu") ? "submit_neue_reservation" : "submit_edit_reservation") );
	//Add button "save as new"
	if($mode == 'edit') {
		$smarty->assign("tpl_submit_as_new", getLL('res_submit_as_new'));
		$smarty->assign("tpl_action_as_new", "submit_neue_reservation");
	}
	$cancel = $_SESSION['show_back'] ? $_SESSION['show_back'] : ko_get_userpref($_SESSION["ses_userid"], "default_view_reservation");
	if(!$cancel) $cancel = "show_cal_monat";
  $smarty->assign("tpl_cancel", $cancel);
  $smarty->assign("tpl_groups", $group);

	$smarty->assign("help", ko_get_help("reservation", "neue_reservation"));

	$smarty->display("ko_formular.tpl");
}//ko_formular_reservation()




/**
  * Erstellt das Formular zum Bearbeiten und Hinzufgen von Reservations-Items
	*/
function ko_formular_item($mode, $id) {
	global $smarty;
	global $KOTA;
	global $access;

	if($mode == "edit") {
		if($access['reservation']['MAX'] < 4) return;
	} else if($mode == "neu") {
		if($access['reservation']['MAX'] < 4) return;
		$id = 0;
	} else return;

	//Select for linked items
	$where = "AND `linked_items` = '' ";  //no hierarchical linking
	if($mode == "edit") $where .= " AND `id` <> '$id'";  //no linking to itself
	kota_ko_reservation_item_id_dynselect($values, $descs, 1);
	$KOTA["ko_resitem"]["linked_items"]["form"]["values"] = $values;
	$KOTA["ko_resitem"]["linked_items"]["form"]["descs"] = $descs;

	//Only show text input for adding res group if ALL edit rights (level 3) is set
	if(ko_get_access_all("res_admin") < 3) {
		//no textplus, so no new group can be added
		$KOTA["ko_resitem"]["gruppen_id"]["form"]["type"] = "select";
		$KOTA["ko_resitem"]["gruppen_id"]["form"]["params"] = 'size="0"';
		$KOTA["ko_resitem"]["gruppen_id"]["form"]["new_line"] = TRUE;
	}


	$form_data["title"] = $mode == "neu" ? getLL("res_new_object") : getLL("res_edit_object");
  $form_data["submit_value"] = getLL("save");
  $form_data["action"] = $mode == "neu" ? "submit_new_item" : "submit_edit_item";
  $form_data["cancel"] = "list_items";

	ko_multiedit_formular("ko_resitem", "", $id, "", $form_data);
}//ko_formular_item()




/**
  * Stores a new reservation to be moderated
	*/
function ko_res_store_moderation($data) {
	$mod_txt = array();
	$items = db_select_data("ko_resitem", "WHERE 1=1", "*");

	foreach($data as $res) {
		$resitem = $items[$res["item_id"]];
		//add other data
		$res["code"] = substr(md5($res["name"].microtime()), 2, 8);
		$res["cdate"] = strftime("%Y-%m-%d %H:%M:%S", time());
		$res["last_change"] = strftime("%Y-%m-%d %H:%M:%S", time());
		$res["linked_items"] = $resitem["linked_items"];
		if(!$res["user_id"]) $res["user_id"] = $_SESSION["ses_userid"];

		//Store moderation
		db_insert_data("ko_reservation_mod", $res);

		//Prepare email text for moderators
		if($resitem["moderation"] == 2) {
			$txt = ko_get_res_infotext($res);
			$mod_txt[$resitem["gruppen_id"]] .= $txt."\n\n";
		}
	}//foreach(data as res)


	//Send mails
	$headers = array("From" => ko_get_setting("info_email"));

	//Inform all moderators for the different resgroups
	foreach($mod_txt as $gid => $txt) {
		if(!$txt || !$gid) continue;
		$mailtext = str_replace("[RES]", "\n\n".$txt, getLL("res_email_mod_text"));
		$mods = ko_get_moderators_by_resgroup($gid);
		foreach($mods as $mod) {
			ko_send_email($mod["email"], "[kOOL] ".getLL("res_email_mod_subject"), ko_emailtext($mailtext), $headers);
		}
	}
}//ko_res_store_moderation()




/**
  * Stores a new reservation and send all necessary mails
	*/
function ko_res_store_reservation($data, $send_user_email) {
	global $access;

	$ids = array();  //Will hold the ids of the new reservations
	$res_txt = "";
	$user_email = "";
	$res3_txt = array();
	$items = db_select_data("ko_resitem", "WHERE 1=1", "*");

	foreach($data as $res) {
		$resitem = $items[$res["item_id"]];
		//add other data
		if(!$res["code"]) $res["code"] = substr(md5($res["name"].microtime()), 2, 8);
		$res["last_change"] = strftime("%Y-%m-%d %H:%M:%S", time());
		$res["linked_items"] = $resitem["linked_items"];
		if(!$res["cdate"]) $res["cdate"] = strftime("%Y-%m-%d %H:%M:%S", time());
		if(!$res["user_id"]) $res["user_id"] = $_SESSION["ses_userid"];
		$do_event = $res["_event_id"]; unset($res["_event_id"]);

		$new_id = db_insert_data("ko_reservation", $res);
		$txt = ko_get_res_infotext($res);
		$res_txt .= $txt."\n\n";
		//Level 3 user making a reservation for a moderated item
		if($resitem["moderation"] > 0 && $access['reservation'][$res['item_id']] == 3) {
			$res3_txt[$resitem["gruppen_id"]] .= $txt."\n\n";
		}

		//Store user's email address
		if($send_user_email && !$user_email && $res["email"]) $user_email = $res["email"];

		//Update event, this reservation belongs to
		if($do_event) {
			$event = db_select_data("ko_event", "WHERE `id` = '$do_event'", "*", "", "", TRUE);
			$new_reservationen = $event["reservationen"] ? ($event["reservationen"].",$new_id") : $new_id;
			db_update_data("ko_event", "WHERE `id` = '$do_event'", array("reservationen" => $new_reservationen));
		}

		//Log entry
		$log_message = $new_id.": ".$resitem["name"].", ".$res["startdatum"].", ".$res["zweck"].", ".$res["name"];
		ko_log("new_res", $log_message);

		$ids[] = $new_id;
	}//foreach(data as res)


	//Send mails
	$headers = array("From" => ko_get_setting("info_email"));

	//1: Mail to user who did the reservation
	if($send_user_email && $user_email) {
		$mailtext = getLL("res_email_confirm_text")."\n\n".$res_txt;
		ko_send_email($user_email, "[kOOL] ".getLL("res_email_confirm_subject"), $mailtext, $headers);
	}

	//2: Mail for moderator, if user with access level 3 has made a reservation of a moderated object
	if(sizeof($res3_txt) > 0) {
		foreach($res3_txt as $gid => $txt) {
			$mailtext = sprintf(getLL("res_email_mod3_text"), ("\n\n".$txt));
			$mods = ko_get_moderators_by_resgroup($gid);
			foreach($mods as $mod) {
				//Check user_pref for this moderator
				if(ko_get_userpref($mod["id"], "do_mod_email_for_edit_res") == 1) {
					ko_send_email($mod["email"], "[kOOL] ".getLL("res_email_mod3_subject"), $mailtext, $headers);
				}
			}
		}
	}

	//3: Mail to given addresses for each reservation
	if(ko_get_setting("res_send_email")) {
		//mailtext
		$recipients = explode(",", str_replace(";", ",", ko_get_setting("res_send_email")));
		foreach($recipients as $rec) {
			$rec = trim($rec);
			if(!$rec || !check_email($rec)) continue;
			ko_send_email($rec, getLL("res_email_confirm_subject"), getLL("res_email_confirm_text")."\n\n".$res_txt, $headers);
		}//foreach(recipients)
	}//if(ko_get_setting(res_send_email))

	return $ids;
}//ko_res_store_reservation()




/**
  * Displays settings for the reservations
	*/
function ko_res_settings() {
	global $smarty;
	global $access;

	if($access['reservation']['MAX'] < 4) return FALSE;

	$mandatory_values = array("zweck", "name", "email", "telefon");
	$mandatory_descs = array(getLL("res_zweck"), getLL("res_name"), getLL("res_email"), getLL("res_telefon"));
	$mandatory_avalues = explode(",", ko_get_setting("res_mandatory"));
	foreach($mandatory_avalues as $v_i => $v) {
		$mandatory_adescs[$v_i] = getLL("res_".$v);
	}

	//build form
	$gc = 0;
	$rowcounter = 0;
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("res_settings_mandatory"),
		 "type" => "doubleselect",
		 "js_func_add" => "double_select_add",
		 "name" => "sel_mandatory",
		 "values" => $mandatory_values,
		 "descs" => $mandatory_descs,
		 "avalues" => $mandatory_avalues,
		 "avalue" => implode(",", $mandatory_avalues),
		 "adescs" => $mandatory_adescs,
		 "params" => 'size="6"',
		 'colspan' => 'colspan="2"',
		 );
	$value = ko_get_setting("res_pdf_show_time");
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("res_settings_pdf_show_time"),
			"type" => "select",
			"name" => "sel_pdf_show_time",
			'values' => array('2', '1', '0'),
			'descs' => array(getLL('res_settings_pdf_show_time_2'), getLL('res_settings_pdf_show_time_1'), getLL('no')),
			"value" => $value
			);
	$value = ko_get_setting("res_pdf_show_comment");
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("res_settings_pdf_show_comment"),
			"type" => "select",
			"name" => "sel_pdf_show_comment",
			"values" => array("1", "0"),
			"descs" => array(getLL("yes"), getLL("no")),
			"value" => $value
			);
	$value = ko_get_setting('res_pdf_week_start');
	$monday = date_find_last_monday(date('Y-m-d'));
	$daynames[] = strftime('%A', strtotime($monday));
	for($i=1; $i<7; $i++) {
		$daynames[] = strftime('%A', strtotime(add2date($monday, 'tag', $i, TRUE)));
	}
	$frmgroup[$gc]['row'][$rowcounter++]['inputs'][0] = array('desc' => getLL('res_settings_pdf_week_start'),
			'type' => 'select',
			'name' => 'sel_pdf_week_start',
			'values' => array(1,2,3,4,5,6,0),
			'descs' => $daynames,
			'value' => $value,
			);
	$value = ko_get_setting("res_show_persondata");
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("admin_settings_misc_show_resdata"),
			"type" => "select",
			"name" => "sel_res_show_persondata",
			"values" => array("1", "0"),
			"descs" => array(getLL("yes"), getLL("no")),
			"value" => $value
			);
	$value = ko_get_setting("res_allow_multires_for_guest");
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("res_settings_allow_multires_for_guest"),
			"type" => "select",
			"name" => "sel_allow_multires",
			"values" => array("1", "0"),
			"descs" => array(getLL("yes"), getLL("no")),
			"value" => $value,
			);
	$value = ko_get_setting("res_monthly_title");
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("res_settings_monthly_title"),
			"type" => "select",
			"name" => "sel_monthly_title",
			"values" => array("item_id", "zweck", "name"),
			"descs" => array(getLL("kota_ko_reservation_item_id"), getLL("kota_ko_reservation_zweck"), getLL("kota_ko_reservation_name")),
			"value" => $value,
			);
	$value = ko_html(ko_get_setting("res_title_length"));
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("res_settings_title_length"),
			"type" => "text",
			"name" => "txt_title_length",
			"value" => $value,
			"params" => 'size="10"',
			);
	$value = ko_html(ko_get_setting("show_dateres_combined"));
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("admin_settings_options_dateres_combined"),
			"type" => "select",
			"name" => "sel_show_dateres_combined",
			"values" => array("1", "0"),
			"descs" => array(getLL("yes"), getLL("no")),
			"value" => $value
			);
	$value = ko_get_setting("res_mark_sunday");
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("res_settings_mark_sunday"),
			"type" => "select",
			"name" => "sel_mark_sunday",
			"values" => array("1", "0"),
			"descs" => array(getLL("yes"), getLL("no")),
			"value" => $value
			);
	$value = ko_html(ko_get_setting("res_send_email"));
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("res_settings_send_email"),
			"type" => "text",
			"name" => "txt_send_email",
			"value" => $value,
			"params" => 'size="60"',
			);

	//display the form
	$smarty->assign("tpl_titel", getLL("res_settings_form_title"));
	$smarty->assign("tpl_submit_value", getLL("save"));
	$smarty->assign("tpl_action", "submit_res_settings");
	$cancel = ko_get_userpref($_SESSION["ses_userid"], "default_view_reservation");
	if(!$cancel) $cancel = "show_cal_monat";
  $smarty->assign("tpl_cancel", $cancel);
	$smarty->assign("tpl_groups", $frmgroup);

	$smarty->assign("help", ko_get_help("reservation", "res_settings"));

	$smarty->display('ko_formular.tpl');
}//ko_res_settings()




/**
  * berprft auf korrekte Angaben bei der Res-Erfassung
	*/
function check_entries(&$koi) {
	if(!$koi["item_id"]) return 9;

  if(!check_datum($koi["startdatum"])) return 1;
  if($koi["enddatum"] != "" && !check_datum($koi["enddatum"])) return 1;

	//Zeitangaben testen
  if($koi["startzeit"] != "" && !check_zeit($koi["startzeit"])) return 2;  //Eine Zeit wird verlangt
	if($koi["enddatum"] != "" && $koi["enddatum"] != $koi["startdatum"]) {
		if($koi["endzeit"] == "" || !check_zeit($koi["endzeit"])) return 5;
	} else {
	  if($koi["endzeit"] != "" && !check_zeit($koi["endzeit"])) return 2;
		//Bei eintgigem Anlass muss die Endzeit grsser sein als die Startzeit
    $time_s1 = str_replace(":", "", $koi["startzeit"]);
    $time_s2 = str_replace(":", "", $koi["endzeit"]);
    if((trim($koi["enddatum"]) == "" || $koi["startdatum"] == $koi["enddatum"]) && (int)$time_s1 > (int)$time_s2) return 2;
	}

	//check for all the mandatory fields
	foreach(explode(",", ko_get_setting("res_mandatory")) as $man) {
		if($man && !$koi[$man]) return 12;
	}

	return 0;
}//check_entries()




/**
  * berprft auf Doppelbelegungen
	*/
function ko_res_check_double($item, $datum1, $datum2, $zeit1, $zeit2, &$error_txt, $id=0) {
	$datum1 = sql_datum($datum1);
	$datum2 = ($datum2) ? sql_datum($datum2) : $datum1;
	$zeit1  = sql_zeit($zeit1);
	$zeit2  = sql_zeit($zeit2);
	//Reservations without time last all day long, so set endtime to midnight
	if($zeit1 == "" && $zeit2 == "") $zeit2 = "23:59";

	//Mit id Selbsttest ausschliessen
	$where  = "WHERE `id`!='$id'";

	//check for the right item and possibly linked items
	ko_get_resitem_by_id($item, $resitem_);
	$resitem = $resitem_[$item];
	if($resitem["linked_items"] != "") {  //item with linked items
		//check for all linked items in all linked items of the made reservations
		$or = array();
		foreach(explode(",", $resitem["linked_items"]) as $linked_item) {
			$or[] = "`linked_items` REGEXP '(^|,)".$linked_item."($|,)'";
		}
		//and check for item and the linked items
		$check_itemids = $item.",".$resitem["linked_items"];
		$where .= " AND (`item_id` IN ($check_itemids) OR (".implode(" OR ", $or).")) ";
	}
	else {  //no linked items, so only check for item and linked items of made reservations
		$where .= "AND (`item_id`='$item' OR `linked_items` REGEXP '(^|,)$item($|,)') ";
	}

	//check for overlapping date and time
	$where .= " AND (
		( DATE_ADD(`startdatum`, INTERVAL `startzeit` HOUR_SECOND) >= DATE_ADD('$datum1', INTERVAL '$zeit1' HOUR_MINUTE) 
			AND DATE_ADD(`startdatum`, INTERVAL `startzeit` HOUR_SECOND) < DATE_ADD('$datum2', INTERVAL '$zeit2' HOUR_MINUTE) )
		OR ( DATE_ADD(`enddatum`, INTERVAL IF(`endzeit`='00:00:00','23:59:59',`endzeit`) HOUR_SECOND) > DATE_ADD('$datum1', INTERVAL '$zeit1' HOUR_MINUTE) 
			AND DATE_ADD(`enddatum`, INTERVAL IF(`endzeit`='00:00:00','23:59:59',`endzeit`) HOUR_SECOND) <= DATE_ADD('$datum2', INTERVAL '$zeit2' HOUR_MINUTE) )
		OR ( DATE_ADD(`startdatum`, INTERVAL `startzeit` HOUR_SECOND) < DATE_ADD('$datum1', INTERVAL '$zeit1' HOUR_MINUTE) 
				AND DATE_ADD(`enddatum`, INTERVAL IF(`endzeit`='00:00:00','23:59:59',`endzeit`) HOUR_SECOND) > DATE_ADD('$datum2', INTERVAL '$zeit2' HOUR_MINUTE) )
		)";

	$rows = db_select_data("ko_reservation", $where);

	$error_txt = '';
	foreach($rows as $row) {
		$error_txt .= $resitem['name'].' - ';
		$error_txt .= sql2datum($row['startdatum']) . ( ($row['startdatum']==$row['enddatum']) ? '' : ('-' . sql2datum($row['enddatum'])) );
		if($row['startzeit'] == '00:00:00' && $row['endzeit'] == '00:00:00') {
			$error_txt .= ' '.getLL('time_all_day');
		} else {
			$error_txt .= ' '.substr($row['startzeit'],0,-3).'-'.substr($row['endzeit'],0,-3);
		}
		if($row['zweck']) $error_txt .= ' "'.(strlen($row['zweck']) > 30 ? substr($row['zweck'], 0, 30).'..' : $row['zweck']).'"';
		//Only show details about person if setting allows it for guest-user
		if(($_SESSION['ses_userid'] != ko_get_guest_id() || ko_get_setting('res_show_persondata')) && trim($row['name']) != '') {
			$error_txt .= ' '.getLL('by').' '.$row['name'].', '.$row['email'].', '.$row['telefon'];
		}
	}
	return ($error_txt) ? FALSE : TRUE;
}//ko_res_check_double()



/**
  * Liefert eine textliche Zusammenstellung einer Reservation fr die Besttigungs-Emails
	*/
function ko_get_res_infotext($data) {
	$txt = "";
	$list = kota_get_list($data, "ko_reservation");
	foreach($list as $key => $value) {
		if($key == getLL("kota_ko_reservation_enddatum") || $key == getLL("kota_ko_reservation_endzeit")) continue;
		if($value) $txt .= "$key: ".ko_unhtml($value)."\n";
	}
	if($data["code"]) $txt .= getLL("res_code").": ".$data["code"]."\n";

	return $txt;
}//ko_get_res_infotext()



/**
  * Lscht allfllig leere Reservations-Gruppen.
	* Wird nach Lschen und Bearbeiten von Res-Items aufgerufen.
	*/
function ko_delete_empty_resgroups() {
	ko_get_resgroups($res_groups);
	foreach($res_groups as $r_i => $r) {
		ko_get_resitems_by_group($r_i, $resitems);
		if(sizeof($resitems) == 0) {
			db_delete_data("ko_resgruppen", "WHERE `id` = '$r_i'");
		}
	}
}//ko_delete_empty_resgroups()




/**
  * Wendet Res-Filter an und gibt WHERE und LIMIT-String fr SQL zurck
	* Wendet permanente Zeitfilter und Filter fr die darzustellenden Res-Items an.
	*/
function apply_res_filter(&$z_where, &$z_limit, $_start="", $_ende="", $user_id="") {
	global $access;

	$use_start = ($_start != "") ? $_start : $_SESSION["filter_start"];
  $use_ende = ($_ende != "") ? $_ende : $_SESSION["filter_ende"];
	$use_items = $_SESSION['show_items'];

	//Permanenten Filter einfgen, falls vorhanden und nur view-Rechte
	$z_where = "";
	$perm_filter_start = ko_get_setting("res_perm_filter_start");
	$perm_filter_ende  = ko_get_setting("res_perm_filter_ende");
	if($access['reservation']['MAX'] < 3 && ($perm_filter_start || $perm_filter_ende)) {
		if($perm_filter_start != "") {
			$z_where .= " AND startdatum >= '".$perm_filter_start."' ";
		}
		if($perm_filter_ende != "") {
			$z_where .= " AND startdatum <= '".$perm_filter_ende."' ";
		}
	}


	if(isset($use_start) && $use_start != "immer") {
	  get_heute($tag, $monat, $jahr);
		if($use_start == "today") {
			$start = sql_datum($tag.".".$monat.".".$jahr);
		} else {
			addmonth($monat, $jahr, $use_start);
			$start = sql_datum("1.".$monat.".".$jahr);
		}
    $z_where .= "AND `startdatum` >= '$start'";
  }
  if(isset($use_ende) && $use_ende != "immer") {
    get_heute($tag, $monat, $jahr);
		if($use_ende == "today") {
			$ende = sql_datum($tag.".".$monat.".".$jahr);
		} else {
			addmonth($monat, $jahr, ($use_ende+1));
			$ende = sql_datum("0.".$monat.".".$jahr);
		}
    $z_where .= " AND `startdatum` <= '$ende'";
  }

	//Check for proper access
	$show_items = array();
	foreach($use_items as $item) {
		if($item && $access['reservation'][$item] > 0) $show_items[] = $item;
	}

	if(sizeof($show_items) == 0) {
		if($user_id > 0 && $user_id != ko_get_guest_id()) $z_where .= " AND `user_id` = '$user_id' ";
		else $z_where .= " AND 1=2 ";
	}
	else {
		$item_where = " AND (`item_id` IN ('".implode("','", $show_items)."') ";
		if($user_id > 0 && $user_id != ko_get_guest_id()) $item_where .= " OR `user_id` = '$user_id' ";
		$item_where .= ") ";
	}
	$z_where .= $item_where;

	if($_SESSION["show_start"] > 0 && $_SESSION["show_limit"]) {
		$z_limit = "LIMIT " . ($_SESSION["show_start"]-1) . ", " . $_SESSION["show_limit"];
	}
}//apply_res_filter()




/**
  * Lscht eine Reservation gemss der bergebenen ID
	* Fhrt Rechte-Check durch
	*/
function do_del_res($id, $del_serie=FALSE) {
	global $access;

	//Reservation auslesen fr Rechte-Check und Log-Meldung
  ko_get_res_by_id($id, $r_); $r = $r_[$id];

	//Check access rights
	if($access['reservation'][$r['item_id']] > 2 || ($_SESSION["ses_userid"] == $r["user_id"] && $_SESSION["ses_userid"] != ko_get_guest_id() && $access['reservation'][$r['item_id']] > 1) ) {
		//Delete reservation
		db_delete_data("ko_reservation", "WHERE `id` = '$id'");
		ko_log_diff("delete_res", $r);

		//Delete whole serie if set
		if(intval($r["serie_id"]) > 0 && $del_serie) {
			db_delete_data("ko_reservation", "WHERE `serie_id` = '".intval($r["serie_id"])."'");
		}
	}
}//do_del_res()




function ko_res_get_items_css() {
	$css = '<style type="text/css">
<!--
';

	ko_get_resitems($items);
	foreach($items as $item) {
		if(!$item['farbe']) $item['farbe'] = 'aaaaaa';
		$css .= '.item'.$item['id'].', .item'.$item['id'].' a, .item'.$item['id'].' a:link, .item'.$item['id'].' a:visited, .item'.$item['id'].' a:hover, .item'.$item['id'].' a:active { ';
		$css .= 'background-color: #'.$item['farbe'].'; ';
		$css .= 'border-color: #'.$item['farbe'].'; ';
		$css .= 'color: '.ko_get_contrast_color($item['farbe']).'; ';
		$css .= '}'."\n";
	}

	//Add colors for event groups with res_combined == 1
	ko_get_eventgruppen($egs, '', 'AND `res_combined` = \'1\'');
	foreach($egs as $eg) {
		if(!$eg['farbe']) $eg['farbe'] = 'aaaaaa';
		$css .= '.eg'.$eg['id'].', .eg'.$eg['id'].' a, .eg'.$eg['id'].' a:link, .eg'.$eg['id'].' a:visited, .eg'.$eg['id'].' a:hover, .eg'.$eg['id'].' a:active { ';
		$css .= 'background-color: #'.$eg['farbe'].'; ';
		$css .= 'border-color: #'.$eg['farbe'].'; ';
		$css .= 'color: '.ko_get_contrast_color($eg['farbe']).'; ';
		$css .= '}'."\n";
	}

	$css .= '
-->
</style>';

	return $css;
}//ko_res_get_items_css()




/**
  * Display the calendar div which will be filled by fullCalendar JS
	*/
function ko_res_calendar() {
	global $ko_path;

	//Add the link to the year view
	$code  = '';
	$code .= '<div id="ko_calendar">';
	$code .= '<div class="fc-mwselect">';
	$code .= '<div name="mwselect" id="mwselect" style="float: left;">';
	$code .= ko_calendar_mwselect($_SESSION['cal_view']);
	$code .= '</div>';
	$code .= '<a href="index.php?action=show_cal_jahr"><img src="'.$ko_path.'images/cal_jahr.gif" border="0" title="'.getLL('res_cal_year').'"></a>';
	$code .= '</div>';
	$code .= '</div>';

	//Add PDF link
	$code .= '<table style="margin-left:12px" cellspacing="0" cellpadding="3">';
	$code .= '<tr><td style="border-left-style:solid;border-left-width:1px">&nbsp;</td></tr>';
	$code .= '<tr><td style="border-left-style:solid;border-left-width:1px;border-bottom-width:1px;border-bottom-style:solid;">';
	$code .= '<span onclick="sendReq(\'inc/ajax.php\', \'action\', \'pdfcalendar\', do_element);">';
	$code .= '<img src="'.$ko_path.'images/create_pdf.png" border="0" />&nbsp;'.getLL("res_list_footer_pdf_label").'</span>';
	$code .= '<span name="res_pdf_link" id="res_pdf_link">&nbsp;</span>';
	$code .= '</td></tr>';
	$code .= '</table>';

	print $code;
}//ko_daten_calendar()
?>
