<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

define('VERSION', 'R39');


//Reservation: Objekt-Bild
$RESITEM_IMAGE_WIDTH = 60;
//Itemlist-Stringlngen-Maximum
define("ITEMLIST_LENGTH_MAX", 35);
//Default-Werte fr Logins
$DEFAULT_USERPREFS = array(
		array('key' => 'show_limit_daten',            'value' => '20',                          'type' => ''),
		array('key' => 'cal_jahr_num',                'value' => '6',                           'type' => ''),
		array('key' => 'show_limit_leute',            'value' => '20',                          'type' => ''),
		array('key' => 'show_limit_kg',               'value' => '20',                          'type' => ''),
		array('key' => 'show_limit_reservation',      'value' => '20',                          'type' => ''),
		array('key' => 'show_limit_dp',               'value' => '20',                          'type' => ''),
		array('key' => 'show_limit_logins',           'value' => '20',                          'type' => ''),
		array('key' => 'show_limit_fileshare',        'value' => '20',                          'type' => ''),
		array('key' => 'show_limit_tapes',            'value' => '20',                          'type' => ''),
		array('key' => 'show_limit_groups',           'value' => '20',                          'type' => ''),
		array('key' => 'show_limit_donations',        'value' => '20',                          'type' => ''),
		array('key' => 'show_limit_trackings',        'value' => '20',                          'type' => ''),
		array('key' => 'tracking_date_limit',         'value' => '7',                           'type' => ''),
		array('key' => 'default_view_daten',          'value' => 'show_cal_monat',              'type' => ''),
		array('key' => 'default_view_reservation',    'value' => 'show_cal_monat',              'type' => ''),
		array('key' => 'front_modules_left',          'value' => 'daten_cal,fastfilter,news',   'type' => ''),
		array('key' => 'front_modules_center',        'value' => 'today',                       'type' => ''),
		array('key' => 'front_modules_right',         'value' => 'geburtstage',                 'type' => ''),
		array('key' => 'do_mod_email_for_edit_res',   'value' => '2',                           'type' => ''),
		array('key' => 'do_res_email',                'value' => '2',                           'type' => ''),
		array('key' => 'modules_dropdown',            'value' => 'ja',                          'type' => ''),
);

$LEUTE_ADRESSLISTE = array("firm", "department", "anrede", "vorname", "nachname", "adresse", "plz", "ort", "land", "telp", "telg", "natel", "fax", "email", "web");
$LEUTE_ADRESSLISTE_LAYOUT = array(
		array("firm", "deparment"),
		array("anrede"),
		array("vorname", "nachname"),
		array("adresse"),
		array("plz", "ort"),
		array("land"),
		array("@P: ","telp", "@G: ","telg"),
		array("@Mobil: ","natel", "@Fax: ","fax"),
		array("email"),
		array("web")
		);

//mapping table for LDAP-entries
$LDAP_ATTRIB = array(
										 "firm" => "o",
                     "department" => "ou",
                     "vorname" => "givenName",
                     "nachname" => "sn",
                     "adresse" => "postalAddress",
                     "adresse_zusatz" => "postalAddress",
                     "plz" => "postalCode",
                     "ort" => "l",
                     "telp" => "homePhone",
                     "telg" => "telephoneNumber",
                     "natel" => "mobile",
                     "fax" => "facsimileTelephoneNumber",
                     "email" => "mail",
);

//Zugehrigkeiten der Familien-Daten zu den Personendaten
//Diese Spalten kommen sowohl in ko_leute wie auch in ko_familie vor. ko_leute.* wird jeweils von ko_familie.* berschrieben.
//Ausser beim Neu-Anlegen einer Person, dann ist es umgekehrt.
//Nachname ist standardmssig kein Fam-Feld, da es oft verschiedene Namen in Familien geben kann.
$COLS_LEUTE_UND_FAMILIE = array("adresse", "adresse_zusatz", "plz", "ort", "land", "telp");

//default columns from ko_leute to be hidden in the form
//can be overridden or extended in config/ko-config.php
$LEUTE_EXCLUDE  = array("id", "famid", "lastchange", "hidden", "deleted", "kinder", "crdate", "cruserid");

//Default fields containing an email address. Add additionals in config/ko-config.php
$LEUTE_EMAIL_FIELDS = array("email");

//Additional columns that will be exported for "children" exports
//Normal columns from DB.ko_leute may be added by adding their name prefixed with an underscore. The values from the first parent
// found will be used.
//Special columns include: _father, _mother which will contain the first and lastname of the father or the mother respectively
//Define your columns in config/ko-config.php
$LEUTE_EXPORT_CHILDREN_COLUMNS = array("_father", "_mother", "_natel");

//Set date and time formats (see http://php.net/strftime for help)
//Can be overwritten in config/ko-config.php if needed
$_DATETIME["de"] = array("dm" => "%d.%m", "dM" => "%e. %B",
												 "mY" => "%m %Y", "nY" => "%b %Y", "MY" => "%B %Y",
												 "dmy" => "%d.%m.%y", "dmY" => "%d.%m.%Y", "dMY" => "%e. %B %Y",
												 "DdM" => "%A, %e. %B",
												 "ddmy" => "%a, %d.%m.%y", "DdmY" => "%A, %d.%m.%Y", "DdMY" => "%A, %e. %B %Y");
$_DATETIME["en"] = array("dm" => "%d/%m", "dM" => "%e %B",
												 "mY" => "%m/%Y", "nY" => "%b %Y", "MY" => "%B %Y",
												 "dmy" => "%d/%m/%y", "dmY" => "%d/%m/%Y", "dMY" => "%e %B %Y",
												 "DdM" => "%A, %e %B",
												 "ddmy" => "%a, %d/%m/%y", "DdmY" => "%A, %d/%m/%Y", "DdMY" => "%A, %e %B %Y");
$_DATETIME["nl"] = array("dm" => "%e %b", "dM" => "%e %B", "mY" => "%b '%y",
												 "nY" => "%b %Y", "MY" => "%B %Y",
												 "dmy" => "%d-%m-%y", "dmY" => "%d-%m-%Y", "dMY" => "%e %B %Y",
												 "DdM" => "%A %e %B",
												 "ddmy" => "%a %e %b '%y", "DdmY" => "%A %e %b %Y", "DdMY" => "%A %e %B %Y");


//If TRUE all access priviliges will be set to maximum (use with caution!)
//define("ALL_ACCESS", TRUE);

//If set to TRUE the PHP Quick Profiler (PQP) will be displayed for each page (not included in standard kOOL package)
//define('DEBUG', TRUE);


//Kunden-spezifische Konfiguration einlesen (kann oben stehende Werte berschreiben)
include($ko_path."config/ko-config.php");

//Session
include($ko_path."inc/session.inc");

//Error reporting
include($ko_path."inc/error_handling.inc");


if(defined('DEBUG') && DEBUG) {
	//start output with: if(defined('DEBUG') && DEBUG) $profiler->display($DEBUG_db);

	require($ko_path.'pqp/classes/PhpQuickProfiler.php');
	$debugMode = TRUE;
	$profiler = new PhpQuickProfiler(PhpQuickProfiler::getMicroTime(), 'web_test/pqp/');

	class pqp_db {
		var $queryCount = 0;
		var $queries = array();
		function query($sql) {
			return mysql_query($sql);
		}
	};
	$DEBUG_db = new pqp_db;

	define('DEBUG_SELECT', TRUE);
	define('DEBUG_UPDATE', TRUE);
	define('DEBUG_INSERT', TRUE);
	define('DEBUG_DELETE', TRUE);
}


//Get base_path from _SERVER if not set during first installation
if($ko_menu_akt == "install" && !$BASE_PATH) {
	$bdir = str_replace("install", "", dirname($_SERVER['SCRIPT_NAME']));
	$droot = $_SERVER["DOCUMENT_ROOT"];
	if(substr($droot, -1) == "/") $droot = substr($droot, 0, -1);
	$BASE_PATH = $droot.$bdir;
}
if($BASE_PATH != "" && substr($BASE_PATH, -1) != "/") $BASE_PATH .= "/";

//Hooks (Plugins)
include($BASE_PATH."inc/hooks.inc");

//Set include paths for PEAR and smarty
if($INCLUDE_PATH_PEAR) set_include_path($INCLUDE_PATH_PEAR.PATH_SEPARATOR.get_include_path());
if($INCLUDE_PATH_SMARTY) set_include_path($INCLUDE_PATH_SMARTY.PATH_SEPARATOR.get_include_path());


//Connect to the database
$db_conn = mysql_connect($mysql_server, $mysql_user, $mysql_pass);
//Test the connection
$db_connection = $db_conn !== FALSE;
mysql_select_db($mysql_db);
//Set client-server connection to latin1
if($ko_menu_akt != 'install') mysql_query('SET NAMES LATIN1');

//Language-Stuff
$LIB_LANGS  = array("en", "de", "nl");
$LIB_LANGS2 = array("en" => array("UK"),
										"de" => array("CH", "DE"),
										"nl" => array("NL"),
										);
include($BASE_PATH."inc/lang.inc");
$DATETIME = $_DATETIME[$_SESSION["lang"]];


//No DB-connection and not the install-tool is running
if(!$db_connection && $ko_menu_akt != "install") {
	print '<div align="center" style="font-weight:900;color:red;">';
	print getLL("error_no_db_1")."<br /><br />";
	print getLL("error_no_db_2");
	print '</div>';
	print '<ul>';
	print '<li>'.getLL("error_no_db_reason_1").'</li>';
	print '<li>'.getLL("error_no_db_reason_2").'</li>';
	print '<li>'.getLL("error_no_db_reason_3").'</li>';
	print '</ul>';
	exit;
}


//Front-Modules
include($BASE_PATH."inc/front_modules.inc");

//Submenus (fr alle Module)
include($BASE_PATH."inc/submenu.inc");

//Submenu-Behandlung
include($BASE_PATH."inc/submenu_actions.inc");


//all available modules
$LIB_MODULES = array('daten', 'reservation', 'leute', 'kg', 'groups', 'tracking', 'dp', 'donations', 'tapes', 'fileshare', 'sms', 'admin', 'tools');
foreach($MODULES as $k => $v) {
	if(!in_array($v, $LIB_MODULES)) unset($MODULES[$k]);
}

//Namen fr die Frontmodule
$FRONTMODULES = array("daten_cal"       => array("modul" => "daten", "name" => getLL("fm_name_daten_cal")),
											"geburtstage"     => array("modul" => "leute", "name" => getLL("fm_name_geburtstage")),
											"mod"             => array("modul" => "leute,reservation", "name" => getLL("fm_name_mod")),
											'fastfilter'      => array('modul' => 'leute', 'name' => getLL('fm_name_fastfilter')),
											"news"            => array("modul" => "", "name" => getLL("fm_name_news")),
											"adressaenderung" => array("modul" => "", "name" => getLL("fm_name_adressaenderung")),
											"dienstplan"      => array("modul" => "dp", "name" => getLL("fm_name_dienstplan")),
											"today"           => array("modul" => "leute,daten,dp,reservation", "name" => getLL("fm_name_today")),
);
if(ENABLE_FILESHARE) $FRONTMODULES["fileshare"] = array("modul" => "fileshare", "name" => getLL("fm_name_fileshare"));

//Read in settings etc
ko_init();


//Include calendar for jsdate input fields
require($ko_path.'inc/calendar/calendar.php');
$js_calendar = new DHTML_Calendar($ko_path.'inc/calendar/', $ko_path.'images/', $_SESSION['lang'], 'calendar-system', false);



function ko_init() {
	global $db_connection, $ko_menu_akt;

	//Return during installation, as not DB connection and/or no DB tables are present yet
	if(!$db_connection || $ko_menu_akt == "install") return FALSE;

	unset($GLOBALS["kOOL"]);

	//Read settings
	$settings = db_select_data("ko_settings", "WHERE 1", array("key", "value"));
	foreach($settings as $s) {
		$GLOBALS["kOOL"]["ko_settings"][$s["key"]] = $s["value"];
	}

	//Read userprefs for logged in user
	$userprefs = NULL;
	//db_select_data does not work here, as this table doesn't contain an unique_id column
	$rows = db_select_data('ko_userprefs', "WHERE `user_id` = '".$_SESSION['ses_userid']."'", '*', 'ORDER BY `key` ASC', '', FALSE, TRUE);
	foreach($rows as $row) {
		if($row["type"] != "") {
			$userprefs["TYPE@".$row["type"]][$row["key"]] = $row;
		} else {
			$userprefs[$row["key"]] = $row["value"];
		}
	}
	$GLOBALS["kOOL"]["ko_userprefs"] = $userprefs;

	//Get all help entries for the current module
	$helps = db_select_data('ko_help', "WHERE `module` = '$ko_menu_akt'", '*');
	foreach($helps as $help) {
		if($help['type'] == '') {
			$GLOBALS['kOOL']['ko_help'][$help['language']]['_notype'] = $help;
		} else {
			$GLOBALS['kOOL']['ko_help'][$help['language']][$help['type']] = $help;
		}
	}

}//ko_init()




/************************************************************************************************************************
 *                                                                                                                      *
 * MODULE UND BERECHTIGUNGEN                                                                                            *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
  * Checks whether a module is installed for a user
	*
	* If no userid is given as argument the current user will be checked
	* that is stored in $_SESSION["ses_userid"].
	*
	* @param string id of module to check for
	* @param int userid of user to check. If not set, value in $_SESSION["ses_userid"] will be used
	* @return boolean True if module is available to user, false otherwise
	*/
function ko_module_installed($m, $uid="") {
	if(defined("ALL_ACCESS")) return TRUE;

	if($uid) {
		ko_get_user_modules($uid, $modules);
	} else {
		ko_get_user_modules($_SESSION["ses_userid"], $modules);
	}
	if(in_array($m, $modules)) return TRUE;
	else return FALSE;
}//ko_module_installed()



/**
	* Get all modules a user is allowed to see
	*
	* @param int userid
	* @param array Contains the modules
	*/
function ko_get_user_modules($uid, &$m) {
	global $MODULES;

	//Get from cache
	if(isset($GLOBALS["kOOL"]["user_modules"][$uid])) {
		$m = $GLOBALS["kOOL"]["user_modules"][$uid];
		return;
	}

	if(defined("ALL_ACCESS")) {
		$m = $MODULES;
		return;
	}

	if(!$uid) {
		$uid = ko_get_guest_id();
	}

	$row = db_select_data("ko_admin", "WHERE `id` = '$uid'", "modules", "", "", TRUE);
	$m = explode(",", $row["modules"]);

	$groups = ko_get_admingroups($uid);
	foreach($groups as $group) {
		$row = db_select_data("ko_admingroups", "WHERE `id` = '".$group["id"]."'", "modules", "", "", TRUE);
		$m = array_merge($m, explode(",", $row["modules"]));
	}
	$m = array_unique($m);

	//Store in cache and return
	$GLOBALS["kOOL"]["user_modules"][$uid] = $m;
}//ko_get_user_modules()



/**
  * Returns an array of admingroups.
	*
	* If the first argument is set to a user id then the admingroups are returned
	* this user is being assigned to. Otherwise all admingroups are returned.
	*
	* @param int userid
	* @return array admingroups
	*/
function ko_get_admingroups($uid="") {
	//Get from cache
	if($uid && isset($GLOBALS["kOOL"]["admingroups"][$uid])) return $GLOBALS["kOOL"]["admingroups"][$uid];

	$groups = array();
	//get all groups
	if($uid == "") {
		$groups = db_select_data("ko_admingroups", "", "*", "ORDER BY name ASC");
	}
	//get groups for the specified account
	else {
		$row = db_select_data("ko_admin", "WHERE `id` = '$uid'", "admingroups", "", "", TRUE);
		foreach(explode(",", $row["admingroups"]) as $groupid) {
			if(!$groupid) continue;
			$group = db_select_data("ko_admingroups", "WHERE `id` = '$groupid'", "*", "", "", TRUE);
			$groups[$group["id"]] = $group;
		}
	}

	//Store in cache and return
	if($uid) $GLOBALS["kOOL"]["admingroups"][$uid] = $groups;
	return $groups;
}//ko_get_admingroups()




/**
  * Get ALL-Rights
	*/
function ko_get_access_all($col, $id="", &$max=0) {
	$max = 0;
	if(defined('ALL_ACCESS')) $id = ko_get_root_id();
	if(!$id) $id = $_SESSION['ses_userid'];

	//Accept module name instead of col name as well
	if(substr($col, -6) != '_admin') {
		switch($col) {
			case 'reservation': $col = 'res_admin'; break;
			case 'admin': $col = 'admin'; break;
			case 'daten': $col = 'event_admin'; break;
			default: $col = $col.'_admin';
		}
	}

	if(isset($GLOBALS['kOOL']['admin_max'][$id][$col])) $max = $GLOBALS['kOOL']['admin_max'][$id][$col];
	if(isset($GLOBALS['kOOL']['admin_all'][$id][$col])) return $GLOBALS['kOOL']['admin_all'][$id][$col];
	
	$value = 0;
	//Check for settings for login
	$rights = db_select_data('ko_admin', "WHERE `id` = '$id'", '*', '', '', TRUE);
	foreach(explode(',', $rights[$col]) as $r) {
		if(FALSE === strpos($r, "@")) $value = $r;
		$max = max($max, substr($r, 0, 1));
	}
	//Check for settings for admingroups
	if($rights["admingroups"]) {
		$admingroups = db_select_data("ko_admingroups", "WHERE `id` IN ('".implode("','", explode(",", $rights["admingroups"]))."')");
		foreach($admingroups as $ag) {
			foreach(explode(",", $ag[$col]) as $r) {
				if(FALSE === strpos($r, "@")) $value = max($value, $r);
				$max = max($max, substr($r, 0, 1));
			}
		}
	}

	//Raise max rights for people module if a admin_filter is set for the given access level
	if($col == 'leute_admin') {
		$laf = unserialize($rights['leute_admin_filter']);
		if($max < 3 && $laf[3]) {
			$max = 3;
		} else if($max < 2 && $laf[2]) {
			$max = 2;
		} else if($max < 1 && $laf[1]) {
			$max = 1;
		}
	}

	if($col == 'groups_admin') {
		if($max < 3) {
			if(db_get_count('ko_groups', 'id', "AND `rights_edit` REGEXP '(^|,)$id(,|$)'") > 0) $max = 3;
		}
		if($max < 2) {
			if(db_get_count('ko_groups', 'id', "AND `rights_new` REGEXP '(^|,)$id(,|$)'") > 0) $max = 2;
		}
		if($max < 1) {
			if(db_get_count('ko_groups', 'id', "AND `rights_view` REGEXP '(^|,)$id(,|$)'") > 0) $max = 1;
		}
	}

	$GLOBALS['kOOL']['admin_all'][$id][$col] = $value;
	$GLOBALS['kOOL']['admin_max'][$id][$col] = $max;

	return $value;
}//ko_get_access_all()




function ko_get_access($module, $uid='', $force=FALSE, $apply_admingroups=TRUE, $mode='login', $store_globally=TRUE) {
	global $access, $MODULES;
	
	//Temporary array to hold the access rights within this function
	$_access = array();

	if(!in_array($module, $MODULES)) return FALSE;
	if($uid == '') $uid = $_SESSION['ses_userid'];
	if(defined('ALL_ACCESS')) $uid = ko_get_root_id();

	//Only reread access rights if force is set
	if(is_array($access[$module]) && !$force) return TRUE;

	switch($module) {
		case 'dp':
		case 'leute':
		case 'fileshare':
		case 'kg':
		case 'tapes':
		case 'groups':
		case 'donations':
		case 'tracking':
		case 'projects':
			$col = $module.'_admin';
		break;
		case 'reservation':
			$col = 'res_admin';
		break;
		case 'admin':
			$col = 'admin';
		break;
		case 'daten':
			$col = 'event_admin';
		break;
		default:
			return FALSE;
	}

	//get rights for user from db
	if($mode == 'login') {
		$row = db_select_data('ko_admin', "WHERE `id` = '$uid'", '*', '', '', TRUE);
	} else {
		$row = db_select_data('ko_admingroups', "WHERE `id` = '$uid'", '*', '', '', TRUE);
	}
	$rights = explode(',', $row[$col]);
	foreach($rights as $r) {
		if(trim($r) == '') continue;
		if(strpos($r, '@') === FALSE) {  //No @ means ALL rights
			$_access[$module]['ALL'] = $r;
		} else {
			list($level, $id) = explode('@', $r);
			$_access[$module][$id] = max($_access[$module]['ALL'], $level);
		}
	}
	//Add access rights from admin groups
	if($row['admingroups'] != '' && $apply_admingroups) {
		$groups = db_select_data('ko_admingroups', "WHERE `id` IN ('".implode("','", explode(',', $row['admingroups']))."')");
		foreach($groups as $group) {
			$rights_group = explode(',', $group[$col]);
			foreach($rights_group as $r) {
				if(trim($r) == '') continue;
				if(strpos($r, '@') === FALSE) {  //No @ means ALL rights
					$_access[$module]['ALL'] = max($r, $_access[$module]['ALL']);
				} else {
					list($level, $id) = explode('@', $r);
					$_access[$module][$id] = max($_access[$module]['ALL'], $_access[$module][$id], $level);
				}
			}
		}
	}//if(apply_admingroups)

	if(defined('ALL_ACCESS')) {
		$_access[$module]['ALL'] = 4;
		foreach($_access[$module] as $id => $level) {
			$_access[$module][$id] = 4;
		}
	}


	switch($module) {
		case 'daten':
			$egs = db_select_data('ko_eventgruppen', 'WHERE 1=1');
			foreach($egs as $eg) {
				if($eg['calendar_id'] > 0) {
					if(isset($_access[$module]['cal'.$eg['calendar_id']])) {
						$_access[$module][$eg['id']] = $_access[$module]['cal'.$eg['calendar_id']];
					} else {
						$_access[$module][$eg['id']] = $_access[$module]['ALL'];
						$_access[$module]['cal'.$eg['calendar_id']] = $_access[$module]['ALL'];
					}
				} else {
					if(!isset($_access[$module][$eg['id']])) $_access[$module][$eg['id']] = $_access[$module]['ALL'];
				}
			}
		break;


		case 'tapes':
			$tapegroups = db_select_data('ko_tapes_groups', 'WHERE 1=1');
			foreach($tapegroups as $tapegroup) {
				if(!isset($_access[$module][$tapegroup['id']])) $_access[$module][$tapegroup['id']] = $_access[$module]['ALL'];
			}
		break;


		case 'tracking':
			$trackings = db_select_data('ko_tracking', 'WHERE 1=1');
			foreach($trackings as $tracking) {
				if(!isset($_access[$module][$tracking['id']])) $_access[$module][$tracking['id']] = $_access[$module]['ALL'];
			}
		break;


		case 'dp':
			$teams = db_select_data('ko_dp_dienste', 'WHERE 1=1');
			foreach($teams as $team) {
				if(!isset($_access[$module][$team['id']])) $_access[$module][$team['id']] = $_access[$module]['ALL'];
			}
		break;


		case 'donations':
			$accounts = db_select_data('ko_donations_accounts', 'WHERE 1=1');
			foreach($accounts as $account) {
				if(!isset($_access[$module][$account['id']])) $_access[$module][$account['id']] = $_access[$module]['ALL'];
			}
		break;


		case 'reservation':
			//Mark group access rights with prefix
			foreach($_access[$module] as $k => $v) {
				if(intval($k)) {
					unset($_access[$module][$k]);
					$_access[$module]['grp'.$k] = $v;
				}
			}
			//Add access rights for items
			$items = db_select_data('ko_resitem', 'WHERE 1=1');
			foreach($items as $item) {
				if(isset($_access[$module]['grp'.$item['gruppen_id']])) {
					$_access[$module][$item['id']] = $_access[$module]['grp'.$item['gruppen_id']];
				} else {
					$_access[$module][$item['id']] = $_access[$module]['ALL'];
					if($item['gruppen_id']) $_access[$module]['grp'.$item['gruppen_id']] = $_access[$module]['ALL'];
				}
			}
			unset($items);
		break;


		case 'leute':
			$rights = array();
			for($i=3; $i>$_access[$module]['ALL']; $i--) {
				if(FALSE !== apply_leute_filter('', $z_where, TRUE, $i)) {
					$leute = db_select_data('ko_leute', 'WHERE 1=1 '.$z_where, 'id');
					foreach($leute as $id => $p) {
						if(!isset($_access[$module][$id])) $_access[$module][$id] = $i;
					}
				}
			}
			unset($leute);
			//GS will be added at the end (after MAX has been set)
		break;


		case 'groups':
			//Get access rights for single groups that are higher than the ALL rights
			if($_access[$module]['ALL'] < 3) {
				$grps3 = db_select_data('ko_groups', "WHERE `rights_edit` REGEXP '(^|,)$uid(,|$)'", 'id');
				if(sizeof($grps3) > 0) {
					foreach($grps3 as $grp) {
						$_access[$module][$grp['id']] = 3;
					}
				}
			}
			unset($grps3);
			//Get access rights for single groups that are higher than the ALL rights
			if($_access[$module]['ALL'] < 2) {
				$grps2 = db_select_data('ko_groups', "WHERE `rights_new` REGEXP '(^|,)$uid(,|$)'", 'id');
				if(sizeof($grps2) > 0) {
					foreach($grps2 as $grp) {
						if(!isset($_access[$module][$grp['id']])) $_access[$module][$grp['id']] = 2;
					}
				}
			}
			unset($grps2);
			//Get access rights for single groups that are higher than the ALL rights
			if($_access[$module]['ALL'] < 1) {
				$grps1 = db_select_data('ko_groups', "WHERE `rights_view` REGEXP '(^|,)$uid(,|$)'", 'id');
				if(sizeof($grps1) > 0) {
					foreach($grps1 as $grp) {
						if(!isset($_access[$module][$grp['id']])) $_access[$module][$grp['id']] = 1;
					}
				}
			}
			unset($grps1);
		break;

		case 'fileshare':
		case 'kg':
		case 'admin':
			//Nothing
		break;
	}


	//Add max value
	$_access[$module]['MAX'] = max($_access[$module]);

	//Store max and all values in Cache for ko_get_access_all()
	$GLOBALS['kOOL']['admin_all'][$uid][$col] = $_access[$module]['ALL'];
	$GLOBALS['kOOL']['admin_max'][$uid][$col] = $_access[$module]['MAX'];

	//Only add it her after MAX has been set, so this value won't be considered for the MAX value
	if($module == 'leute') {
		// Add right to moderate group subscriptions
		$gs = db_select_data('ko_admin', "WHERE `id` = '$uid'", 'leute_admin_gs', '', '', TRUE);
		$_access[$module]['GS'] = $gs['leute_admin_gs'] == 1;
	}

	//Usually the access rights will be stored in the global array $access
	if($store_globally) {
		//Reset access rights before (re)building them
		unset($access[$module]);
		$access[$module] = $_access[$module];
		return;
	}
	//But when reading the access rights for another user it shouldn't overwrite one's own access rights
	else {
		return $_access;
	}
	unset($_access);
}//ko_get_access()



/**
	* Saves admin data in ko_admin
	*
	* Stores access rights for modules, password, available modules etc. in ko_admin
	*
	* @param string module id or other column to store data for
	* @param int user id or admingroup id to store the data for
	* @param string Value to be stored
	* @param string Stores the data for a login if set to "login", for an admingroup otherwise
	* @return True on success, false on failure
	*/
function ko_save_admin($module, $uid, $string, $type="login") {
	switch($module) {
		case "daten": $col = "event_admin"; break;
		case "leute": $col = "leute_admin"; break;
		case "leute_filter": $col = "leute_admin_filter"; break;
		case "leute_spalten": $col = "leute_admin_spalten"; break;
		case "leute_groups": $col = "leute_admin_groups"; break;
		case "leute_gs": $col = "leute_admin_gs"; break;
		case "reservation": $col = "res_admin"; break;
		case "admin": $col = "admin"; break;
		case "dp": $col = "dp_admin"; break;
		case "fileshare": $col = "fileshare_admin"; break;
		case "kg": $col = "kg_admin"; break;
		case "tapes": $col = "tapes_admin"; break;
		case "groups": $col = "groups_admin"; break;
		case "donations": $col = "donations_admin"; break;
		case "tracking": $col = "tracking_admin"; break;
		case "projects": $col = "projects_admin"; break;
		case "modules": $col = "modules"; break;
		case "admingroups": $col = "admingroups"; break;
		case "login": $col = "login"; break;
		case "name": $col = "name"; break;
		case "password": $col = "password"; break;
		default: $col = "";
	}//switch(module)

	if(!isset($uid)) return FALSE;
	if($col == "") return FALSE;

	if($type == "login") {
		db_update_data('ko_admin', "WHERE `id` = '$uid'", array($col => format_userinput($string, 'text')));
	} else {
		db_update_data('ko_admingroups', "WHERE `id` = '$uid'", array($col => format_userinput($string, 'text')));
	}

	//Unset cached value in GLOBALS[kOOL]
	if(isset($GLOBALS["kOOL"][$col][$uid][$type])) unset($GLOBALS["kOOL"][$col][$uid][$type]);

	return TRUE;
}



/**
  * Returns the array of admin-filters for the given login.
	*
	* This array defines the global filter that is to be applied to ko_leute always for the given login.
	*
	* @param int user id or admingroup id
	* @param string Get filter for login if set to "login", for admingroup otherwise
	* @return array Filter to be applied
	*/
function ko_get_leute_admin_filter($id, $mode="login") {
	//Get from cache
	if(isset($GLOBALS["kOOL"]["leute_admin_filter"][$id][$mode])) return $GLOBALS["kOOL"]["leute_admin_filter"][$id][$mode];

	if($mode == "login") {
		$row = db_select_data("ko_admin", "WHERE `id` = '$id'", "leute_admin_filter", "", "", TRUE);
	} else if($mode == "admingroup") {
		$row = db_select_data("ko_admingroups", "WHERE `id` = '$id'", "leute_admin_filter", "", "", TRUE);
	}

	//Store in cache and return
	$r = unserialize($row["leute_admin_filter"]);
	$GLOBALS["kOOL"]["leute_admin_filter"][$id][$mode] = $r;
	return $r;
}//ko_get_leute_admin_filter()



/**
  * Returns the columns of ko_leute, for which the user has [view] and [edit] rights.
	*
	* Remark: Remember special cols like groups, kg, kg_leiter, dienst, dienstleiter.
	* They are not included here, but retrieved from the corresponding module-rights
	*
	* @param int user id or admingroup id
	* @param string Get filter for login if set to "login", for admingroup otherwise
	* @return array Array with view and edit rights or FALSE if no limitations exist
	*/
function ko_get_leute_admin_spalten($userid, $mode="login") {
	global $FORCE_KO_ADMIN;

	//Get from cache
	if(isset($GLOBALS["kOOL"]["leute_admin_spalten"][$userid][$mode])) return $GLOBALS["kOOL"]["leute_admin_spalten"][$userid][$mode];

	if($mode == "login" || $mode == "all") {
		$cols = db_select_data("ko_admin", "WHERE `id` = '$userid'", "leute_admin_spalten", "", "", TRUE);
		$return = unserialize($cols["leute_admin_spalten"]);
	} else if($mode == "admingroup") {
		$cols = db_select_data("ko_admingroups", "WHERE `id` = '$userid'", "leute_admin_spalten", "", "", TRUE);
		$return = unserialize($cols["leute_admin_spalten"]);
	}

	if($mode == "all") {
		$admingroups = ko_get_admingroups($userid);
		foreach($admingroups as $group) {
			$group_cols = db_select_data("ko_admingroups", "WHERE `id` = '".$group["id"]."'", "leute_admin_spalten", "", "", TRUE);
			$cols = unserialize($group_cols["leute_admin_spalten"]);
			if(sizeof($cols) > 0) $return = array_merge_recursive((array)$return, (array)$cols);
		}
	}

	//Unset empty entries
	if(is_array($return)) {
		foreach($return as $k => $v) {
			if(!$v) unset($return[$k]);
		}
	}

	//Return FALSE if no cols were found, so all will get displayed
	if(sizeof($return) == 0) $return = FALSE;

	//Check for forced access rights
	if(isset($FORCE_KO_ADMIN["leute_admin_spalten"])) {
		$return = unserialize($FORCE_KO_ADMIN["leute_admin_spalten"]);
	}

	//Store in cache and return
	$GLOBALS["kOOL"]["leute_admin_spalten"][$userid][$mode] = $return;
	return $return;
}//ko_get_leute_admin_spalten()




function ko_get_leute_admin_groups($userid) {
	$groups = db_select_data("ko_admin", "WHERE `id` = '$userid'", "leute_admin_groups", "", "", TRUE);
	if($groups) {
		return $groups["leute_admin_groups"];
	} else {
		return FALSE;
	}
}//ko_get_leute_admin_groups()







/************************************************************************************************************************
 *                                                                                                                      *
 * USER UND EINSTELLUNGEN                                                                                               *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
	* Get the people id of the logged in id
	*
	* @return int id in ko_leute of the person assigned to the logged in user
	*/
function ko_get_logged_in_id($id="") {
	$lid = $id ? $id : $_SESSION["ses_userid"];
	if(!$lid) return FALSE;

	$row = db_select_data('ko_admin', "WHERE `id` = '$lid'", 'id,leute_id', '', '', TRUE);
	if(is_array($row)) {
		return $row["leute_id"];
	} else {
		return "";
	}
}



/**
  * Returns the person assigned to the currently logged in user
	* If an admin email is set for this login, this will be returned as the email field for this person (if admin=TRUE)
	*/
function ko_get_logged_in_person($admin=TRUE) {
	$lid = $_SESSION["ses_userid"];
	if(!$lid) return FALSE;

	$person = db_select_data("ko_admin AS a LEFT JOIN ko_leute as l ON a.leute_id = l.id",
												 "WHERE a.id = '$lid' AND (a.disabled = '0' OR a.disabled = '')",
												 "l.*, a.email AS admin_email",
												 '', '', TRUE);
	//Set email from one of the email fields if main email is not set
	if(!$person['email']) {
		ko_get_leute_email($person, $email);
		$person['email'] = $email;
	}
	//Overwrite person's email address with admin email from login
	if($admin && $person['admin_email']) $person['email'] = $person['admin_email'];

	return $person;
}



/**
  * Get date and time of the last login for a given login
	*
	* @param int user id. $_SESSION["ses_userid"] is being used not given
	* @return datetime SQL datetime value of last login
	*/
function ko_get_last_login($uid="") {
	$uid = $uid ? $uid : $_SESSION["ses_userid"];
	if(!$uid) return FALSE;

	$row = db_select_data('ko_admin', "WHERE `id` = '".$_SESSION['ses_userid']."'", 'id,last_login', '', '', TRUE);
	if(is_array($row)) {
		return $row["last_login"];
	} else {
		return "";
	}
}//ko_get_last_login()




/**
	* Get the id of the special login ko_guest
	*
	* @return int user id of ko_guest
	*/
function ko_get_guest_id() {
	if($GLOBALS["kOOL"]["guest_id"]) return $GLOBALS["kOOL"]["guest_id"];

	$row = db_select_data('ko_admin', "WHERE `login` = 'ko_guest'", 'id', '', '', TRUE);
	if(is_array($row)) {
		$GLOBALS["kOOL"]["guest_id"] = $row["id"];
		return $row["id"];
	} else {
		return FALSE;
	}
}



/**
	* Get the id of the special login root
	*
	* @return int user id of root
	*/
function ko_get_root_id() {
	if($GLOBALS["kOOL"]["root_id"]) return $GLOBALS["kOOL"]["root_id"];

	$row = db_select_data('ko_admin', "WHERE `login` = 'root'", 'id', '', '', TRUE);
	if(is_array($row)) {
		$GLOBALS["kOOL"]["root_id"] = $row["id"];
		return $row["id"];
	} else {
		return FALSE;
	}
}



/*
 * Get a setting from ko_settings
 *
 * @param string Key to get setting for
 * @return mixed Value for the specified key
 */
function ko_get_setting($key) {
	//Get from cache
	if(isset($GLOBALS["kOOL"]["ko_settings"][$key])) return $GLOBALS["kOOL"]["ko_settings"][$key];

	$query = "SELECT `value` from `ko_settings` WHERE `key` = '$key' LIMIT 1";
	$result = mysql_query($query);
	$row = mysql_fetch_row($result);
	$GLOBALS["kOOL"]["ko_settings"][$key] = $row[0];
	return $row[0];
}//ko_get_setting()


/*
 * Stores a setting in ko_settings
 *
 * @param string Key of the setting to be stored
 * @param mixed Value to be stored
 * @return boolean True on succes, false on failure
 */
function ko_set_setting($key, $value) {
	//Auf vorhandenen Settings-Eintrag "key" berprfen
	if(db_get_count('ko_settings', 'key', "AND `key` = '$key'") == 0) {
		return FALSE;  //Keine neuen Settings definieren lassen
	}

	db_update_data('ko_settings', "WHERE `key` = '$key'", array('value' => format_userinput($value, 'text')));
	$GLOBALS["kOOL"]["ko_settings"][$key] = $value;

	return TRUE;
}//ko_set_setting()



/**
	* Get a user preference as stored in ko_userprefs
	*
	* @param int user id
	* @param string Key of user preference
	* @param string Type of user preference to get
	* @param string ORDER BY statement to pass to the db
	* @return mixed Value of user preference
	*/
function ko_get_userpref($id, $key="", $type="", $order="") {
	if($type != "") {
		if($key != "") {
			//Look up userpref in GLOBALS
			if($id == $_SESSION["ses_userid"] && isset($GLOBALS["kOOL"]["ko_userprefs"]["TYPE@".$type][$key]))
				return array($GLOBALS["kOOL"]["ko_userprefs"]["TYPE@".$type][$key]);
			//Get it from DB if not set
			$query = "SELECT * FROM `ko_userprefs` WHERE `user_id` = '$id' AND `key` = '$key' AND `type` = '$type' $order";
		} else {
			//Look up userpref in GLOBALS
			if($id == $_SESSION["ses_userid"] && is_array($GLOBALS["kOOL"]["ko_userprefs"]["TYPE@".$type]))
				return $GLOBALS["kOOL"]["ko_userprefs"]["TYPE@".$type];
			//Get it from DB if not set
			$query = "SELECT * FROM `ko_userprefs` WHERE `user_id` = '$id' AND `type` = '$type' $order";
		}
		$result = mysql_query($query);
		while($row = mysql_fetch_assoc($result)) {
			$r[] = $row;
		}
		return $r;
	} else {
		//Look up userpref in GLOBALS
		if($id == $_SESSION["ses_userid"] && isset($GLOBALS["kOOL"]["ko_userprefs"][$key]))
			return $GLOBALS["kOOL"]["ko_userprefs"][$key];
		//Get it from DB if not set
		$query = "SELECT * FROM `ko_userprefs` WHERE `user_id` = '$id' AND `key` = '$key' $order";
		$result = mysql_query($query);
		$row = mysql_fetch_assoc($result);
		return $row['value'];
	}
}//ko_get_userpref()


/**
	* Store a user preference in ko_userprefs
	*
	* @param int user id
	* @param string Key of user preference
	* @param mixed Value to be stored
	* @param string Type of user preference to store
	*/
function ko_save_userpref($id, $key, $value, $type="") {
	$id = format_userinput($id, "int");
	$key = format_userinput($key, "text");
	$type = format_userinput($type, "alphanum+");

	//Store in db
	if(db_get_count('ko_userprefs', 'key', "AND `user_id`= '$id' AND `key` = '$key' AND `type` = '$type'") == 1) {
		db_update_data('ko_userprefs', "WHERE `user_id` = '$id' AND `key` = '$key' AND `type` = '$type'", array('value' => $value));
  } else {  //...sonst neues einfgen
		db_insert_data('ko_userprefs', array('user_id' => $id, 'type' => $type, 'key' => $key, 'value' => $value));
  }

	//Save in GLOBALS as well (but only for logged in user)
	if($id == $_SESSION["ses_userid"]) {
		if($type != "") {
			$GLOBALS["kOOL"]["ko_userprefs"]["TYPE@".$type][$key] = array("type" => $type, "key" => $key, "value" => $value);
		} else {
			$GLOBALS["kOOL"]["ko_userprefs"][$key] = $value;
		}
	}
}//ko_save_userpref()


/**
	* Delete a user preference
	*
	* @param int user id
	* @param string Key to be deleted
	* @param string Type of preference to be deleted
	*/
function ko_delete_userpref($id, $key, $type="") {
	$id = format_userinput($id, "int");
	$key = format_userinput($key, "text");
	$type = format_userinput($type, "alphanum+");

	//Delete from DB
	db_delete_data('ko_userprefs', "WHERE `user_id` = '$id' AND `key` = '$key' AND `type` = '$type'");

	//Delete from cache
	if($type != '') {
		unset($GLOBALS['kOOL']['ko_userprefs']['TYPE@'.$type][$key]);
	} else {
		unset($GLOBALS['kOOL']['ko_userprefs'][$key]);
	}
}//ko_delete_userpref()


/**
	* Checks whether a given user preference is set in ko_userprefs
	*
	* @param int user id
	* @param string Key to be checked for
	* @param string Type of preference to be checked for
	*/
function ko_check_userpref($id, $key, $type="") {
	$id = format_userinput($id, "int");
	$key = format_userinput($key, "text");
	$type = format_userinput($type, "alphanum+");

	if($type != "") {
		$query = "SELECT `key`, `value` FROM `ko_userprefs` WHERE `user_id` = '$id' AND `key` = '$key' AND `type` = '$type'";
		$result = mysql_query($query);
		$row = mysql_fetch_assoc($result);
	} else {
		$query = "SELECT `value` FROM `ko_userprefs` WHERE `user_id` = '$id' AND `key` = '$key'";
		$result = mysql_query($query);
		$row = mysql_fetch_assoc($result);
	}
	return (sizeof($row) >= 1);
}//ko_check_userpref()








/************************************************************************************************************************
 *                                                                                                                      *
 * FILTER                                                                                                               *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
	* Returns a single filter from ko_filter
	*
	* @param int Filter id
	* @param array Filter
	*/
function ko_get_filter_by_id($id, &$f) {
	ko_get_filters($all_filters, "leute", TRUE);
	$f = $all_filters[$id];
}//ko_get_filter_by_id()


/**
	* Get filters by type (e.g. type="leute")
	*
	* @param array Filters
	* @param string Type of filters to get
	* @param boolean Get all filter if true, if false only get the allowed filters for the logged in user
	*/
function ko_get_filters(&$f, $typ, $get_all=FALSE) {
	if(isset($GLOBALS['kOOL']['ko_filter'][$typ][($get_all?'all':'notall')])) {
		$f = $GLOBALS['kOOL']['ko_filter'][$typ][($get_all?'all':'notall')];
		return;
	}

	//Prepare the filters, that are not to be display because this user is not allowed to view this column
	$allowed_cols = ko_get_leute_admin_spalten($_SESSION["ses_userid"], "all");
	if(is_array($allowed_cols["view"]) && sizeof($allowed_cols["view"]) > 0 && ko_module_installed("groups", $_SESSION["ses_userid"])) {
		$allowed_cols["view"] = array_merge($allowed_cols["view"], array("groups", "roles"));
	}
	//Add column event, which is used for the rota filter
	if(is_array($allowed_cols['view']) && sizeof($allowed_cols['view']) > 0 && ko_module_installed('dp', $_SESSION['ses_userid'])) {
		$allowed_cols['view'] = array_merge($allowed_cols['view'], array('event'));
	}

	$f = $_f = array();
	$rows = db_select_data('ko_filter', "WHERE `typ` = '$typ'", '*', 'ORDER BY `name` ASC');
	foreach($rows as $row) {
		if($row['name'] == 'donation' && !ko_module_installed('donations', $_SESSION['ses_userid'])) continue;
		//Don't return filters for columns, that are not allowed
		if(!$get_all && (is_array($allowed_cols["view"]) && sizeof($allowed_cols["view"]) > 0)) {
			$sql = ko_get_filter_column($row["sql1"]);
			if(!in_array($sql, $allowed_cols["view"]) && !in_array($sql, array("kg", "kg_leiter"))) continue;

			if($sql == "kg" || $sql == "kg_leiter") {
				if(ko_get_access_all('kg_admin') < 1) continue;
			}
		}

		//special filters for other tables
		for($i=1; $i<4; $i++) {
			if(substr($row["code$i"], 0, 4) == "FCN:") {
				$fcn = substr($row["code$i"], 4);
				if(strpos($fcn, ":")) {  //Find parameters given along with the function name (e.g. used for enum_ll)
					$params = explode(":", $fcn);
					$fcn = $params[0];
					if(function_exists($fcn)) eval("$fcn(\$code, \$params);");
				} else {
					if(function_exists($fcn)) eval("$fcn(\$code);");
				}
				$row["code$i"] = $code;
			}
		}

		//Locallang-values if set
		$ll_name = getLL("filter_".$row["name"]);
		foreach(array("var1", "var2", "var3") as $var) {
			$ll_var = getLL("filter_".$var."_".$row["name"]);
			$row[$var] = $ll_var ? $ll_var : ($ll_name ? $ll_name : $row[$var]);
		}
		$row["_name"] = $row["name"];  //Keep name as in db table for comparisons
		$row["name"] = $ll_name ? $ll_name : $row["name"];

		$_f[$row["id"]] = $row;

		//prepare for ll sorting
		$filter_sort[$row["id"]] = $row["name"];
	}

	//Sort filters by the localized name
	asort($filter_sort);
	foreach($filter_sort as $id => $name) {
		$f[$id] = $_f[$id];
	}

	$GLOBALS['kOOL']['ko_filter'][$typ][($get_all?'all':'notall')] = $f;
}//ko_get_filters()



/**
  * Tries to find the column a filter is applied to
	*
	* Will be obsolete soon, after storing this information in a new db column in ko_filter
	*/
function ko_get_filter_column($sql) {
	$remove = explode(",", "(,),1,2,3,4,5,6,7,8,9,0,A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z,-,>,<,=,+,*,/,[,],',`, ");
	while(strlen($sql) > 0 && in_array(substr($sql, 0, 1), $remove)) $sql = substr($sql, 1);

	$keep = explode(",", "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,_,1,2,3,4,5,6,7,8,9,0");
	for($i=0; $i<strlen($sql); $i++) {
		if(!in_array(substr($sql, $i, 1), $keep)) {
			$sql = substr($sql, 0, $i);
		}
	}
	return $sql;
}//ko_get_filter_column()



/**
  * Generate a special filter for group datafields
	*
	* This function is called by the filter for group datafields by a FCN: definition in the SQL column
	* It generates the necessary code for the filter dynamically
	*
	* @param string HTML code for the filter
	*/
function ko_specialfilter_groupdatafields(&$code) {
	global $all_groups;

	if(!is_array($all_groups)) {
		ko_get_groups($all_groups);
	}

	$code = '<select name="var1" size="0" onchange="sendReq('."'../groups/inc/ajax.php', 'action,dfid,sesid', 'groupdatafieldsfilter,'+this.options[this.selectedIndex].value+',".session_id()."', do_element);".'">';
	$code .= '<option value=""></option>';

	//get reusable first
	$dfs = db_select_data("ko_groups_datafields", "WHERE `reusable` = '1'", "*", "ORDER BY description ASC");
	foreach($dfs as $df) {
		$code .= '<option value="'.$df["id"].'">'.$df["description"].'</option>';
	}

	//add group specific afterwards
	$dfs = db_select_data("ko_groups_datafields", "WHERE `reusable` = '0'", "*", "ORDER BY description ASC");
	foreach($dfs as $df) {
		//find first group, this datafield is used in and use this a description
		$group_name = "";
		foreach($all_groups as $group) {
			if(strstr($group["datafields"], $df["id"])) {
				$group_name = $group["name"];
				break;
			}
		}
		//Don't display unused datafields
		if(!$group_name) continue;

		$code .= '<option value="'.$df["id"].'">'.ko_html($df["description"])." (".$group_name.')</option>';
	}
	$code .= '</select>';
}//ko_specialfilter_groupdatafields()


/**
  * Generate a special filter for smallgroup regions
	*
	* This function is called by the filter for smallgroup regions by a FCN: definition in the SQL column
	* It generates the necessary code for the filter dynamically
	*
	* @param string HTML code for the filter
	*/
function ko_specialfilter_kleingruppen_region(&$code) {
	$code = '<select name="var1" size="0"><option value=""></option>';
	$rows = db_select_distinct("ko_kleingruppen", "region", "", "", TRUE);
	foreach($rows as $row) {
		if(!$row) continue;
		$code .= '<option value="'.$row.'">'.ko_html($row).'</option>';
	}
	$code .= '</select>';
}//ko_spcialfilter_kleingruppen_region()


/**
  * Generate a special filter for smallgroup types
	*
	* This function is called by the filter for smallgroup types by a FCN: definition in the SQL column
	* It generates the necessary code for the filter dynamically
	*
	* @param string HTML code for the filter
	*/
function ko_specialfilter_kleingruppen_type(&$code) {
	$code = '<select name="var1" size="0"><option value=""></option>';
	$rows = db_select_distinct("ko_kleingruppen", "type", "", "", TRUE);
	foreach($rows as $row) {
		if(!$row) continue;
		$code .= '<option value="'.$row.'">'.ko_html($row).'</option>';
	}
	$code .= '</select>';
}//ko_spcialfilter_kleingruppen_type()


/**
  * Generate a special filter for the family role of ko_leute
	*
	* @param string HTML code for the filter
	*/
function ko_specialfilter_enum_ll(&$code, $params) {
	//Parse parameters (0 is function name)
	$table = $params[1];
	$col = $params[2];

	$code = '<select name="var1" size="0"><option value=""></option>';
	$rows = db_get_enums_ll($table, $col);
	foreach($rows as $key => $value) {
		if(!$key) continue;
		$code .= '<option value="'.$key.'">'.$value.'</option>';
	}
	$code .= '</select>';
}//ko_spcialfilter_enum_ll()



function ko_specialfilter_rota(&$code) {
	global $DATETIME;

	ko_get_eventgruppen($grps);

	$code = '<select name="var1" size="0">';
	$events = db_select_data("ko_event", "WHERE `dp` = '1' AND `startdatum` > NOW()", "*", "ORDER BY startdatum ASC, eventgruppen_id ASC", "LIMIT 0,30");
	foreach($events as $event) {
		$value  = strftime($DATETIME["dmy"], strtotime($event["startdatum"]));
		$value .= ": ".$grps[$event["eventgruppen_id"]]["name"];
		$code .= '<option value="'.$event["id"].'">'.$value.'</option>';
	}
	$code .= '</select>';
}//ko_specialfilter_rota()



function ko_specialfilter_filterpreset(&$code) {
	$filterset = array_merge((array)ko_get_userpref('-1', '', 'filterset', 'ORDER BY `key` ASC'), (array)ko_get_userpref($_SESSION['ses_userid'], '', 'filterset', 'ORDER BY `key` ASC'));

	$code = '<select name="var1" size="0">';
	foreach($filterset as $f) {
		$value = $f['user_id'] == '-1' ? '@G@'.$f['key'] : $f['key'];
		$desc = $f['user_id'] == '-1' ? getLL('itemlist_global_short').' '.$f['key'] : $f['key'];
	  $code .= '<option value="'.$value.'">'.$desc.'</option>';
	}
	$code .= '</select>';
}//ko_specialfilter_filterpreset()



function ko_specialfilter_crdate(&$code, $params) {
	foreach($_SESSION["filter"] as $i => $f) {
		if(!is_numeric($i)) continue;
		$filter = db_select_data("ko_filter", "WHERE `id` = '".$f[0]."'", "*", "", "", TRUE);
		if($filter["name"] == "crdate") {
			$value1 = $f[1][1];
			$value2 = $f[1][2];
		}
	}

	if($params[1] == 1) {
		$value1 = $value1 ? $value1 : "0000-00-00";
		$code = '<input type="text" name="var1" size="12" maxlength="10" onkeydown="if ((event.which == 13) || (event.keyCode == 13)) { this.form.submit_filter.click(); return false;} else return true;" value="'.$value1.'" />';
	} else if($params[1] == 2) {
		$value2 = $value2 ? $value2 : strftime("%Y-%m-%d", time());
		$code = '<input type="text" name="var2" size="12" maxlength="10" onkeydown="if ((event.which == 13) || (event.keyCode == 13)) { this.form.submit_filter.click(); return false;} else return true;" value="'.$value2.'" />';
	}

}//ko_specialfilter_crdate()




function ko_specialfilter_donation(&$code) {
	$code = '<select name="var1" size="0">';
	$rows = db_select_distinct('ko_donations', 'YEAR(date)');
	foreach($rows as $row) {
		if(!$row) continue;
		$code .= '<option value="'.$row.'">'.ko_html($row).'</option>';
	}
	$code .= '</select>';
}//ko_spcialfilter_donation()





function ko_specialfilter_donation_account(&$code) {
	$code = '<select name="var2" size="0"><option value=""></option>';
	$rows = db_select_data('ko_donations_accounts', 'WHERE 1=1', '*');
	foreach($rows as $row) {
		$code .= '<option value="'.$row['id'].'">'.ko_html($row['number'].' '.$row['name']).'</option>';
	}
	$code .= '</select>';
}//ko_spcialfilter_donation_account()







/************************************************************************************************************************
 *                                                                                                                      *
 * MODUL-FUNKTIONEN   D A T E N                                                                                         *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
	* Get all calendars
	*/
function ko_get_event_calendar(&$r, $id="", $type="") {
	$z_where = "WHERE 1=1 ";
	if($id) $z_where .= " AND `id` = '$id' ";
	if($type) $z_where .= " AND `type` = '$type' ";

	$r = db_select_data('ko_event_calendar', $z_where, '*', 'ORDER BY name ASC');
}//ko_get_event_calendar()

/**
	* Liefert alle Eventgruppen
	*/
function ko_get_eventgruppen(&$grp, $z_limit = "", $z_where = "") {
	$order = ($_SESSION["sort_tg"]) ? " ORDER BY ".$_SESSION["sort_tg"]." ".$_SESSION["sort_tg_order"] : " ORDER BY name ASC ";
	$grp = db_select_data('ko_eventgruppen', "WHERE 1=1 $z_where", '*', $order, $z_limit);
}//ko_get_eventgruppen()


/**
	* Liefert einzelne Eventgruppe
	*/
function ko_get_eventgruppe_by_id($gid, &$grp) {
	$grp = db_select_data('ko_eventgruppen', "WHERE `id` = '$gid'", '*', '', 'LIMIT 1', TRUE);
}//ko_get_eventgruppe_by_id()


/**
	* Liefert die Farbe, die einer Eventgruppe zugewiesen ist
	*/
function ko_get_eventgruppen_farbe($id) {
	$row = db_select_data('ko_eventgruppen', "WHERE `id` = '$id'", 'farbe', '', '', TRUE);
	return $row['farbe'];
}//ko_get_eventgruppen_farbe()


/**
	* Liefert den Namen, der einer Eventgruppe zugewiesen ist
	*/
function ko_get_eventgruppen_name($id) {
	$row = db_select_data('ko_eventgruppen', "WHERE `id` = '$id'", 'name', '', '', TRUE);
	return $row['name'];
}//ko_get_eventgruppen_name()


/**
	* Liefert die Reservations-Items, die einer Eventgruppe zugeordnet sind
	*/
function ko_get_eventgruppen_resitems($id) {
	$row = db_select_data('ko_eventgruppen', "WHERE `id` = '$id'", 'resitems', '', '', TRUE);
	return $row['resitems'];
}//ko_get_eventgruppen_resitems()


/**
	* Liefert einzelnen Event
	*/
function ko_get_event_by_id($id, &$e) {
	$e = db_select_data('ko_event', "WHERE `id` = '$id'", '*', '', '', TRUE);
}//ko_get_event_by_id()


/**
	* Liefert alle Events
	*/
function ko_get_events(&$e, $z_where = '', $z_limit = '', $table='ko_event', $z_sort='') {
	$e = array();

	if($z_sort) $order = $z_sort;
	else $order = $_SESSION["sort_events"] ? " ORDER BY ".($_SESSION["sort_events"] == "eventgruppen_id" ? "eventgruppen_name" : $_SESSION["sort_events"])." ".$_SESSION["sort_events_order"].",startzeit ".$_SESSION["sort_events_order"] : " ORDER BY startdatum ASC,startzeit ASC";
	$e = db_select_data($table.' AS e LEFT JOIN ko_eventgruppen AS tg ON e.eventgruppen_id = tg.id', 'WHERE 1=1 '.$z_where, 'e.id AS id, e.*, tg.name AS eventgruppen_name, tg.farbe AS eventgruppen_farbe, tg.res_combined AS res_combined', $order, $z_limit);
}//ko_get_events()


/**
	* Liefert alle zu moderierenden Events
	*/
function ko_get_events_mod(&$e, $z_where = "", $z_limit = "") {
	ko_get_events($e, $z_where, $z_limit, 'ko_event_mod');
}//ko_get_events_mod()


/**
	* Liefert alle Events an einem Datum
	*/
function ko_get_events_by_date($t="", $m, $j, &$r, $z_where="", $table="ko_event") {
	$datum = $j."-".str_to_2($m)."-".($t?str_to_2($t):"01");

	$r = db_select_data($table.' AS e LEFT JOIN ko_eventgruppen AS tg ON e.eventgruppen_id = tg.id', "WHERE (`startdatum` <= '$datum' AND `enddatum` >= '$datum') $z_where", 'e.id AS id, e.*, tg.name AS eventgruppen_name', 'ORDER BY `startdatum` ASC, `startzeit` ASC');
}//ko_get_events_by_date()






function kota_ko_event_eventgruppen_id_dynselect(&$values, &$descs, $rights=0, $_where="") {
	global $access;

	$values = $descs = array();
	$cals = db_select_data("ko_event_calendar", "WHERE 1=1", "*", "ORDER BY `name` ASC");
	foreach($cals as $cid => $cal) {
		if($access['daten']['cal'.$cid] < $rights) continue;
		//Add cal name (as optgroup)
		$descs["i".$cid] = $cal["name"];
		//Get groups for this cal
		$where = "WHERE `calendar_id` = '$cid' ";
		$where .= $_where;
		$groups = db_select_data("ko_eventgruppen", $where, "*", "ORDER BY `name` ASC");
		foreach($groups as $gid => $group) {
			$values["i".$cid][$gid] = $gid;
			$descs[$gid] = $group["name"];
		}
	}//foreach(cals)
	//Add all event groups without calendars
	$groups = db_select_data("ko_eventgruppen", "WHERE `calendar_id` = '0'", "*", "ORDER BY `name` ASC");
	foreach($groups as $gid => $group) {
		if($access['daten'][$gid] < $rights) continue;
		$values[$gid] = $gid;
		$descs[$gid] = $group["name"];
	}
}//kota_ko_event_eventgruppen_id_dynselect()




/**
	* Find moderators for a given event group
	*/
function ko_get_moderators_by_eventgroup($gid) {
	//Get moderators for this event group
	$mods = db_select_data("ko_admin AS a LEFT JOIN ko_leute as l ON a.leute_id = l.id",
												 "WHERE (a.event_admin REGEXP '^4(,|$)' OR a.event_admin REGEXP '(^|,)4@$gid(,|$)') AND (l.email != '' OR a.email != '') AND (a.disabled = '0' OR a.disabled = '')",
												 "a.id AS id, a.event_admin, l.email AS email, a.email AS admin_email, l.id AS leute_id");
	foreach($mods as $i => $mod) {
		if($mod['admin_email']) $mods[$i]['email'] = $mod['admin_email'];
	}

	return $mods;
}//ko_get_moderators_by_eventgroup()











/************************************************************************************************************************
 *                                                                                                                      *
 * MODUL-FUNKTIONEN   L E U T E                                                                                         *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
	* Liefert eine Liste alle vorkommenden Lnder in der Personen-Daten
	*/
function ko_get_all_countries(&$c) {
	$c = db_select_distinct('ko_leute', 'land', '', "WHERE `deleted` = '0'");
}//ko_get_all_countries()



/**
	* Liefert Personen-Daten
	*/
function ko_get_leute(&$p, $z_where = "", $z_limit = "", $z_cols = "", $z_sort = "", $apply_version=TRUE) {
	global $ko_menu_akt;

	//only apply sorting if not a MODULE-column is to be sorted
	if(is_string($z_sort) && !empty($z_sort)) {
		$sort = $z_sort;
	} else if(is_array($_SESSION["sort_leute"]) && is_array($_SESSION["sort_leute_order"])) {
		$sort_add = array();
		foreach($_SESSION["sort_leute"] as $i => $col) {
			if(substr($col, 0, 6) != "MODULE") {
				$sort_add[] = $col." ".$_SESSION["sort_leute_order"][$i];
			}
		}
		if(!in_array("nachname", $_SESSION["sort_leute"])) $sort_add[] = "nachname ASC";
		if(!in_array("vorname", $_SESSION["sort_leute"])) $sort_add[] = "vorname ASC";
		$sort = "ORDER BY ".implode(", ", $sort_add);
	} else {
		$sort = "";
	}

	//Decide on the columns to get
	if($z_cols != "") {
		$cols = $z_cols;
	} else {
		$cols = "*";
	}

	//Unset z_limit if an old version is to be retrieved
	$limit = FALSE;
	if($_SESSION["leute_version"] && $z_limit && $apply_version) {
		list($limit_start, $limit) = explode(", ", str_replace("LIMIT ", "", $z_limit));
		$z_limit = "";
	}

	//Perform query
	$p = array();
	$count = 0;
	$rows = db_select_data('ko_leute', 'WHERE 1=1 '.$z_where, $cols, $sort, $z_limit);
	$num = sizeof($rows);
	foreach($rows as $row) {
		//Get old version of person if set
		if($_SESSION["leute_version"] && $apply_version) {
			//Apply limit manually if z_limit was set but old version is displayed
			if($limit && ($count < $limit_start || $count >= $limit)) continue;
			//Don't show records with crdate greater than the given date. Display all those with no crdate (backwards compatibilty and safer)
			if(strtotime($row["crdate"]) > strtotime($_SESSION["leute_version"]." 23:59:59")) {
				$num--;
				continue;
			}
			//Get old version
			$old = ko_leute_get_version($_SESSION["leute_version"], $row["id"]);
			$hid = strpos(ko_get_leute_hidden_sql(), "hidden = '0'");
			if($old["deleted"] == 1 || ($hid && $old["hidden"] == 1) ) {
				//Don't display old version that used to be deleted or hidden when hidden entries are to be invisible
				$num--;
				continue;
			} else {
				if(isset($old["id"])) {  //old entry found
					$p[$row["id"]] = $old;
				} else if($row["deleted"] == 0) {  //no old entry so display current if not deleted
					$p[$row["id"]] = $row;
				} else {
					//Don't display currently deleted entries with no old version
					$num--;
					continue;
				}
			}
		}
		//Normal case, so just store current entry as it is in ko_leute
		else {
			$p[$row["id"]] = $row;
		}
	}
	return $num;
}//ko_get_leute()



function ko_manual_sorting($cols) {
	if($_SESSION["leute_version"]) {
		return TRUE;
	} else {
		$manual_columns = array('kg', 'kg_leiter', 'dienst', 'dienstleiter', 'famid', 'famfunction');
		foreach($cols as $col) {
			if(in_array($col, $manual_columns) || substr($col, 0, 6) == "MODULE") {
				return TRUE;
			}
		}
	}
	return FALSE;
}//ko_manual_sorting()



/**
  * Liefert Familien-Daten zu Familien-ID
	*/
function ko_get_familie($id) {
	if(!is_numeric($id)) return FALSE;

	$fam = db_select_data('ko_familie', "WHERE `famid` = '$id'", '*', '', 'LIMIT 1', TRUE);
	ko_add_fam_id($fam);

	return $fam;
}//ko_get_fmailie()



/**
  * Fgt eine Familien-ID bestehend aus Nachname, Ort und Vornamen zur bergebenen Familie
	*/
function ko_add_fam_id(&$fam, $_members="") {
	global $COLS_LEUTE_UND_FAMILIE, $FAMFUNCTION_SORT_ORDER;

	$max_len = 12;

	if($_members) {
		$members = $_members;
		$num_members = sizeof($members);
	} else {
		$num_members = ko_get_personen_by_familie($fam["famid"], $members);
	}
	//order members by Father, Mother, Kids
	$new_members = array();
	foreach($members as $i => $member) {
		$sort_members[($FAMFUNCTION_SORT_ORDER[$member["famfunction"]] ? $FAMFUNCTION_SORT_ORDER[$member["famfunction"]] : 10)][$i] = $member["nachname"];
	}
	if(sizeof($sort_members[1]) > 0) {
		ksort($sort_members[1]);   //Man
		foreach($sort_members[1] as $k => $v) $new_members[] = $members[$k];
	}
	if(sizeof($sort_members[2]) > 0) {
		ksort($sort_members[2]);   //Woman
		foreach($sort_members[2] as $k => $v) $new_members[] = $members[$k];
	}
	if(sizeof($sort_members[3]) > 0) {
		ksort($sort_members[3]);   //Children
		foreach($sort_members[3] as $k => $v) $new_members[] = $members[$k];
	}
	if(sizeof($sort_members[10]) > 0) {
		ksort($sort_members[10]);  //No famfunction defined
		foreach($sort_members[10] as $k => $v) $new_members[] = $members[$k];
	}
	$members = $new_members;
	reset($members);

	//lastname
	if(in_array("nachname", $COLS_LEUTE_UND_FAMILIE)) {
		//normal families, with lastname as a family field
		$famlastname = $fam["nachname"];
	} else {
		//mixed families with different lastnames
		$famnames = array();
		foreach($members as $member) {
			if(!in_array($member["nachname"], $famnames)) $famnames[] = $member["nachname"];
		}
		$famlastname = implode("-", $famnames);
	}
	//city
	if($fam["ort"]) {
		$famcity = strlen($fam["ort"]) > $max_len ? substr($fam["ort"], 0, $max_len).".." : $fam["ort"];
		$famcity = getLL("from")." ".$famcity;
	}
	//single members of the family
	$fammembers = "";
	if($num_members > 0) {
		foreach($members as $p) {
			$fammembers .= strtoupper(substr($p["vorname"], 0, 1)).",";
		}
		$fammembers = "(".substr($fammembers, 0, -1).")";
	}//if(num_members>0)

	//put it all together into the new fam-id
	$fam["id"] = $famlastname." ".$famcity." ".$fammembers;
	//save lastname in family, even if lastname is not a family field. This makes the export work with lastnames
	if(!in_array("nachname", $COLS_LEUTE_UND_FAMILIE)) $fam["nachname"] = $famlastname;
}//ko_add_fam_id()



/**
  * Liefert alle Familien
	* inkl. ID
	*/
function ko_get_familien(&$fam) {
	global $ko_menu_akt;

	$fam = array();

	//Get all families
	$query = "SELECT * FROM ko_familie ORDER BY nachname ASC";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$fam[$row["famid"]] = $row;
	}

	//Get all family members once, so they don't have to be retrieved inside the loop
	$members = array();
	$deleted = ($ko_menu_akt == "leute" && ko_get_userpref($_SESSION["ses_userid"], "leute_show_deleted") == 1) ? " AND `deleted` = '1' " : " AND `deleted` = '0' ";
	$deleted .= ko_get_leute_hidden_sql();
	$result = mysql_query("SELECT * FROM ko_leute WHERE `famid` != '0' $deleted ORDER BY `famid` ASC");
	while($row = mysql_fetch_assoc($result)) {
		$members[$row["famid"]][] = $row;
	}

	//Add family ID
	foreach($fam as $i => $f) {
		ko_add_fam_id($fam[$i], $members[$f["famid"]]);
		$sort[$fam[$i]["id"]] = $fam[$i]["famid"];
	}//foreach(fam)

	//sort them by famid which is constructed by all the lastnames
	ksort($sort, SORT_LOCALE_STRING);
	$return = NULL;
	foreach($sort as $famid) {
		$return[$famid] = $fam[$famid];
	}
	$fam = $return;
}//ko_get_familien()



/**
  * Aktualisiert eine Familie mit den bergebenen Fam-Daten
	* und aktualisiert alle Member
	*/
function ko_update_familie($famid, $fam_data, $leute_id="") {
	global $FAMILIE_EXCLUDE;

	$data = array();
	$fam_cols = db_get_columns("ko_familie");
	foreach($fam_cols as $col_) {
		$col = $col_["Field"];
		if(in_array($col, $FAMILIE_EXCLUDE)) continue;
		if(!isset($fam_data[$col])) continue;

		$query1 .= "`$col` = '".$fam_data[$col]."', ";
		$data[$col] = $fam_data[$col];
	}//foreach(fam_cols as col)
	if(sizeof($data) == 0) return;

	//Familien-Daten aktualisieren
	db_update_data('ko_familie', "WHERE `famid` = '$famid'", $data);

	//Alle Familien-Mitglieder aktualisieren
	ko_update_leute_in_familie($famid, $changes=TRUE, $leute_id);
}//ko_update_familie()



/**
  * Aktualisiert alle Member mit den Angaben aus der Familie
	* Only store changes to ko_leute_changes if second argument is set. This gets set in ko_update_familie()
	* The third argument defines the id of the person being saved, as no entry to ko_leute_changes must be saved (this is done in submit_edit_person in leute/index.php
	*/
function ko_update_leute_in_familie($famid, $do_changes=FALSE, $leute_id="") {
	global $COLS_LEUTE_UND_FAMILIE;

	if(!is_numeric($famid) || $famid <= 0) return FALSE;
	$fam_data = ko_get_familie($famid);

	$data = array();
	foreach($COLS_LEUTE_UND_FAMILIE as $col) {
		$data[$col] = $fam_data[$col];
	}

	//Kinder-Feld
	$num_kids = ko_get_personen_by_familie($famid, $members, "child");

	//Daten aller Family-Members aktualisieren
	ko_get_personen_by_familie($famid, $members);
	foreach($members as $m) {
		//store version
		if($do_changes && $leute_id != $m["id"]) {
			ko_save_leute_changes($m["id"]);
		}
		//Update according to fam data
		if($m["famfunction"] == "husband" || $m["famfunction"] == "wife") {
			$data['kinder'] = $num_kids;
		} else {
			$data['kinder'] = '0';
		}
		db_update_data('ko_leute', "WHERE `id` = '".$m['id']."'", $data);
	}
}//ko_update_leute_in_familie()



/**
	* Liefert einzelne Person
	*/
function ko_get_person_by_id($id, &$p) {
	global $ko_menu_akt;

	if(!is_numeric($id)) return FALSE;

	$deleted = ($ko_menu_akt == "leute" && ko_get_userpref($_SESSION["ses_userid"], "leute_show_deleted") == 1) ? " AND `deleted` = '1' " : " AND `deleted` = '0' ";

	$p = db_select_data('ko_leute', "WHERE `id` = '$id' $deleted", '*', '', '', TRUE);
}//ko_get_person_by_id()




/**
  * Get the name belonging to a person's id
	*/
function ko_get_person_name($id, $format="vorname nachname") {
	ko_get_person_by_id($id, $p);
	return strtr($format, $p);
}//ko_get_person_name()



/**
  * Liefert alle Personen einer Familie
	*/
function ko_get_personen_by_familie($famid, &$p, $function="") {
	if(!is_numeric($famid) || $famid <= 0) return FALSE;
	$p = array();

	if($function != "" && in_array($function, db_get_enums("ko_leute", "famfunction"))) {
		$z_where = " AND `famfunction` = '$function'";
	} else $z_where = "";

	$p = db_select_data('ko_leute', "WHERE `famid` = '$famid' $z_where", '*', 'ORDER BY famfunction DESC');

	return sizeof($p);
}//ko_get_personen_by_familie()



/**
	* Liefert eine Liste aller (oder wenn id definiert ist nur diesen Eintrag) zu moderierenden Mutationen (aus Tabelle ko_leute_mod)
	*/
function ko_get_mod_leute(&$r, $id="") {
	$r = array();
	$z_where  = "WHERE `_leute_id` <> '0'";  //don't show web-group-subscriptions
	$z_where .= ($id != "") ? " AND `_id`='$id'" : "";
	$query = "SELECT * FROM `ko_leute_mod` $z_where";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$r[$row["_id"]] = $row;
	}
}//ko_get_mod_leute()



/**
	* Liefert eine Liste aller (oder wenn id definiert ist nur diesen Eintrag) zu moderierenden Gruppen-Anmeldungen (aus Tabelle ko_leute_mod)
	*/
function ko_get_groupsubscriptions(&$r, $gsid="", $uid="") {
	global $access;

	// Group rights if uid is given
	if($uid > 0) {
		ko_get_access('groups');
	}

	// Get subscriptions
	$r = array();
	$z_where  = "WHERE `_leute_id` = '0'";  //don't show address changes
	$z_where .= ($gsid != "") ? " AND `_id`='$gsid'" : "";
	$query = "SELECT * FROM `ko_leute_mod` $z_where";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		if($uid) {
			// Only display subscriptions to groups the given user has level 2 access to
			if($access['groups']['ALL'] > 1 || $access['groups'][ko_groups_decode($row['_group_id'], 'group_id')] > 1) {
				$r[$row["_id"]] = $row;
			}
		} else {
			// Return them all if no userid is given
			$r[$row["_id"]] = $row;
		}
	}
}//ko_get_groupsubscriptions()



/**
 * Apply filter given in setting 'birthday_filter' and return SQL
 * To be attached to SQL to get birthday list
 */
function ko_get_birthday_filter() {
	$filter = unserialize(ko_get_setting('birthday_filter'));
	if(!$filter['value']) {
		return '';
	} else {
		apply_leute_filter(unserialize($filter['value']), $z_where);
		return ' '.$z_where;
	}
}//ko_get_birthday_filter()



/**
  * Liefert die Spaltennamen der ko_leute-DB
	* Zustzlich werden noch Module-Spaltennamen (wie z.B. Gruppen) hinzugefgt
	* mode kann view oder edit sein, jenachdem fr welchen Modus die Spalten gemss ko_admin.leute_admin_spalten verlangt sind
	*   (bei all wird auf den Vergleich mit allowed_cols verzichtet)
	*/
function ko_get_leute_col_name($groups_hierarchie=FALSE, $add_group_datafields=FALSE, $mode="view", $force=FALSE) {
	global $access;

	$r_all = unserialize(ko_get_setting("leute_col_name"));
	$r = $r_all[$_SESSION["lang"]];

	//exclude not allowed cols, if set
	$allowed_cols = ko_get_leute_admin_spalten($_SESSION["ses_userid"], "all");
	$always_allowed = array();
	if(ko_module_installed("groups", $_SESSION["ses_userid"])) $always_allowed[] = "groups";
	if(ko_module_installed("kg", $_SESSION["ses_userid"])) {
		$always_allowed[] = "kg";
		$always_allowed[] = "kg_leiter";
	}

	//Unset not allowed columns
	if($mode != "all") {
		if(is_array($allowed_cols[$mode]) && sizeof($allowed_cols[$mode]) > 0) {
			foreach($r as $i => $v) {
				if(in_array($i, $always_allowed)) continue;
				if(!in_array($i, $allowed_cols[$mode])) unset($r[$i]);
			}
		}
	}

	//Remove empty entries
	foreach($r as $k => $v) if(!$v) unset($r[$k]);

	if(!ko_module_installed("groups") && !$force) return $r;

	//Add groups
	ko_get_access('groups');
	$groups = ko_groups_get_recursive(ko_get_groups_zwhere());
	ko_get_groups($all_groups);
	foreach($groups as $group) {
		if($access['groups']['ALL'] < 1 && $access['groups'][$group['id']] < 1 && !$force) continue;
		$name = strlen($group["name"]) > ITEMLIST_LENGTH_MAX ? substr($group["name"], 0, ITEMLIST_LENGTH_MAX).".." : $group["name"];
		if($groups_hierarchie) {
			$depth = sizeof(ko_groups_get_motherline($group["id"], $all_groups));
			for($i=0; $i<$depth; $i++) $name = "&nbsp;&nbsp;".$name;
		}
		$r["MODULEgrp".$group["id"]] = $name;
		//add datafields for this group if needed
		if($add_group_datafields && $all_groups[$group["id"]]["datafields"] && (ko_get_userpref($_SESSION["ses_userid"], "show_group_datafields") || $force)) {
			foreach(explode(",", $all_groups[$group["id"]]["datafields"]) as $fid) {
				$field = db_select_data("ko_groups_datafields", "WHERE `id` = '$fid'", "id,description", "", "", TRUE);
				if(!$field["id"]) continue;
				$r["MODULEgrp".$group["id"].":".$fid] = $field["description"];
			}
		}
	}

	return $r;
}//ko_get_leute_col_name()




function ko_get_family_col_name() {
	$r_all = unserialize(ko_get_setting("familie_col_name"));
	$r = $r_all[$_SESSION["lang"]];

	return $r;
}//ko_get_family_col_name()



/**
  * Wendet die Leute-Filter an und gibt SQL-WHERE-Clause zurck
	* Ebenfalls verwendet, um Admin-Filter fr Berechtigungen anzuwenden
	* Muss in ko.inc stehen (und nicht in leute/inc/leute.inc), damit ko_get_admin() immer Zugriff darauf hat --> z.B. fr Dropdown-Mens
	*/
function apply_leute_filter($filter, &$where_code, $add_admin_filter=TRUE, $admin_filter_level="") {
	global $ko_menu_akt;

	//Innerhalb einer Filtergruppe werden die Filter mit OR verknpft
  $where_code = "";
  $q = array();
  if(is_array($filter)) {

		//Move addchildren filter to the end, so it will be applied as the last filter
		$new = array(); $last = FALSE;
		foreach($filter as $f_i => $f) {
			ko_get_filter_by_id($f[0], $f_);
			if(in_array($f_['_name'], array('addchildren', 'addparents'))) $last = $f;
			else $new[$f_i] = $f;
		}
		$filter = $new;
		if($last) $filter[] = $last;

		//Loop through all filters and build SQL
		foreach($filter as $f_i => $f) {
			if(!is_numeric($f_i)) continue;

			ko_get_filter_by_id($f[0], $f_);
			$f_typ = $f_['_name'];


			//Gruppen-, Rollen- und FilterVorlagen-Filter finden
			if($f_["_name"] == "group" || $f_["_name"] == "role" || $f_["_name"] == "filterpreset") {
				$link = $filter["link"] == "or" ? " OR " : " AND";
			} else {
				$link = "OR";
			}

			$f_sql = "";
			for($i = 1; $i <= sizeof($f[1]); $i++) {
				$f_sql_part = "";
				//Nur Leeres Argument erlauben, wenn es das einzige in diesem Filter ist
				if(sizeof($f[1]) == 1 || $f[1][$i] != "" || $f_["dbcol"] == "ko_groups_datafields_data.value") {

					//In jeder Zeile alle Werte VAR[1-3] ersetzen
					$trans = array(
							"[VAR1]" => format_userinput($f[1][1], "text"),
							"[VAR2]" => format_userinput($f[1][2], "text"),
							"[VAR3]" => format_userinput($f[1][3], "text")
					);
					$f_sql_part .= strtr($f_["sql$i"], $trans)." AND ";
																																
					//Leere Suchstrings gehen nur mit LIKE und nicht mit REGEXP!
					if($f[1][$i] == "") $f_sql_part = str_replace("REGEXP", "LIKE", $f_sql_part);
				}

				if(trim($f_sql_part) != "AND") $f_sql .= $f_sql_part;
			}


			//Alle AND's am Schluss entfernen (mehrere mglich!)
			while(substr(rtrim($f_sql), -4) == " AND") {
				$f_sql = substr(rtrim($f_sql), 0, -4);
			}

			//Handle group filter if old groups should not be displayed
			if($f_["_name"] == "group" && !ko_get_setting("show_passed_groups")) {
				ko_get_groups($all_groups);
				$not_leaves = db_select_distinct("ko_groups", "pid");
				$_gid = substr($f[1][1], 1);
				ko_get_groups($top, "AND `id` = '$_gid'");
				//Get subgroups of current group (if any) and exclude all with expired start and/or stop date
				$z_where = "AND ((`start` != '0000-00-00' AND `start` > NOW()) OR (`stop` != '0000-00-00' AND `stop` < NOW()))";
				rec_groups($top[$_gid], $children, $z_where, $not_leaves);
				foreach($children as $child) {
					//Get full id for child
					$motherline = ko_groups_get_motherline($child["id"], $all_groups);
					$mids = array();
					foreach($motherline as $mg) {
						$mids[] = "g".$all_groups[$mg]["id"];
					}
					$full_id = (sizeof($mids) > 0 ? implode(":", $mids).":" : "")."g".$child["id"];
					//Exclude children with expired start and/or stop date
					$f_sql .= ' AND `groups` NOT REGEXP '."'$full_id' ";
				}
			}
			//Add children filter
			if($f_['_name'] == 'addchildren') {
				//Clear all other filters if checkbox "only children" has been ticked
				if($f[1][3] == 'true') $q = array();
				//Apply all filters except for this one and get all famids for the filtered people
				$cf = $filter;
				unset($cf[$f_i]);
				apply_leute_filter($cf, $cwhere, $add_admin_filter, $admin_filter_level);
				$families = db_select_data('ko_leute', 'WHERE famid > 0 AND famfunction IN (\'husband\', \'wife\') '.$cwhere, 'id,famid');
				if(sizeof($families) == 0) {
					$f_sql = '';
				} else {
					$famids = array();
					foreach($families as $fam) $famids[] = $fam['famid'];
					$f_sql = " `famid` IN ('".implode("','", array_unique($famids))."') AND `famfunction` = 'child' ".($f_sql ? "AND ".$f_sql : '');
				}
			}
			//Add parents filter
			if($f_['_name'] == 'addparents') {
				//Clear all other filters if checkbox "only parents" has been ticked
				if($f[1][1] == 'true') $q = array();
				//Apply all filters except for this one and get all famids for the filtered people
				$cf = $filter;
				unset($cf[$f_i]);
				apply_leute_filter($cf, $cwhere, $add_admin_filter, $admin_filter_level);
				$families = db_select_data('ko_leute', 'WHERE famid > 0 AND famfunction = \'child\' '.$cwhere, 'id,famid');
				if(sizeof($families) == 0) {
					$f_sql = '';
				} else {
					$famids = array();
					foreach($families as $fam) $famids[] = $fam['famid'];
					$f_sql = " `famid` IN ('".implode("','", array_unique($famids))."') AND `famfunction` IN ('husband', 'wife') ";
				}
			}

			//find special filters for other db tables
			list($db_table, $db_col) = explode(".", $f_["dbcol"]);
			if($db_table && $db_col) {
				//special group datafields filter
				if($db_table == "ko_groups_datafields_data") {
					$rows = db_select_data("ko_groups_datafields_data", "WHERE $f_sql", "person_id");
					$ids = NULL;
					foreach($rows as $row) {
						if(!$row["person_id"]) continue;
						$ids[] = "'".$row["person_id"]."'";
					}
					if(is_array($ids)) {
						$f_sql = "`id` IN (".implode(",", $ids).")";
					} else {
						$f_sql = " 1=2 ";
					}
				}
				//special small group filters
				else if($db_table == "ko_kleingruppen") {
					$rows = db_select_data("ko_kleingruppen", "WHERE $f_sql", "id");
					$ids = NULL;
					foreach($rows as $row) {
						if(!$row["id"]) continue;
						$ids[] = $row["id"];
					}
					if(is_array($ids)) {
						$kg_sql = array();
						foreach($ids as $id) {
							$kg_sql[] = "`kg` REGEXP '(^|,)$id($|,)'";
						}
						$f_sql = implode(" OR ", $kg_sql);
					} else {
						$f_sql = " 1=2 ";
					}
				}
				//special rota filter
				else if($db_table == "ko_dp_einteilung") {
					$rows = db_select_data("ko_dp_einteilung", "WHERE $f_sql", "leute");
					$ids = array();
					foreach($rows as $row) {
						if(!$row["leute"]) continue;
						foreach(explode(',', $row['leute']) as $pid) {
							if(!$pid || format_userinput($pid, 'uint') != $pid) continue;
							$ids[] = $pid;
						}
					}
					foreach($ids as $key => $value) if(!$value) unset($ids[$key]);
					$ids = array_unique($ids);
					if(sizeof($ids) > 0) {
						$f_sql = "`id` IN (".implode(",", $ids).")";
					} else {
						$f_sql = " 1=2 ";
					}
				}
				//Apply another filter preset
				else if($db_table == "ko_filter") {
					if(substr($f_sql, 0, 3) == '@G@') $preset = ko_get_userpref('-1', substr($f_sql, 3), 'filterset');
					else $preset = ko_get_userpref($_SESSION['ses_userid'], $f_sql, 'filterset');
					if($preset[0]["key"]) {  //preset found
						//Get filter and convert it into a WHERE clause
						apply_leute_filter(unserialize($preset[0]["value"]), $filter_where);
						//Get ids of people fitting this condition
						$rows = db_select_data("ko_leute", "WHERE 1=1 ".$filter_where, "id");
						//Convert it into an id-list for an IN () statement
						$ids = NULL;
						foreach($rows as $row) {
							if(!$row["id"]) continue;
							$ids[] = $row["id"];
						}
						if(sizeof($ids) > 0) {
							$f_sql = "`id` IN (".implode(",", $ids).")";
						} else {  //No ids found, so add a false condition
							$f_sql = " 1=2 ";
						}
					} else {  //no preset found
						$f_sql = "";
					}
				}
				//Apply filter for a given year of donations made
				else if($db_table = 'ko_donations') {
					$rows = db_select_data('ko_donations', 'WHERE '.$f_sql, 'person');
					$ids = array();
					foreach($rows as $row) {
						if(!$row['person']) continue;
						$ids = array_merge($ids, explode(',', format_userinput($row['person'], 'intlist')));
					}
					foreach($ids as $key => $value) if(!$value) unset($ids[$key]);
					$ids = array_unique($ids);
					if(sizeof($ids) > 0) {
						$f_sql = '`id` IN ('.implode(',', $ids).')';
					} else {
						$f_sql = ' 1=2 ';
					}
				}
			}//if(db_table && db_col)


			if(trim($f_sql) != "") {
				if($f[2]) {  //Negativ
					$q[$f_typ] .= " ( !($f_sql) ) $link ";
				} else {
					$q[$f_typ] .= " ( $f_sql ) $link ";
				}
			}
		}//foreach(filter)
	}//if(is_array(filter))
				    
  //Einzelne Filter-Gruppen mit AND verbinden und letztes OR lschen
	$link = $filter["link"] == "or" ? " OR " : " AND ";
	if(sizeof($q) > 0) {
		foreach($q as $type => $q_) {
			if(trim(substr($q_, 0, -4)) != "") {
				$q_ = " ( " . substr($q_, 0, -4) . " ) ";
				//Use the link for all filters except for addchildren, which is always added with OR
				$where_code .= ($type == 'addchildren' || $type == 'addparents' ? ' OR ' : $link).$q_;
			}
		}
	}
	$where_code = substr($where_code, 4);  //Erstes OR lschen

	//Admin-Filter anwenden
	if($add_admin_filter) {
		//add all filters from applied admingroups first
		$add_rights = array();
		$admingroups = ko_get_admingroups($_SESSION["ses_userid"]);
		foreach($admingroups as $ag) {
			$add_rights[] = "admingroup:".$ag["id"];
		}
		$add_rights[] = "login";
		foreach($add_rights as $type) {
			if(substr($type, 0, 10) == "admingroup") {
				list($type, $use_id) = explode(":", $type);
			} else {
				$use_id = $_SESSION["ses_userid"];
			}
			$laf = ko_get_leute_admin_filter($use_id, $type);
			if(sizeof($laf) > 0) {
				if($admin_filter_level != "") {
					//apply only given level (if set) for ko_get_admin()
					if(isset($laf[$admin_filter_level]["filter"])) {
						apply_leute_filter($laf[$admin_filter_level]["filter"], $where, FALSE);
						if(trim(substr($where, 4)) != "") $admin_code .= "( ".substr($where, 4)." ) OR ";
					}
				} else {
					//apply all levels for read access
					for($i=1; $i<4; $i++) {
						if(!isset($laf[$i]["filter"])) continue;
						apply_leute_filter($laf[$i]["filter"], $where, FALSE);
						if(trim(substr($where, 4)) != "") $admin_code .= "( ".substr($where, 4)." ) OR ";
					}//for(i=1..3)
				}
			}//if(sizeof(laf))
		}
		if($admin_code != "") $admin_code = substr($admin_code, 0, -3);
	}//if(add_admin_filter)

	if(trim($where_code) != "") {
		if(trim($admin_code) != "") {
			$where_code = " AND ($where_code) AND ($admin_code) ";
		} else {
			$where_code = " AND $where_code ";
		}
	} else {
		if($admin_code != "") {
			$where_code = " AND $admin_code ";
		}
	}
	
	//deleted ausblenden
	$deleted = ($ko_menu_akt == "leute" && ko_get_userpref($_SESSION["ses_userid"], "leute_show_deleted") == 1)
						 ? " AND `deleted` = '1' "
						 : " AND `deleted` = '0' ";
	//retrieve deleted if old version is to be displayed.
	//They are eliminated later (in ko_get_leute()), if they have been deleted in the desired version.
	$deleted = $_SESSION["leute_version"] ? "" : $deleted;
	//Add SQL for hidden records
	$deleted .= ko_get_leute_hidden_sql();

	if($where_code) {
		$where_code = " AND ( ".substr($where_code, 5)." ) ".$deleted;
		return TRUE;
	} else {
		$where_code = $deleted;
		return FALSE;
	}
}//apply_leute_filter()




function ko_get_leute_hidden_sql() {
	$sql = "";

	switch(ko_get_setting("leute_hidden_mode")) {
		case 0:  //Show always
		break;
		case 1:  //Hide always
			$sql = " AND hidden = '0' ";
		break;
		case 2:  //Let user decide
			if(ko_get_userpref($_SESSION["ses_userid"], "leute_show_hidden") == 0) {
				$sql = " AND hidden = '0' ";
			}
		break;
	}

	return $sql;
}//get_leute_hidden_sql()



/**
  * Liefert Formular zu einzelnem Filter
	* Fr Ajax und Submenu.inc
	*/
function ko_get_leute_filter_form($fid) {
	$code = "";

	ko_get_filter_by_id($fid, $f);

	$code_filter = array();
	for($i = 1; $i <= $f["numvars"]; $i++) {
		$code_filter[]  = getLL("filter_".$f["var$i"]) ? getLL("filter_".$f["var$i"]) : $f["var$i"];
		$code_filter[] .= $f["code$i"];
	}

	foreach($code_filter as $c) {
		$code .= $c."<br />";
	}


	$code_filter_zusatz = "";
	if($f["allow_neg"]) {
		$code_filter_zusatz = '<input type="checkbox" name="filter_negativ" />'.getLL("filter_negativ");
	}

	$code_filter_zusatz .= '<p align="center">';
	$code_filter_zusatz .= '<input type="button" value="'.getLL("filter_add").'" name="submit_filter" onclick="javascript:do_submit_filter(\'leutefilter\', \''.session_id().'\');" />';
	$code_filter_zusatz .= '&nbsp;&nbsp;';
	$code_filter_zusatz .= '<input type="button" value="'.getLL("filter_replace").'" name="submit_filter_new" onclick="javascript:do_submit_filter(\'leutefilternew\', \''.session_id().'\');" />';
	$code_filter_zusatz .= '</p>';


	$code .= $code_filter_zusatz;
	return ('<div name="filter_form">'.$code.'</div>');
}//ko_get_leute_filter_form()





/**
	* Gibt formatierte Personendaten zurck
	* data enthlt den Wert aus der DB
	* col ist die DB-Spalte
	* p ist eine Referenz auf den ganzen Personendatensatz
	* all_datafields ist ein Array aller Datenfelder
	* forceDatafields: Damit werden die Datenfelder miteinbezogen, auch wenn userpref nicht gesetzt ist. (Z.B. von TYPO3-Ext kool_leute)
	*/
function map_leute_daten($data, $col, &$p, &$all_datafields, $forceDatafields=FALSE) {
	global $DATETIME;
	global $all_groups;
	global $access;

	//Datenbank-Spalten-Info holen, falls es keine Modul-Spalte ist (die nicht direkt als Leute-Spalte gespeichert ist)
	if(substr($col, 0, 6) != "MODULE") {
		if(!$data && substr($col, 0, 1) != "_") return "";
		$db_col = db_get_columns("ko_leute", $col);
	}

	if($col == "groups") {  //Used for group filters and the groups-column in the list view
		$value = NULL;
		if(substr($data, 0, 1) == "r" || substr($data, 0, 2) == ":r") {  //Rolle
			ko_get_grouproles($role, "AND `id` = '".substr($data, (strpos($data, "r")+1))."'");
			return $role[substr($data, (strpos($data, "r")+1))]["name"];
		} else {  //Gruppe(n)
			if(!isset($access['groups'])) ko_get_access('groups');
			foreach(explode(',', $data) as $g) if($g && ($access['groups']['ALL'] > 0 || $access['groups'][ko_groups_decode($g, 'group_id')] > 0)) $value[] = ko_groups_decode($g, 'group_desc_full', 25);
			return implode(", ", $value);
		}
	} else if($col == "datafield_id") {  //Angewandte Gruppen-Datenfelder-Filter schn darstellen
		if(strlen($data) == 6 && format_userinput($data, "uint") == $data) {
			$df = db_select_data("ko_groups_datafields", "WHERE `id` = '$data'", "*", "", "", TRUE);
			return $df["description"];
		} else {
			return $data;
		}
	} else if($db_col[0]["Type"] == "date") {  //Datums-Typen von SQL umformatieren
		if($data == "0000-00-00") return "";
		return strftime($DATETIME["dmY"], strtotime($data));
	} else if(substr($db_col[0]["Type"],0,4) == "enum") {  //Find ll values for enum
		$ll_value = getLL("ko_leute_".$col."_".$data);
		return ($ll_value ? $ll_value : $data);
	} else if ($col == "dienst" || $col == "dienstleiter") {  //Dienste nicht als IDs sondern mit Namen ausgeben
		return ko_dienstliste($data);
	} else if (($col == "kg" || $col == "kg_leiter")) {  //Kleingruppen formatiert ausgeben
		return ko_kgliste($data);
	} else if ($col == "famid") {
		$fam = ko_get_familie($data);
		return $fam["id"]." ".getLL("ko_leute_famfunction_short_".$p["famfunction"]);
	} else if(substr($db_col[0]["Type"], 0, 7) == "tinyint") {  //Treat tinyint as checkbox
		return ($data ? getLL("yes") : getLL("no"));
	} else if(substr($col, 0, 1) == "_") {  //Children export columns
		if(!$p["famid"] || $p["famfunction"] != "child") return "";
		switch($col) {
			case "_father":
			case "_mother":
				$func = $col == "_father" ? "husband" : "wife";
				$d = db_select_data("ko_leute", "WHERE `famid` = '".$p["famid"]."' AND `famfunction` = '$func' AND `deleted` = '0'", "*", "", "", TRUE);
				return $d["vorname"]." ".$d["nachname"];
			break;  //father
			default:
				if(in_array(substr($col, 0, 8), array("_father_", "_mother_"))) {
					$p_col = substr($col, 8);
					$fam_function = substr($col, 0, 7) == "_father" ? "'husband'" : "'wife'";
				} else {
					$p_col = substr($col, 1);
					$fam_function = "'husband', 'wife'";
				}
				$d = db_select_data("ko_leute", "WHERE `famid` = '".$p["famid"]."' AND `famfunction` IN ($fam_function) AND `$p_col` != '' AND `deleted` = '0'", "*", "ORDER BY famfunction ASC");
				foreach($d as $e) {
					if($e[$p_col]) return $e[$p_col];
				}
				return "";
		}
	} else if(substr($col, 0, 6) == "MODULE") {
		switch(substr($col, 6, 3)) {
			//Gruppen-Modul: Rolle in entsprechender Gruppe anzeigen
			case "grp":
				$gid = substr($col, 9);
				$value = "";
				$data = $p["groups"];
				foreach(explode(",", $data) as $group) {
					//Don't display groups with start or stop date if settings show_passed_groups is not set.
					$_gid = ko_groups_decode($group, "group_id");
					$stop = FALSE;
					if(!ko_get_setting("show_passed_groups")) {
						$motherline = array_merge(array($_gid), ko_groups_get_motherline($_gid, $all_groups));
						foreach($motherline as $mg) {
							if($all_groups[$mg]["stop"] != "0000-00-00" && time() > strtotime($all_groups[$mg]["stop"])) $stop = TRUE;
							if($all_groups[$mg]["start"] != "0000-00-00" && time() < strtotime($all_groups[$mg]["start"])) $stop = TRUE;
						}
					}
					if($stop) continue;
					if($gid == $_gid) {  //Assigned to this group, and not one of the subgroups
						$v = ko_groups_decode($group, "role_desc");
						$value .= $v ? ko_html($v).", " : "x, ";
					} else if(in_array($gid, ko_groups_decode($group, "mother_line"))) {  //Check for assignement to a subgroup
						if($all_groups[$gid]["type"] == 1) {  //Dummy group (Platzhalter), so show assigned subgroups
							$value .= '<a href="#" onclick="'."sendReq('../leute/inc/ajax.php', 'action,id,state,sesid', 'itemlist,MODULEgrp".$_gid.",switch,".session_id()."', do_element);return false;".'">'.ko_html(ko_groups_decode($group, "group_desc"))."</a>, ";
						} else {
							$value = "x, ";
						}
					}
				}
				//output datafields of this group
				if($all_groups[$gid]["datafields"] && (ko_get_userpref($_SESSION["ses_userid"], "show_group_datafields") || $forceDatafields)) {
					$return = NULL;
					$return[] = substr($value, 0, -2);
					foreach(explode(",", $all_groups[$gid]["datafields"]) as $fid) {
						//check for valid datafield
						if(!isset($all_datafields[$fid])) continue;

						//Get datafield value (versioning handled in function)
						$value = ko_get_datafield_data($gid, $fid, $p["id"], $_SESSION["leute_version"], $all_datafields, $all_groups);
						if($value["typ"] == "checkbox") {
							$return[] = $value["value"] == "1" ? ko_html(getLL("yes")) : ko_html(getLL("no"));
						} else {
							$return[] = ko_html($value["value"]);
						}
					}
					return $return;
				}
				//no datafields, or don't display them
				else {
					return substr($value, 0, -2);
				}
			break;  //grp
		}
	} else if($col == "`event`") {  //Used for rota special filter
		$event = db_select_data("ko_event", "WHERE `id` = '$data'", "*", "", "", TRUE);
		$group = db_select_data("ko_eventgruppen", "WHERE `id` = '".$event["eventgruppen_id"]."'", "*", "", "", TRUE);
		return strftime($DATETIME["dmy"], strtotime($event["startdatum"])).": ".$group["name"];
	} else if($col == '`account`') {  //Used for donation special filter
		$account = db_select_data('ko_donations_accounts', 'WHERE `id` = \''.$data.'\'', '*', '', '', TRUE);
		return $account['number'];
	} else {  //Den Rest wie gehabt ausgeben
		return $data;
	}

}//map_leute_daten()




function ko_get_leute_email($p, &$email) {
	global $LEUTE_EMAIL_FIELDS;

	if(!is_array($p)) {
		ko_get_person_by_id($p, $person);
		$p = $person;
	}

	$found = FALSE;
	foreach($LEUTE_EMAIL_FIELDS as $field) {
		if($p[$field]) {
			$email = $p[$field];
			$found = TRUE;
			break;
		}
	}

	return $found;
}//ko_get_leute_email()




/**
 * Store an old state of an edited person record in database for versioning
 * @params $id ID of person's dataset
 * @params $data array holding the current data for this record, which will be stored serialized
 */
function ko_save_leute_changes($id, $data="", $df="") {
	if(!$id) return FALSE;

	//Don't allow two changes by the same user within one second
	// (might happen when editing a person belonging to a family. Then the family members get updated as well)
	$same = db_get_count("ko_leute_changes", "id", "AND `leute_id` = '$id' AND `user_id` = '".$_SESSION["ses_userid"]."' AND (UNIX_TIMESTAMP() - UNIX_TIMESTAMP(`date`) <= 1)");
	if($same > 0) return FALSE;

	//Get person from db if not given
	if(!is_array($data)) {
		ko_get_person_by_id($id, $data);
		if($data["id"] != $id) return FALSE;
	}

	//Get datafields from db if not given
	if(!is_array($df)) {
		$df = ko_get_datafields($id);
		if(!is_array($df)) $df = array();
	}

	$store = array("date" => date("Y-m-d H:i:s"),
								 "user_id" => $_SESSION["ses_userid"],
								 "leute_id" => $id,
								 "changes" => serialize($data),
								 "df" => serialize($df),
								 );
	db_insert_data("ko_leute_changes", $store);
}//ko_save_leute_changes()





/**
 * Get an old version for a given person
 * @param date version, Set date, for which to return the address data (YYYY-MM-DD). The first version after this date will be returned
 * @param int id, ID of the person for which to return the version
 * @return array, Array of address data for the given timestamp
 */
function ko_leute_get_version($version, $id) {
	if(!$id || !$version) continue;

	$old = db_select_data("ko_leute_changes", "WHERE `leute_id` = '$id' AND `date` > '$version 23:59:59'", "*", "ORDER BY `date` ASC", "LIMIT 0, 1", TRUE);
	
	$row = unserialize($old["changes"]);
	return $row;
}//ko_leute_get_version()



/**
 * Get the value for a given group datafield
 * @param int gid, Group id
 * @param int fid, Datafield id
 * @param int pid, Person id
 * @param date version, Optional date for which to get the group datafield value
 * @param array all_datafields, Array with all group datafields given by reference
 * @param array all_groups, Array with all groups given by reference
 */
function ko_get_datafield_data($gid, $fid, $pid, $version="", &$all_datafields, &$all_groups) {
	//Return old version
	if($version != "") {
		$value = db_select_data("ko_groups_datafields_data AS dfd LEFT JOIN ko_groups_datafields AS df ON dfd.datafield_id = df.id", "WHERE dfd.datafield_id = '$fid' AND dfd.person_id = '$pid' AND dfd.group_id = '$gid'", "dfd.value AS value, df.type as typ, dfd.id as dfd_id", "", "", TRUE);

		//Get old version
		$old = db_select_data("ko_leute_changes", "WHERE `leute_id` = '$pid' AND `date` > '$version 23:59:59'", "*", "ORDER BY `date` ASC", "LIMIT 0, 1", TRUE);
		//If an old version has been found display the old value
		//Otherwise display the current value because there is no older version available
		if(isset($old["df"])) {
			$df_old = unserialize($old["df"]);

			//Set back to old value if set
			if(isset($df_old[$value["dfd_id"]])) {
				$value["value"] = $df_old[$value["dfd_id"]]["value"];
			} else {
				$value["value"] = "";
			}
		}
	}

	//Just get current version
	else {
		$value = db_select_data("ko_groups_datafields_data LEFT JOIN ko_groups_datafields ON ko_groups_datafields_data.datafield_id = ko_groups_datafields.id", "WHERE ko_groups_datafields_data.datafield_id = '$fid' AND ko_groups_datafields_data.person_id = '$pid' AND ko_groups_datafields_data.group_id = '$gid'", "ko_groups_datafields_data.value AS value, ko_groups_datafields.type as typ", "", "", TRUE);
	}
	
	return $value;
}//ko_get_datafield_data()



/**
 * Get all group datafields for the given person
 * @param int pid, Person's id to get all datafields for
 * @return array df, Array with alle datafields for this person
 */
function ko_get_datafields($pid) {
	$df = db_select_data("ko_groups_datafields_data", "WHERE `person_id` = '$pid' AND `deleted` = '0'", "*", "ORDER BY `group_id` ASC");
	return $df;
}//ko_get_datafields()










/************************************************************************************************************************
 *                                                                                                                      *
 * MODUL-FUNKTIONEN   K L E I N G R U P P E N                                                                           *
 *                                                                                                                      *
 ************************************************************************************************************************/

function ko_get_kleingruppen(&$kg, $z_limit = '', $id = '', $_z_where='') {
	$kg = array();

	//Limit anwenden, falls gesetzt
	if($z_limit == "0" || $z_limit == "LIMIT 0" || trim($z_limit) == "") {
		$z_limit = "";
	}

	//Nur einzelne Kleingruppe holen, falls id gesetzt
	if($id) {
		$z_where = " WHERE `id` IN (";
		foreach(explode(",", $id) as $i) {
			$z_where .= "'".$i."',";
		}
		$z_where = substr($z_where, 0, -1).") ";
	} else if($_z_where != '') {
		$z_where = $_z_where;
	} else $z_where = "";


	if(is_string($_SESSION["sort_kg"]) && $_SESSION["sort_kg"] != "anz_leute" && $_SESSION["sort_kg"] != "kg_leiter") {
		$order = "ORDER BY `".$_SESSION["sort_kg"]."` ".$_SESSION["sort_kg_order"];
	} else {
		$order = "ORDER BY name ASC";
	}


	//Prepare kg members and leaders
	$kg_data = array();
	$kg_members = db_select_data("ko_leute", "WHERE (`kg` != '' OR `kg_leiter` != '') AND `deleted` = '0'", "id,kg,kg_leiter");
	foreach($kg_members as $member) {
		foreach(explode(",", $member["kg"]) as $kgid) {
			if(!$kgid) continue;
			$kg_data["kg"][$kgid][] = $member["id"];
		}
		foreach(explode(",", $member["kg_leiter"]) as $kgid) {
			if(!$kgid) continue;
			$kg_data["kg_leiter"][$kgid][] = $member["id"];
		}
	}

	//Get all small groups
	$rows = db_select_data('ko_kleingruppen', $z_where, '*', $order, $z_limit);
	foreach($rows as $row) {
		//Add columns about members and leaders
		$row["kg_leiter"] = is_array($kg_data['kg_leiter'][$row['id']]) ? implode(",", $kg_data["kg_leiter"][$row["id"]]) : '';
		$row["kg_leute"] = is_array($kg_data['kg'][$row['id']]) ? implode(",", $kg_data["kg"][$row["id"]]) : '';
		$row["anz_leute"] = sizeof($kg_data["kg"][$row["id"]]);

		$kg[$row["id"]] = $row;
	}
}//ko_get_kleingruppen()




function ko_get_kg_leiter(&$leiter, $kg_id) {
	$leiter = array();
	$rows = db_select_data('ko_leute', "WHERE `kg_leiter` REGEXP '$kg_id' AND `deleted` = '0'");
	foreach($rows as $row) {
		$leiter[] = $row['id'];
	}
}//ko_get_kg_leiter()




function ko_get_kg_leute(&$leute, $kg_id) {
	$leute = array();
	$rows = db_select_data('ko_leute', "WHERE `kg` REGEXP '$kg_id' AND `deleted` = '0'");
	foreach($rows as $row) {
		$leute[] = $row['id'];
	}
}//ko_get_kg_leute()



function ko_kgliste($data) {
	$r = "";

	if(!isset($GLOBALS["kOOL"]["ko_kleingruppen"])) {
    $GLOBALS["kOOL"]["ko_kleingruppen"] = db_select_data("ko_kleingruppen", "", "*", "ORDER BY name ASC");
  }

  foreach(explode(",", $data) as $id) {
    $kgs[] = $GLOBALS["kOOL"]["ko_kleingruppen"][$id]["name"];
  }
  $r = implode(", ", $kgs);
  return $r;
}//ko_kgliste()












/************************************************************************************************************************
 *                                                                                                                      *
 * MODUL-FUNKTIONEN   R E S E R V A T I O N                                                                             *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
	* Liefert einzelne Reservation
	*/
function ko_get_res_by_id($id, &$r) {
	$r = db_select_data('ko_reservation', "WHERE `id` = '$id'");
}//ko_get_res_by_id()


/**
	* Liefert die Farbe eines Reservations-Items
	*/
function ko_get_resitem_farbe($id) {
	$row = db_select_data('ko_resitem', "WHERE `id` = '$id'", 'farbe', '', '', TRUE);
	return $row['farbe'];
}


/**
	* Liefert alle Reservationen (normale oder zu moderierende) zu einem definierten Datum
	*/
function ko_get_res_by_date($t="", $m, $j, &$r, $show_all = TRUE, $mode = "res", $z_where="") {
	global $access, $ko_menu_akt;

	//Reservationen oder Mod-Res
	if($mode=="res") $db_table = "ko_reservation";
	else if($mode=="mod") $db_table = "ko_reservation_mod";
	else return;

	$datum = $j."-".str_to_2($m)."-".($t?str_to_2($t):"01");
	
	$where = "WHERE (`startdatum`<='$datum' AND `enddatum`>='$datum')";

	if($mode == "res") {
		if($ko_menu_akt == "reservation" && sizeof($_SESSION["show_items"]) == 0) return FALSE;
		if(!$show_all) {
			$where .= " AND (`item_id` IN ('".implode("', '", $_SESSION["show_items"])."'))";
		}//if(!show_all)
	}
	else if($mode == "mod") {
		if($access['reservation']['ALL'] > 3) {
			$where .= '';
		} else if($access['reservation']['MAX'] > 3) {
			$items = array();
			foreach($access['reservation'] as $k => $v) {
				if(!intval($k) || $v < 4) continue;
				$items[] = $k;
			}
			$where .= ' AND `item_id` IN (\''.implode("','", $items)."') ";
		} else {
			$where .= ' AND 1=2 ';
		}
	}//if..else(mode==res)
	$r = db_select_data($db_table, $where.' '.$z_where, '*', 'ORDER BY `startdatum` ASC, `startzeit` ASC');
}//ko_get_res_by_date()


/**
	* Liefert alle normalen oder moderierten Reservationen
	*/
function ko_get_reservationen(&$r, $z_where, $z_limit='', $type='res', $z_sort='') {
	$r = array();

	//Sortierung
	if($z_sort) $sort = $z_sort;
	else if($_SESSION["sort_item"] && $_SESSION["sort_item_order"]) $sort = "ORDER BY ".($_SESSION["sort_item"] == "item_id" ? "item_name" : $_SESSION["sort_item"])." ".$_SESSION["sort_item_order"];
	else $sort = "";

	//Reservationen oder Mod-Res
	if($type=="res") $db_table = "ko_reservation";
	else if($type=="mod") $db_table = "ko_reservation_mod";
	else return;

	//WHERE anwenden, oder falls leer, eine FALSE-Bedingung einfgen
	if($z_where != "") $z_where = "WHERE 1=1 " . $z_where;
	else $z_where = "WHERE 1=2";  //Nichts anzeigen

	$query = "SELECT r.*,ri.name AS item_name,ri.farbe AS item_farbe,ri.gruppen_id AS gruppen_id FROM $db_table AS r LEFT JOIN ko_resitem AS ri ON r.item_id = ri.id $z_where $sort $z_limit";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$r[$row["id"]] = $row;
	}//while(row)
}//ko_get_reservationen()


/**
	* Liefert alle Res-Items einer Res-Gruppe
	*/
function ko_get_resitems_by_group($g, &$r) {
	$r = array();
	ko_get_resitems($r, "", "WHERE i.gruppen_id = '$g'");
}//ko_get_resitems_by_group()


/**
	* Liefert ein einzelnes Res-Item
	*/
function ko_get_resitem_by_id($id, &$r) {
	$r = array();
	ko_get_resitems($r, "", "WHERE i.id = '$id'");
}//ko_get_resitem_by_id()



/**
	* Liefert den Namen eines Res-Items
	*/
function ko_get_resitem_name($id) {
	$row = db_select_data('ko_resitem', "WHERE `id` = '$id'", 'name', '', '', TRUE);
	return $row['name'];
}//ko_get_resitem_name()


/**
	* Liefert alle Resitems in sortierter Reihenfolge
	*/
function ko_get_resitems(&$r, $z_limit="", $z_where="") {
	$order = ($_SESSION["sort_group"]) ? (" ORDER BY ".($_SESSION["sort_group"] == "gruppen_id" ? "gruppen_name" : $_SESSION["sort_group"])." ".$_SESSION["sort_group_order"]) : " ORDER BY name ASC ";
	$query = "SELECT i.*,g.name AS gruppen_name FROM `ko_resitem` AS i LEFT JOIN ko_resgruppen AS g ON i.gruppen_id = g.id $z_where $order $z_limit";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$r[$row["id"]] = $row;
	}
}//ko_get_resitems()


/**
	* Liefert eine Liste aller oder einer einzelnen Res-Gruppen
	*/
function ko_get_resgroups(&$r, $id="") {
	$where = $id != '' ? "WHERE `id` = '$id'" : 'WHERE 1=1';
	$r = db_select_data('ko_resgruppen', $where, '*', 'ORDER BY name ASC');
}//ko_get_resgroups()


/**
	* Liefert alle zu moderierenden Reservationen der angegebenen Resitems
	*/
function ko_get_res_mod(&$r, $items, $user_id="") {
	$where = "";
	//Apply filter for items
	if(is_array($items)) {
		$where .= " AND (`item_id` IN ('".implode("','", $items)."')) ";
	}
	//Apply filter for user_id if given
	if($user_id > 0 && $user_id != ko_get_guest_id()) {
		$where .= " AND (`user_id` = '$user_id') ";
	}

	$r = db_select_data("ko_reservation_mod", "WHERE 1=1 $where", "*");
}//ko_get_res_mod()


/**
	* Liefert eine einzelne zu moderierende Reservation
	*/
function ko_get_res_mod_by_id(&$r, $id) {
	$r = db_select_data('ko_reservation_mod', "WHERE `id` = '$id'");
}//ko_get_res_mod_by_id()


/**
	* Find moderators for a given res item
	* Uses ko_get_moderators_by_resgroup()
	*/
function ko_get_moderators_by_resitem($item_id) {
	//Find resgroup id
	$item = db_select_data("ko_resitem", "WHERE `id` = '$item_id'", "gruppen_id", "", "", TRUE);
	$gid = $item["gruppen_id"];

	return ko_get_moderators_by_resgroup($gid);
}//ko_get_moderators_by_resitem()



/**
	* Find moderators for a given res group
	*/
function ko_get_moderators_by_resgroup($gid) {
	//Get moderators for this resgroup
	$mods = db_select_data("ko_admin AS a LEFT JOIN ko_leute as l ON a.leute_id = l.id",
												 "WHERE (a.res_admin REGEXP '^4(,|$)' OR a.res_admin REGEXP '(^|,)4@$gid(,|$)') AND (l.email != '' OR a.email != '') AND (a.disabled = '0' OR a.disabled = '')",
												 "a.id AS id, a.res_admin, l.email AS email, a.email AS admin_email, l.id AS leute_id");
	foreach($mods as $i => $mod) {
		if($mod['admin_email']) $mods[$i]['email'] = $mod['admin_email'];
	}

	return $mods;
}//ko_get_moderators_by_resgroup()




/**
  * Get values to be used in smarty html_options to display res items in a select
	* Adds optgroups for res groups
	*/
function kota_ko_reservation_item_id_dynselect(&$values, &$descs, $rights=0, $_where="") {
	global $access;

	ko_get_access('reservation');

	$values = $descs = array();
	$groups = db_select_data("ko_resgruppen", "WHERE 1=1", "*", "ORDER BY `name` ASC");
	foreach($groups as $gid => $group) {
		if($access['reservation']['grp'.$gid] < $rights) continue;
		//Add group name (as optgroup)
		$descs["i".$gid] = $group["name"];
		//Get items for this group
		$where = "WHERE `gruppen_id` = '$gid' ";
		$where .= $_where;
		$items = db_select_data("ko_resitem", $where, "*", "ORDER BY `name` ASC");
		foreach($items as $iid => $item) {
			$values["i".$gid][$iid] = $iid;
			$descs[$iid] = $item["name"];
		}
	}//foreach(groups)
}//kota_ko_reservation_item_id_dynselect()















/************************************************************************************************************************
 *                                                                                                                      *
 * MODUL-FUNKTIONEN   A D M I N                                                                                         *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
	* Liefert alle Logins
	*/
function ko_get_logins(&$l, $z_where = "", $z_limit = "", $sort_ = "") {
	if($sort_ != "") {
		$sort = $sort_;
	} else if($_SESSION["sort_admin"] && $_SESSION["sort_admin_order"]) {
		$sort = "ORDER BY ".$_SESSION["sort_admin"]." ".$_SESSION["sort_admin_order"];
	} else {
		$sort = "ORDER BY login ASC";
	}

	$l = db_select_data('ko_admin', 'WHERE 1=1 '.$z_where, '*', $sort, $z_limit);
}//ko_get_logins()


/**
	* Liefert ein einzelnes Login
	*/
function ko_get_login($id, &$l) {
	$l = db_select_data('ko_admin', "WHERE `id` = '$id'", '*', '', '', TRUE);
}//ko_get_login()


/**
  * Liefert Etiketten-Einstellungen
	*/
function ko_get_etiketten_vorlagen(&$v) {
	$v = array();
	$query = "SELECT * FROM `ko_etiketten` WHERE `key` = 'name' ORDER BY `value`";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$v[] = $row;
	}
}//ko_get_etiketten_vorlagen()


/**
  * Liefert einzelne Etiketten-Vorlagen-Werte
	*/
function ko_get_etiketten_vorlage($id, &$v) {
	$v = array();
	$query = "SELECT * FROM `ko_etiketten` WHERE `vorlage` = '$id'";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$v[$row["key"]] = $row["value"];
	}
}//ko_get_etiketten_vorlagen()


/**
  * Speichert eine komplette Etiketten-Vorlage
	*/
function ko_save_etiketten_vorlage($id, $values, $mode="new") {
	foreach($values as $key => $value) {
		if($mode == "new") {
			db_insert_data('ko_etiketten', array('vorlage' => $id, 'key' => $key, 'value' => $value));
		} else if($mode == "edit") {
			//Test if this key is already available and only update then, otherwise insert
			if(db_get_count('ko_etiketten', 'vorlage', "AND `vorlage` = '$id' AND `key` = '$key'") > 0) {
				db_update_data('ko_etiketten', "WHERE `vorlage` = '$id' AND `key` = '$key'", array('value' => $value));
			} else {
				db_insert_data('ko_etiketten', array('vorlage' => $id, 'key' => $key, 'value' => $value));
			}
		}
	}
}//ko_save_etiketten_vorlage()














/************************************************************************************************************************
 *                                                                                                                      *
 * MODUL-FUNKTIONEN   D I E N S T P L A N                                                                               *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
	* Liefert alle Dienste
	*/
function ko_get_dienste(&$r, $id="", $z_where="", $z_limit="") {
	$z_where = $id != '' ? " WHERE `id` = '$id' " : $z_where;
	$r = db_select_data('ko_dp_dienste', $z_where, '*', 'ORDER BY `name` ASC', $z_limit);
}//ko_get_dienste()



function ko_get_superdienste(&$r, $id="") {
	$r = db_select_data('ko_dp_superdienste', ($id ? "WHERE `id` = '$id'" : 'WHERE 1=1'));
}//ko_get_superdienste()



/**
	* Liefert alle Leute-IDs zu einem Dienst
	*/
function ko_get_leute_by_dienst(&$l, $d) {
	$l = array();
	if(!$d) return FALSE;

	//Get team and sql-where for groups associated with this team
	ko_get_dienste($_dienst, $d);
	$dienst = $_dienst[$d];
	$where = "`dienst` REGEXP '$d'";
	if($dienst["groupid"]) {
		//Add role if set
		$teamrole = ko_get_setting("dp_teamrole");
		$role = $teamrole ? ":r".$teamrole : "";
		//Add sql for each given group
		foreach(explode(",", $dienst["groupid"]) as $gid) {
			$where .= " OR `groups` REGEXP '(^|,|:)".$gid.$role."($|,|:)'";
		}
	}

	//Sorting
	$orderby = ko_get_setting("dp_orderby");
	if(!$orderby) $orderby = "vorname";

	$query = "SELECT `id` FROM `ko_leute` WHERE ($where) AND `deleted` = '0' ORDER BY `$orderby`";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$l[] = $row["id"];
	}
}//ko_get_leute_by_dienst()



/**
	* Liefert alle Leute-IDs der Dienstleiter zu einem Dienst
	*/
function ko_get_leiter_by_dienst(&$l, $d) {
	$l = array();
	if(!$d) return FALSE;

	//Get team and sql-where for groups associated with this team
	ko_get_dienste($_dienst, $d);
	$dienst = $_dienst[$d];
	$where = "`dienstleiter` REGEXP '$d'";
	if($dienst["groupid"]) {
		//Add role if set
		$leaderrole = ko_get_setting("dp_leaderrole");
		//If no leader role is set, then don't add any leaders, as "normal" group members are not leaders
		if($leaderrole) {
			//Add sql for each given group
			foreach(explode(",", $dienst["groupid"]) as $gid) {
				$where .= " OR `groups` REGEXP '(^|,|:)".$gid.":r".$leaderrole."($|,|:)'";
			}
		}
	}

	$query = "SELECT `id` FROM `ko_leute` WHERE ($where) AND `deleted` = '0'";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$l[] = $row["id"];
	}
}//ko_get_leiter_by_dienst()



/**
	* Liefert alle DP-Events eines Monates
	*/
function ko_get_dp_events(&$e, $monat, $jahr) {
	$e = array();
	if(!$monat) return FALSE;

	$query = "SELECT e.*,tg.name AS eventgruppen_name FROM `ko_event` AS e LEFT JOIN ko_eventgruppen AS tg ON e.eventgruppen_id = tg.id WHERE e.dp != '0' AND MONTH(`startdatum`) = '$monat' AND YEAR(`startdatum`)='$jahr' ORDER BY startdatum ASC, startzeit ASC";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$e[] = $row;
	}
}//ko_get_dp_events()


/**
	* Liefert alle eingeteilten Leute eines Dienstes eines Events
	*/
function ko_get_einteilung(&$l, $d, $e) {
	$l = array();

	//Dienst-Array zulassen, damit fr Dienstgruppen die Einteilung aus mehreren Diensten geholt werden kann
	if(is_array($d) && sizeof($d) > 0) {
		$dienst_query = "( ";
		foreach($d as $id) {
			if($id) $dienst_query .= "`dienst` = '$id' OR ";
		}
		$dienst_query = substr($dienst_query, 0, -4).") ";
	} else {
		$dienst_query = "`dienst` = '$d'";
	}

	$query = "SELECT `leute` FROM `ko_dp_einteilung` WHERE $dienst_query AND `event` = '$e'";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$l_ = explode(",", $row["leute"]);
		foreach($l_ as $temp) {
			if($temp) $l[] = trim($temp);
		}
	}
}//ko_get_einteilung()


/**
	* Speichert eine Diensteinteilung fr einen Event
	*/
function ko_dp_save_einteilung($d, $e, $l) {
	if(db_get_count('ko_dp_einteilung', 'dienst', "AND `dienst` = '$d' AND `event` = '$e'") == 1) {
		db_update_data('ko_dp_einteilung', "WHERE `dienst` = '$d' AND `event` = '$e'", array('leute' => $l));
  } else {
		db_insert_data('ko_dp_einteilung', array('dienst' => $d, 'event' => $e, 'leute' => $l));
  }
}//ko_dp_save_einteilung()



/**
	* Liefert den Status eines Monates
	*/
function ko_dp_get_monat_status($m) {
	if(!$m) return;

	$month = db_select_data('ko_dp_monat', "WHERE `id` = '$m'", 'status', '', '', TRUE);
	return $month['status'];
}//ko_dp_get_monat_status()
	


/**
	* berprft, ob jemand an einem Event schon in einem anderen Dienst eingeteilt ist
	*/
function ko_dp_check_double($l, $d, $e) {
	return db_get_count('ko_dp_einteilung', 'dienst', "AND `event` = '$e' AND `dienst` != '$d' AND `leute` REGEXP '(^|,)$l(,|$)'") > 0;
}//ko_dp_check_double()


/**
	* Liefert eine Liste mit den Dienstnamen
	* Erwartet eine kommagetrennte Liste der Dienst-IDs
	*/
function ko_dienstliste($dienste) {
	if(!$dienste) return FALSE;

	$r = "";
	$dienste_a = explode(",", $dienste);
	foreach($dienste_a as $d) {
		ko_get_dienste($ad, $d);
		if($ad[$d]["name"]) {
			$r .= $ad[$d]["name"] . ", ";
		}
	}
	$r = substr($r, 0, -2);
	
	return $r;
}//ko_dienstliste()










/************************************************************************************************************************
 *                                                                                                                      *
 * MODUL-FUNKTIONEN   F I L E S H A R E                                                                                 *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
	* Liefert die vorhandenen Shares
	* Erlaubt die Angaben von zustzlichen Filtern und Limiten
	*/
function ko_get_shares($filter, $orderBy="", $limit="") {
	if(!$filter) return FALSE;

	$r = db_select_data('ko_fileshare', 'WHERE 1=1 '.$filter, '*', 'ORDER BY '.($orderBy ? $orderBy : 'filename ASC'), $limit);
}//ko_get_shares()


/**
	* Speichert mit den gemachten Angaben ein neues Share
	*/
function ko_fileshare_save_share($id, $user_id, $filename, $type, $parent, $size) {
	if(!$id) return FALSE;

	db_insert_data('ko_fileshare', array('id' => $id, 'user_id' => $user_id, 'filename' => format_userinput($filename, 'text'), 'type' => $type, 'c_date' => date('Y-m-d H:i:s'), 'filesize' => $size, 'parent' => $parent));
}//ko_fileshare_save_share()



/**
  * Macht Sent-Eintrag nach dem Versenden eines Mails
	*/
function ko_fileshare_send_file($fileid, $rec, $recid) {
	if(!$fileid || !$recid) return FALSE;

	db_insert_data('ko_fileshare_sent', array('file_id' => $fileid, 'recipient' => $rec, 'recipient_id' => $recid));
}//ko_fileshare_send_file()



/**
  * Liefert alle Ordner fr einen Benutzer
	*/
function ko_fileshare_get_folders($userid, $mode="view") {
	global $access;

	$r = array();
	if(!in_array($mode, array("view", "new", "edit", "mod"))) return FALSE;
	if(!$userid || !ko_module_installed("fileshare",$userid)) return FALSE;
	$levels = array('view' => 1, 'new' => 2, 'edit' => 3, 'mod' => 4);
	$level = $levels[$mode];

	if($access['fileshare']['MAX'] >= $level) {
		//Top-Folders
		$top = db_select_data('ko_fileshare_folders', "WHERE `user` = '$userid' AND `parent` = '0' AND `flag` != 'S'", '*', 'ORDER BY parent ASC, name ASC');

		//Build Array in alphabetic tree-order
		foreach($top as $t) {
			$r[$t["id"]] = $t;
			rec_folders($t, $userid, $r);
		}
	}

	//Add Freigabe-Ordner
	$shareroot = ko_fileshare_get_shareroot($userid);
	$r[$shareroot["id"]] = $shareroot;
	//Add Shared Folders
	$shareroot = ko_fileshare_get_shareroot($_SESSION["ses_userid"]);
	$rows = db_select_data('ko_fileshare_folders', "WHERE `user` != '$userid' AND `share_users` REGEXP '@$userid@' AND `share_rights` >= '$level'", '*', 'ORDER BY name ASC');
	foreach($rows as $row) {
		$row['parent'] = $shareroot['id'];
		$r[$row['id']] = $row;
	}

	return $r;
}//ko_fileshare_get_folders()

function rec_folders(&$t, $userid, &$r) {
	//Children
	$children = db_select_data('ko_fileshare_folders', "WHERE `user` = '$userid' AND `parent` = '".$t['id']."' AND `flag` != 'S'", '*', 'ORDER BY name ASC');

	foreach($children as $c) {
		$r[$c["id"]] = $c;
		rec_folders($c, $userid, $r);
		unset($children[$c["id"]]);
	}
}//rec_folders()



function ko_fileshare_get_folder(&$folder, $id) {
	$folder = db_select_data('ko_fileshare_folders', "WHERE `id` = '$id'", '*', '', '', TRUE);
}//ko_fileshare_get_folder()




/**
  * Stellt eine Grssenangabe schn in B, KB, MB oder GB dar
	*/
function ko_nice_size($size) {
	if($size > (1024*1024*1024)) $size = round($size/(1024*1024*1024), 2)."GB";
  else if($size > (1024*1024)) $size = round($size/(1024*1024), 2)."MB";
  else if($size > 1024) $size = round($size/1024)."KB";
  else if($size > 0) $size = $size."B";
	return $size;
}//ko_nice_size()



/**
  * Liefert Rootline eines Folders
	*/
function ko_fileshare_get_rootline($id, $userid) {
	$rootline = array();

	ko_fileshare_get_folder($af, $id);
	if($af["user"] != $userid) {  //Bei Shared-Folders S-Folder als Parent angeben
		$parent_ = ko_fileshare_get_shareroot($userid);
		$parent = $parent_["id"];
	} else {  //Sonst richtigen Parent whlen
		$parent = $af["parent"];
	}
	$rootline[$id] = $af["name"];
	while($parent != 0) {
		ko_fileshare_get_folder($af, $parent);
		$parent = $af["parent"];
		$rootline[$af["id"]] = $af["name"];
	}//while(parent != 0)

	return $rootline;
}//ko_fileshare_get_rootline()



/**
  * Liefert ID des Eingang-Folders fr einen Benutzer
	*/
function ko_fileshare_get_inbox($userid) {
	return db_select_data('ko_fileshare_folders', "WHERE `user` = '$userid' AND `flag` = 'I'", '*', '', '', TRUE);
}//ko_fileshare_get_inbox()



/**
  * Liefert ID des Shared-Rootfolders fr einen Benutzer
	*/
function ko_fileshare_get_shareroot($userid) {
	return db_select_data('ko_fileshare_folders', "WHERE `user` = '$userid' AND `flag` = 'S'", '*', '', '', TRUE);
}//ko_fileshare_get_shareroot()



/**
  * Check for Inbox- and Shared-Folders, and create them if not present
	*/
function ko_fileshare_check_inbox_shareroot($id) {
	if(!ko_module_installed('fileshare', $id)) return;

	$inbox = ko_fileshare_get_inbox($id);
	if(!$inbox["id"]) {
		db_insert_data('ko_fileshare_folders', array('user' => $id, 'name' => getLL('fileshare_inbox'), 'comment' => getll('fileshare_inbox_comment'), 'c_date' => date('Y-m-d H:i:s'), 'flag' => 'I'));
	}
	$shares = ko_fileshare_get_shareroot($id);
	if(!$shares["id"]) {
		db_insert_data('ko_fileshare_folders', array('user' => $id, 'name' => getLL('fileshare_share'), 'comment' => getll('fileshare_share_comment'), 'c_date' => date('Y-m-d H:i:s'), 'flag' => 'S'));
	}
}//ko_fileshare_check_inbox_shareroot()




/**
  * Liefert Select-Box fr Pfad-Auswahl
	*/
function ko_fileshare_get_folder_select($userid, $mode="view", &$values, &$descs, $shareroot=TRUE) {
	$code = "";
	$values = $descs = array();

	$folders = ko_fileshare_get_folders($userid, $mode);
	foreach($folders as $f) {
		if(!$shareroot && $f["flag"] == "S") continue;
		$sel = ($f["id"] == $_SESSION["folderid"]) ? 'selected="selected"' : '';
		$code .= '<option value="'.$f["id"].'" '.$sel.'>';
		$depth = sizeof(ko_fileshare_get_rootline($f["id"], $userid))-1;
		for($i=0; $i<$depth; $i++) $code .= "&nbsp;&nbsp;";
		$code .= $f["name"];
		$code .= '</option>';

		$values[] = $f["id"];
		$desc = "";
		for($i=0; $i<$depth; $i++) $desc .= "&nbsp;&nbsp;";
		$descs[]  = $desc.$f["name"];
	}
	return $code;
}//ko_fileshare_get_folder_select()



/**
  * berprft einen Ordner auf gewisse Rechte fr einen Benutzer
	*/
function ko_fileshare_check_permission($userid, $folderid, $action) {
	global $access;

	if($userid <= 0) return FALSE;

	ko_fileshare_get_folder($folder, $folderid);
	if($folderid > 0 && $folder["user"] <= 0) return FALSE;

	if($folder["user"] == $userid || $folderid == 0) {  //Owned Folder
		$own = TRUE;
	} else {  //Shared Folder
		$own = FALSE;
		if($folder["share_rights"] >= 1) $share_view = TRUE; else $share_view = FALSE;
		if($folder["share_rights"] >= 2) $share_new = TRUE; else $share_new = FALSE;
		if($folder["share_rights"] >= 3) $share_del = TRUE; else $share_del = FALSE;
	}

	switch($action) {
		case "view_file":
			if($own && $access['fileshare']['MAX'] > 0) return TRUE;
			else if(!$own && $share_view) return TRUE;
			else return FALSE;
		break;

		case "new_file":
			if($own && $access['fileshare']['MAX'] > 1) return TRUE;
			else if(!$own && $share_new) return TRUE;
			else return FALSE;
		break;

		case "del_file":
			if($own && $access['fileshare']['MAX'] > 2) return TRUE;
			else if(!$own && $share_del) return TRUE;
			else return FALSE;
		break;

		case "new_folder":
		case "del_folder":
		case "edit_folder":
			if($own && $access['fileshare']['MAX'] > 3) return TRUE;
			else return FALSE;
		break;

	}//switch(action)

}//ko_fileshare_check_permission()



/**
  * Speichert eine Datei als Share-Datei fr den definierten User in seiner Inbox
	*/
function ko_fileshare_save_file_as_share($uid, $dateiname) {
	global $FILESHARE_FOLDER;

	if(!ENABLE_FILESHARE || !ko_module_installed("fileshare", $uid)) return FALSE;

	$save_filename = basename($dateiname);
	$save_id = md5($save_filename.microtime());
	$save_type = exec("file -ib ".escapeshellcmd($dateiname));
	$inbox = ko_fileshare_get_inbox($uid);
	clearstatcache();
	$file_size = filesize($dateiname);
	copy($dateiname, $FILESHARE_FOLDER.$save_id);
	chmod($FILESHARE_FOLDER.$save_id, 0644);
	ko_fileshare_save_share($save_id, $uid, $save_filename, $save_type, $inbox["id"], $file_size);
}//ko_fileshare_save_file_as_share()







/************************************************************************************************************************
 *                                                                                                                      *
 * MODUL-FUNKTIONEN  T A P E S                                                                                          *
 *                                                                                                                      *
 ************************************************************************************************************************/

function ko_get_tapes(&$tapes, $z_where = "", $z_limit = "") {
	if($_SESSION["sort_tapes"] && $_SESSION["sort_tapes_order"]) $sort = " ORDER BY ".$_SESSION["sort_tapes"]." ".$_SESSION["sort_tapes_order"];
	else $sort = "ORDER BY date DESC";

	if($z_where) {
		$z_where = "WHERE (ko_tapes_groups.id = ko_tapes.group_id) ".$z_where;
	} else {
		$z_where = "WHERE ko_tapes_groups.id = ko_tapes.group_id";
	}

	$query = "SELECT ko_tapes.*, ko_tapes_groups.name as group_name FROM `ko_tapes`, `ko_tapes_groups` $z_where $sort $z_limit";

	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		//Serie auslesen, falls eine definiert
		if($row["serie_id"] > 0) {
			ko_get_tapeseries($serie, "AND `id` = '".$row["serie_id"]."'");
			$row["serie_name"] = $serie[$row["serie_id"]]["name"];
		}
		$tapes[$row["id"]] = $row;
	}
	return TRUE;
}//ko_get_tapes()



function ko_get_tapeseries(&$series, $z_where = "", $z_limit = "") {
	$series = db_select_data('ko_tapes_series', 'WHERE 1=1 '.$z_where, '*', 'ORDER BY name ASC', $z_limit);
}//ko_get_tapeseries



function ko_get_tapegroups(&$groups, $z_where = "", $z_limit = "") {
	$groups = db_select_data('ko_tapes_groups', $z_where, '*', 'ORDER BY name ASC', $z_limit);
}//ko_get_tapegroups()



function ko_get_preachers(&$preachers) {
	$preachers = db_select_distinct('ko_tapes', 'preacher', 'ORDER BY preacher ASC');
}//ko_get_preachers()



/**
  * Falls ID gesetzt ist, kommt nur das Daten-Array zurck ansonsten kommen alle Layoute roh zurck
	*/
function ko_get_tape_printlayout($id = "") {
	if($id != "") {
		$where = "WHERE `id` = '$id'";
	} else $where = "";

	$query = "SELECT * FROM `ko_tapes_printlayout` $where ORDER BY name ASC";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		if($id != "") {
			$r = unserialize($row["data"]);
			$r["id"] = $row["id"];
			$r["name"] = $row["name"];
			$r["default"] = $row["default"];
		} else {
			$r[$row["id"]] = $row;
		}
	}
	return $r;
}//ko_get_tape_printlayout()







/************************************************************************************************************************
 *                                                                                                                      *
 * MODUL-FUNKTIONEN  G R O U P E S                                                                                      *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
  * Liefert alle Gruppen
	*/
function ko_get_groups(&$groups, $z_where="", $z_limit="", $sort_="") {
	if(!$sort_) {
		$sort = ($_SESSION["sort_groups"]) ? "ORDER BY ".$_SESSION["sort_groups"]." ".$_SESSION["sort_groups_order"] : "ORDER BY name ASC";
	} else {
		$sort = $sort_;
	}
	$groups = db_select_data('ko_groups', 'WHERE 1=1 '.$z_where, '*', $sort, $z_limit);
}//ko_get_groups()


/**
  * Liefert alle Rollen
	*/
function ko_get_grouproles(&$roles, $z_where="", $z_limit="") {
	$sort = ($_SESSION["sort_grouproles"]) ? "ORDER BY ".$_SESSION["sort_grouproles"]." ".$_SESSION["sort_grouproles_order"] : "ORDER BY name ASC";
	$roles = db_select_data('ko_grouproles', 'WHERE 1=1 '.$z_where, '*', $sort, $z_limit);
}//ko_get_grouproles()


/**
  * Liefert alle IDs und Bezeichnungen fr alle Rollen in einer Gruppe
	*/
function ko_groups_get_group_id_names($gid, &$groups, &$roles, $do_roles=TRUE) {
	//Nicht aus Cache holen, sondern neu berechnen
	$values = $descs = array();

	//Gruppe
	$group = $groups[$gid];
	//Mutter-Gruppen
	$m = $group;
	$line = array("g".$m["id"]);
	while($m["pid"]) {
		$m = $groups[$m["pid"]];
		$line[] = "g".$m["id"];
	}
	$line = array_reverse($line);
	//Gruppe selber
	$values[] = implode(":", $line);
	$descs[]  = $group["name"];
	//Alle Rollen
	if($do_roles && $group["roles"] != "") {
		foreach(explode(",", $group["roles"]) as $role) {
			if($role) {
				$values[] = implode(":", $line).":r".$role;
				$descs[] = $group["name"].": ".$roles[$role]["name"];
			}
		}
	}

	return array($values, $descs);
}//ko_groups_get_group_id_names()



/**
  * Liefert einzelne Bestandteile eines Gruppen-Rollen-Strings
	*/
function ko_groups_decode($all, $type, $limit=0) {
	global $all_groups;

	if(strlen($all) == 6) {  //Einzelne Gruppen-ID bergeben
		$mother_line = array();
		$base_group = $all;
	} else {  //Sonst handelt es sich um ein g:000001:r000002 usw. 
		$parts = explode(":", $all);
		$base_found = FALSE;
		$mother_line = array();
		for($i=(sizeof($parts)-1); $i>=0; $i--) {
			if(substr($parts[$i], 0, 1) == "r") {
				$rolle = substr($parts[$i], 1);
			} else if(substr($parts[$i], 0, 1) == "g") {
				if(!$base_found) {
					$base_group = substr($parts[$i], 1);
					$base_found = TRUE;
				} else {
					$mother_line[] = substr($parts[$i], 1);
					//Save the groupnames of the motherline aswell for the full path plus role
					if($type == "group_desc_full") {
						if(isset($all_groups[substr($parts[$i], 1)])) {
							$mother_line_names[] = $all_groups[substr($parts[$i], 1)]["name"];
						} else {
							ko_get_groups($group, "AND `id` = '".substr($parts[$i], 1)."'");
							$mother_line_names[] = $group[substr($parts[$i], 1)]["name"];
						}
					}
				}
			}
		}
	}//if..else(strlen(all) == 6)

	switch($type) {
		case "group_id":
			return $base_group;
		break;

		case "group":
			if(isset($all_groups[$base_group])) {
				return $all_groups[$base_group];
			} else {
				ko_get_groups($group, "AND `id` = '$base_group'");
				return $group[$base_group];
			}
		break;

		case "group_desc":
		case "group_desc_full":
			reset($mother_line_names);
			if(isset($all_groups[$base_group])) {
				$group[$base_group] = $all_groups[$base_group];
			} else {
				ko_get_groups($group, "AND `id` = '$base_group'");
			}
			if($rolle) {
				ko_get_grouproles($role, "AND `id` = '$rolle'");
				if($type == "group_desc_full")
					return implode(":", array_reverse($mother_line_names)).(sizeof($mother_line_names)>0?":":"").$group[$base_group]["name"].":".$role[$rolle]["name"];
				else
					return $group[$base_group]["name"].": ".$role[$rolle]["name"];
			} else {
				if($type == "group_desc_full") {
          $value = implode(":", array_reverse($mother_line_names)).(sizeof($mother_line_names)>0?":":"").$group[$base_group]["name"];
          if($limit && strlen($value) > $limit) {
            $limit = floor($limit/2)-2;
            return substr($value, 0, $limit)."[..]".substr($value, -1*$limit);
          } else {
            return $value;
          }
        } else {
          return $group[$base_group]["name"];
        }
			}
		break;

		case "group_description":
			if(isset($all_groups[$base_group])) {
				return $all_groups[$base_group]["description"];
			} else {
				ko_get_groups($group, "AND `id` = '$base_group'");
				return $group[$base_group]["description"];
			}
		break;

		case "role_id":
			return $rolle;
		break;

		case "role_desc":
			if(!$rolle) return $group[$base_group]["name"];
			ko_get_grouproles($role, "AND `id` = '$rolle'");
			return $role[$rolle]["name"];
		break;

		case "mother_line":
			return array_reverse($mother_line);
		break;
	}
}//ko_groups_decode()



function ko_groups_get_motherline($gid, &$groups) {
	if(!$gid) return;

	$mother_line = array();
	$group = $groups[$gid];
	while($group["pid"]) {
		$pid = $group["pid"];
		$mother_line[] = $pid;
		$group = $groups[$pid];
		$gid = $pid;
	}
	return array_reverse($mother_line);
}//ko_groups_get_motherline()



/**
  * Erstellt Save-String gemss POST-Werten und Berechtigungen, damit nicht bearbeitbare nicht rausfliegen
	*/
function ko_groups_get_savestring(&$value, $data, &$log, $_bisher=NULL, $apply_start_stop=TRUE, $do_ezmlm=TRUE) {
	global $access;

	if(!ko_module_installed("groups")) return;
	ko_get_access('groups');

	//Behandlung der Gruppen
	//Einzeln hinzufgen oder lschen, damit Rechte eingehalten werden. (Bestehende, nicht anzeigbare wrden sonst gelscht, da nicht in Formular)
	if(isset($_bisher)) {
		$bisher = explode(",", $_bisher);
	} else {
		ko_get_person_by_id($data["id"], $person);
		$bisher = explode(",", $person["groups"]);
	}
	$submited = explode(",", $value);
	$log = " ";
	//Neu eingetragene:
	foreach($submited as $g) {
		if(!$g) continue;
		$group = ko_groups_decode($g, "group");
	  //Don't work on timed groups
		if($apply_start_stop && ($group["stop"] != "0000-00-00" && $group["stop"] < strftime("%Y-%m-%d", time()))) continue;
		if($apply_start_stop && ($group["start"] != "0000-00-00" && $group["start"] > strftime("%Y-%m-%d", time()))) continue;

		if(!in_array($g, $bisher) && ($access['groups']['ALL'] > 1 || $access['groups'][$group['id']] > 1)) {
			$bisher[] = $g;
			$log .= "+".ko_groups_decode($g, "group_desc").", ";
			//Check for new ezmlm subscription
			if($do_ezmlm && defined("EXPORT2EZMLM") && EXPORT2EZMLM && $group["ezmlm_list"] != "") {
				if(!is_array($person)) ko_get_person_by_id($data["id"], $person);
				ko_ezmlm_subscribe($group["ezmlm_list"], $group["ezmlm_moderator"], $person["email"]);
			}
		}
	}
	//Gelschte:
	foreach($bisher as $b_i => $b) {
		$group = ko_groups_decode($b, "group");
		//Falls col==MODULEgrp ist (also die Funktion aus multiedit heraus aufgerufen wird), nur gewhlte Gruppe bearbeiten,
		//sonst fallen alle anderen Gruppen-Einteilungen raus
		if(substr($data["col"], 0, 9) == "MODULEgrp" && $group["id"] != substr($data["col"], 9)) continue;
	  //Don't work on timed groups
		if($apply_start_stop && ($group["stop"] != "0000-00-00" && $group["stop"] < strftime("%Y-%m-%d", time()))) continue;
		if($apply_start_stop && ($group["start"] != "0000-00-00" && $group["start"] > strftime("%Y-%m-%d", time()))) continue;

		if(($access['groups']['ALL'] > 1 || $access['groups'][$group['id']] > 1) && !in_array($b, $submited)) {
			unset($bisher[$b_i]);
			$log .= "-".ko_groups_decode($b, "group_desc").", ";
			//Check for ezmlm subscription to cancel
			if($do_ezmlm && defined("EXPORT2EZMLM") && EXPORT2EZMLM && $group["ezmlm_list"] != "") {
				if(!is_array($person)) ko_get_person_by_id($data["id"], $person);
				ko_ezmlm_unsubscribe($group["ezmlm_list"], $group["ezmlm_moderator"], $person["email"]);
			}
		}
	}

	//get rid of empty entries
	$r = array();
	foreach($bisher as $v) {
		if(!$v) continue;
		$r[] = $v;
	}

	$value = implode(",", $r);
}//ko_groups_get_savestring()






/**
  * saves the datafields for a person
	*/
function ko_groups_save_datafields($value, $data, &$log) {
	global $all_groups, $access;

	if(!$all_groups) ko_get_groups($all_groups);

	$id = $data["id"];
	$current_groups = array();
	//save datafields of assigned groups
	foreach(explode(",", $data["groups"]) as $group_id) {
		if(!$group_id) continue;
		$gid = ko_groups_decode($group_id, "group_id");
		$current_groups[] = $gid;
		if($access['groups']['ALL'] < 2 && $access['groups'][$gid] < 2) continue;
		//Don't touch groups with start or stop date set. Their values would be empty and so set to empty as they where not in the form
		if($all_groups[$gid]["stop"] != "0000-00-00" && $all_groups[$gid]["stop"] < strftime("%Y-%m-%d", time())) continue;
		if($all_groups[$gid]["start"] != "0000-00-00" && $all_groups[$gid]["start"] > strftime("%Y-%m-%d", time())) continue;

		if($all_groups[$gid]["datafields"]) {
			$value_log = "";
			// go through all datafields
			foreach(explode(",", $all_groups[$gid]["datafields"]) as $fid) {
				// get current df value
				$old_df = db_select_data("ko_groups_datafields_data", "WHERE `datafield_id` = '$fid' AND `person_id` = '$id' AND `group_id` = '$gid'");
				$old_df = array_shift($old_df);
				// only update and log changes if value has been changed
				if(isset($old_df["value"])) {
					if($old_df["value"] != $value[$gid][$fid]) {
						db_update_data("ko_groups_datafields_data", "WHERE `datafield_id` = '$fid' AND `person_id` = '$id' AND `group_id` = '$gid'", array("value" => $value[$gid][$fid]));
						$value_log .= $value[$gid][$fid].", ";
					}
				} else {
					db_insert_data("ko_groups_datafields_data", array("group_id" => $gid, "person_id" => $id, "datafield_id" => $fid, "value" => $value[$gid][$fid]));
					$value_log .= $value[$gid][$fid].", ";
				}
			}
			if($value_log) $log .= $all_groups[$gid]["name"].": ".$value_log;
		}//if(group[datafields]
	}//foreach(data[groups] as group_id)

	//delete datafields for groups, not assigned anymore
	foreach(explode(",", $data["old_groups"]) as $old) {
		if(!$old) continue;
		$gid = ko_groups_decode($old, "group_id");
		//Don't touch groups with start or stop date set. These would not be in current_groups and so the datafields would be deleted
		if($all_groups[$gid]["stop"] != "0000-00-00" && $all_groups[$gid]["stop"] < strftime("%Y-%m-%d", time())) continue;
		if($all_groups[$gid]["start"] != "0000-00-00" && $all_groups[$gid]["start"] > strftime("%Y-%m-%d", time())) continue;
		if(!in_array($gid, $current_groups)) {
			db_delete_data("ko_groups_datafields_data", "WHERE `group_id` = '$gid' AND `person_id` = '$id'");
		}
	}
}//ko_groups_save_datafields()




/**
  * creates datafields-form for all groups a person is in
	*/
function ko_groups_render_group_datafields($groups, $id, $values=FALSE, $_options=array(), $do_dfs=array()) {
	global $all_groups, $ko_path;

	if(!$all_groups) ko_get_groups($all_groups);

	if(!is_array($groups)) {
		$full_groups = explode(",", $groups);
		$groups = NULL;
		foreach($full_groups as $g) {
			$gid = ko_groups_decode($g, "group_id");
			$groups[] = array_merge($all_groups[$gid], array("desc_full" => ko_groups_decode($g, "group_desc_full")));
		}
	}

	//array_unique()
	$new_groups = array();
	$groups_id = array();
	foreach($groups as $g) {
		if(!in_array($g["id"], $groups_id)) {
			$new_groups[] = $g;
			$groups_id[] = $g["id"];
		}
	}
	$groups = $new_groups;
	unset($groups_id);
	unset($new_groups);
	

	//get datafield values for this user for all groups
	if(!$values) {
		$fielddata = db_select_data("ko_groups_datafields_data", "WHERE `person_id` = '$id'", "*", "ORDER BY group_id");
		$values = NULL;
		foreach($fielddata as $data) {
			$values[$data["group_id"]][$data["datafield_id"]] = $data["value"];
		}
	}

	$html = NULL; $df = 0;
	foreach($groups as $group) {
		if(!$group["datafields"]) continue;

		if(!$_options["hide_title"]) $html[$df]["title"] = $group["desc_full"];
		foreach(explode(",", $group["datafields"]) as $fid) {
			//Only render given datafields if set
			if(sizeof($do_dfs) > 0 && !$do_dfs[$fid]) continue;

			$value = $values[$group["id"]][$fid];

			//get datafield
			$field = db_select_data("ko_groups_datafields", "WHERE `id` = '$fid'", "*", "", "", TRUE);
			if(!$field["id"]) continue;

			$html[$df]["content"] .= '<div style="font-size:9px; font-weight:700;">'.$field["description"].': </div>';
			
			if($_options["add_leute_id"]) {
				$input_name = "group_datafields[$id][".$group["id"]."][$fid]";
			} else if($_options["koi"]) {
				$input_name = $_options["koi"];
			} else {
				$input_name = "group_datafields[".$group["id"]."][$fid]";
			}

			switch($field["type"]) {
				case "text":
					$html[$df]["content"] .= '<input type="text" size="40" name="'.$input_name.'" value="'.$value.'" />';
				break;

				case "textarea":
					$html[$df]["content"] .= '<textarea cols="40" rows="5" name="'.$input_name.'">'.$value.'</textarea>';
				break;

				case "checkbox":
					$checked = $value ? 'checked="checked"' : "";
					$html[$df]["content"] .= '<input type="checkbox" name="'.$input_name.'" value="1" '.$checked.' />';
				break;

				case "select":
					$options = unserialize($field["options"]);
					if(sizeof($options) == 0) continue;

					$html[$df]["content"] .= '<select name="'.$input_name.'" size="0">';
					$html[$df]["content"] .= '<option value=""></option>';
					foreach($options as $o) $html[$df]["content"] .= '<option value="'.$o.'" '.($o == $value ? 'selected="selected"' : '').'>'.$o.'</option>';
					$html[$df]["content"] .= '</select>';
				break;

				case "multiselect":
					$options = unserialize($field["options"]);
					if(sizeof($options) == 0) continue;

					$html[$df]["content"] .= '<table><tr><td>';
					$html[$df]["content"] .= '<input type="hidden" name="'.$input_name.'" value="'.$value.'" />';
					$html[$df]["content"] .= '<input type="hidden" name="old_'.$input_name.'" value="'.$value.'" />';
					$html[$df]["content"] .= '<select name="sel_ds1_'.$input_name.'" size="6" onclick="double_select_add(this.options[parseInt(this.selectedIndex)].text, this.options[parseInt(this.selectedIndex)].value, \'sel_ds2_'.$input_name.'\', \''.$input_name.'\');">';
					foreach($options as $o) $html[$df]["content"] .= '<option value="'.$o.'">'.$o.'</option>';
					$html[$df]["content"] .= '</select>';
					$html[$df]["content"] .= '</td><td valign="top">';
					$html[$df]["content"] .= '<img src="'.$ko_path.'images/ds_top.gif" border="0" alt="up" onclick="double_select_move(\''.$input_name.'\', \'top\');" /><br />';
					$html[$df]["content"] .= '<img src="'.$ko_path.'images/ds_up.gif" border="0" alt="up" onclick="double_select_move(\''.$input_name.'\', \'up\');" /><br />';
					$html[$df]["content"] .= '<img src="'.$ko_path.'images/ds_down.gif" border="0" alt="up" onclick="double_select_move(\''.$input_name.'\', \'down\');" /><br />';
					$html[$df]["content"] .= '<img src="'.$ko_path.'images/ds_bottom.gif" border="0" alt="up" onclick="double_select_move(\''.$input_name.'\', \'bottom\');" /><br />';
					$html[$df]["content"] .= '<img src="'.$ko_path.'images/ds_del.gif" border="0" alt="up" onclick="double_select_move(\''.$input_name.'\', \'del\');" />';
					$html[$df]["content"] .= '</td><td>';
					$html[$df]["content"] .= '<select name="sel_ds2_'.$input_name.'" size="6">';
					foreach(explode(",", $value) as $v) if($v) $html[$df]["content"] .= '<option value="'.$v.'">'.$v.'</option>';
					$html[$df]["content"] .= '</select>';
					$html[$df]["content"] .= '</td></tr></table>';
				break;
			}
			$html[$df]["content"] .= "<br />";
		}
		$df++;
	}//foreach(datafields as group)

	$df_html  = '<div id="datafields_form" name="datafields_form" class="df_content">';
	$df_html .= '<table width="100%" cellpadding="0" cellspacing="0">';
	$df_counter = 0;
	foreach($html as $content) {
		if($df_counter == 0) $df_html .= '<tr>';
		$df_html .= '<td width="50%" valign="top">';
		if($content["title"]) $df_html .= '<div class="df_header">'.$content["title"].'</div>';
		$df_html .= $content["content"].'</td>';
		if($df_counter == 0) {
			$df_counter = 1;
		} else {
			$df_counter = 0;
			$df_html .= '</tr>';
		}
	}
	if($df_counter == 1) $df_html .= '<td width="50%">&nbsp;</td></tr>';
	$df_html .= '</table></div>';

	return $df_html;
}//ko_groups_render_group_datafields()





//Liefert alle Gruppen rekursiv
function ko_groups_get_recursive($z_where, $fullarrays=FALSE) {
	$r = array();

	//Leaves finden
	$not_leaves = db_select_distinct("ko_groups", "pid");

	//Top-Level
	ko_get_groups($top, "AND `pid` IS NULL ".$z_where, "", "ORDER BY name ASC");

	$level = 0;
	foreach($top as $t) {
		if($fullarrays) $r[] = $t;
		else $r[] = array("id" => $t["id"], "name" => $t["name"]);
		rec_groups($t, $r, $z_where, $not_leaves, $fullarrays);
	}//foreach(top)

	return $r;
}//ko_groups_get_recursive()


function rec_groups(&$t, &$r, $z_where="", &$not_leaves, $fullarrays=FALSE) {
	if(!is_array($not_leaves)) $not_leaves = db_select_distinct("ko_groups", "pid");

	//Bei Blttern sofort zurckgeben
	if(!in_array($t["id"], $not_leaves)) return;

	ko_get_groups($children, "AND `pid` = '".$t["id"]."' ".$z_where, "", "ORDER BY name ASC");

	foreach($children as $c) {
		if($fullarrays) $r[] = $c;
		else $r[] = array("id" => $c["id"], "name" => $c["name"]);
		rec_groups($c, $r, $z_where, $not_leaves, $fullarrays);
		unset($children[$c["id"]]);
	}
}//rec_groups()



/**
  * Liefert die WHERE-Bedingung fr Gruppen gemss Option, ob abgelaufene Gruppen angezeigt werden drfen oder nicht
	*/
function ko_get_groups_zwhere() {
	if(ko_get_setting("show_passed_groups") == 1) {
		$z_where = "";
	} else {
		$z_where = "AND ((`start` = '0000-00-00' OR `start` <= NOW()) AND (`stop` = '0000-00-00' OR `stop` > NOW()))";
	}
	return $z_where;
}//ko_get_groups_zwhere()



/**
  * Erstellt die JS-Eintrge fr ein Selmenu fr das Gruppen-Modul
	*/
function ko_selmenu_generate_children_entries($top_id, $list_id, &$all_groups, &$all_roles, $show_all_types=FALSE) {
	global $access;
	global $counter, $list_counter, $level, $children;

	$level++;
	if(!$list_counter[$level]) $list_counter[$level] = ($level*1000000);
	$group_list = array();

	if($top_id == "NULL") {
		$groups = db_select_data("ko_groups", "WHERE `pid` IS NULL ".ko_get_groups_zwhere(), "*", "ORDER BY `name` ASC");
	} else {
		$groups = db_select_data("ko_groups", "WHERE `pid` = '$top_id' ".ko_get_groups_zwhere(), "*", "ORDER BY `name` ASC");
	}

	//Get an array of the number of children for all groups that have children
	if(!$children) {
		$children = db_select_data('ko_groups', 'WHERE 1=1 '.ko_get_groups_zwhere(), '`pid`,COUNT(`id`) AS num', 'GROUP BY `pid`');
	}

	foreach($groups as $group) {
		if($access['groups']['ALL'] > 0 || $access['groups'][$group['id']] > 0) {
			//Echter Eintrag
			//$mother_line = array_reverse(ko_groups_get_motherline($group["id"], $all_groups));
			//print 'addItem(1, '.$counter.', "g'.implode(":g", $mother_line).":g".$group["id"].'", "'.$descs[$i].'");'."\n";
			list($values, $descs) = ko_groups_get_group_id_names($group["id"], $all_groups, $all_roles, $do_roles=FALSE);
			foreach($values as $i => $value) {
				if($show_all_types || $group["type"] != 1) {  //Platzhalter-Gruppen nicht ausgeben
					print 'addItem('.$list_id.', '.$counter.', "'.$value.'", "'.$descs[$i].'");'."\n";
					$group_list[] = $counter++;
				}
			}

			//Link auf Subliste mit allen Children dieser Gruppe
			if($children[$group['id']]['num'] > 0) {
				ko_selmenu_generate_children_entries($group["id"], $list_id, $all_groups, $all_roles, $show_all_types);
				$level--;
				$group_list[] = $list_counter[($level+1)]++;
			}

		}//if(g_view)
	}//foreach(groups)

	if($top_id == "NULL") {
		print 'addTopList('.$list_id.', 0, "'.implode(", ", $group_list).'");'."\n";
	} else {
		//Muttergruppe fr Sublisten-Namen holen
		if($level == 2) {
			print 'addItem('.$list_id.', '.$counter.', "back", "---'.getLL("groups_list_up").'---");'."\n";
		} else {
			print 'addItem('.$list_id.', '.$counter.', "sub:'.$list_counter[($level-1)].'", "---'.getLL("groups_list_up").'---");'."\n";
		}
		$group_list = array_merge(array($counter++), $group_list);
		print 'addSubList('.$list_id.', '.$list_counter[$level].', 0, "'.$all_groups[$top_id]["name"].' -->", "'.implode(", ", $group_list).'");'."\n";
	}
}//ko_selmenu_generate_children_entries()




function ko_update_grouprole_filter() {
	//Rollen-Filter machen, der nur nach Rolle suchen lsst
	$new_code  = "<select name=\"var1\" size=\"0\">";
	$new_code .= '<option value="0"></option>';

	//Gruppen-Select
	ko_get_grouproles($roles);
	foreach($roles as $r) {
		$new_code .= '<option value="r'.$r["id"].'">'.$r["name"].'</option>';
	}
	$new_code .= '</select>';

	db_update_data("ko_filter", "WHERE `typ`='leute' AND `name`='role'", array("code1" => $new_code));
}//ko_update_grouprole_filter()








/************************************************************************************************************************
 *                                                                                                                      *
 * P R O J E C T S - F U N K T I O N E N                                                                                *
 *                                                                                                                      *
 ************************************************************************************************************************/
function ko_projects_get_name($project) {
	if(!is_array($project)) {
		$project = db_select_data("ko_projects", "WHERE `id` = '$project'", "*", "", "", TRUE);
	}
	$name = $project["number"]." ".$project["title"];

	return $name;
}//ko_projects_get_name()





/************************************************************************************************************************
 *                                                                                                                      *
 * M U L T I E D I T - F U N K T I O N E N                                                                              *
 *                                                                                                                      *
 ************************************************************************************************************************/


 function ko_include_kota($tables=array()) {
	 global $BASE_PATH, $KOTA, $ko_menu_akt, $access;

	 $KOTA_TABLES = $tables;
	 include($BASE_PATH.'inc/kota.inc');
 }//ko_include_kota()




/**
	* Generates a form for multiedit or a single entry
	*
	* Get information from KOTA to render a form for editing one or more entries
	*
	* @param string Table to edit
	* @param string Comma separated list of columns to be edited (empty for all)
	* @param string Comma separated list of ids to be edited. 0 for a new entry
	* @param string ORDER BY statement to be used if editing multiple entries
	* @param array Data for the rendering of the form (like title etc.)
	* @param boolean Renders form if set to false, only return group array otherwise which can be used to feed ko_formular.tmpl through smarty
	*/
function ko_multiedit_formular($table, $columns="", $ids=0, $order="", $form_data="", $return_only_group=FALSE) {
	global $smarty, $mysql_pass;
	global $KOTA, $js_calendar;

	//Columns used in SQL
	if($columns == "") {  //not multiedit, so take all KOTA-columns
		$mode = "single";
		foreach($KOTA[$table] as $kota_col => $array) {
			if(substr($kota_col, 0, 1) == "_") continue;   //_multititle, _listview
			$columns[] = $kota_col;
		}
		foreach($columns as $column) {
			if($KOTA[$table][$column]["form"]["dontsave"]) continue;
			$sel_columns[] = "`".$column."`";
		}
		$sel_columns = implode(",", $sel_columns);

		//Add help for the given table
		$smarty->assign("help", ko_get_help("kota", $table));
	} else {  //multiedit, only use given column(s)
		$mode = "multi";
		$showForAll = TRUE;
		foreach($columns as $c_i => $col) {
			if(substr($col, 0, 6) == "MODULE") {
				switch(substr($col, 6, 3)) {
					case "grp":
						$db_cols .= "`groups`,";
					break;
					case "gdf":
						$db_cols .= "`groups`,";
					break;
				}
			} else {
				$db_cols .= "`".$col."`,";
			}
		}
		$sel_columns = $db_cols.implode(",", array_keys($KOTA[$table]["_multititle"]));

		//Add help for multiediting
		$smarty->assign("help", ko_get_help("kota", "multiedit"));
	}//if..else(!columns)

	//IDs of the records to be edited
	if($ids == 0) {  //no multiedit, might be a form for a new entry, so don't ask for ids
		$ids = array(0);
		$new_entry = TRUE;
		$sel_ids = 0;
		$row = array("id" => 0);
		foreach($kota_cols as $kota_col) $row[$kota_col] = "";
	} else {  //multiedit, so ids to be edited must be given
		$new_entry = FALSE;
		$sel_ids = "";
		if(is_array($ids)) {
			foreach($ids as $id) {
				$sel_ids .= "'$id', ";
			}
			$sel_ids = substr($sel_ids, 0, -2);
		} else {
			$sel_ids = $ids;
			$ids = array($ids);
		}

		if(!$sel_ids) return FALSE;
	}


	//Get data from DB
	$result = mysql_query("SELECT id,$sel_columns FROM `$table` WHERE `id` IN ($sel_ids) $order");

	//Start building the form
	$rowcounter = 0;
	$gc = 0;
	//Loop through all entries
	while($new_entry || $showForAll || $row = mysql_fetch_assoc($result)) {
		if($new_entry) {  //Single edit form
			$group[$gc] = array();
		} else if($showForAll) {  //Add edit fields to be applied to all edited rows
			$group[$gc] = array("forAll" => TRUE, "titel" => getLL("multiedit_title_forAll"), "state" => "closed", "table" => $table);
			$row = array();
		} else {  //normal multiedit rows
			$titel = "";
			//Set title for each entry
			foreach($KOTA[$table]["_multititle"] as $tc => $tc_fcn) {
				$val = $row[$tc];
				if($tc_fcn != "") eval("\$val=".str_replace("@VALUE@", $val, $tc_fcn).";");
				$titel .= "$val ";
			}
			$group[$gc] = array("titel" => $titel, "state" => "open", "colspan" => 'colspan="2"');
		}
		//Alle zu bearbeitenden Spalten fr diesen Datensatz
		$col_pos = 0;
		foreach($columns as $col) {
			$keep_name = $keep_name_PLUS = "";
			if($showForAll) {
				$keep_name = "koi[$table][$col][forAll]";
				$keep_name_PLUS = "koi[$table][$col"."_PLUS][forAll]";
			}
			$col = str_replace("`", "", $col);
			//Module bearbeiten, damit in row[col] berhaupt etwas steht
			if(substr($col, 0, 6) == "MODULE") {
				switch(substr($col, 6, 3)) {
					case "grp":
						$g_value = array();
						$gid = substr($col, 9);
						foreach(explode(",", $row["groups"]) as $g) {
							if(ko_groups_decode($g, "group_id") == $gid) $g_value[] = $g;
						}
						$row[$col] = implode(",", $g_value);
					break;
					case "gdf":
						$gid = substr($col, 9, 6);  //group id
						$fid = substr($col, 15, 6); //datafield id
						//only continue if person is assigned to this group
						if(FALSE !== strpos($row["groups"], "g".$gid) || $showForAll) {
							$koi_name = $keep_name ? $keep_name : "koi[ko_leute][$col][".$row["id"]."]";
							$code = ko_groups_render_group_datafields($gid, $row["id"], FALSE, array("koi" => $koi_name), array($fid => TRUE));
							$KOTA[$table][$col]["form"] = array("desc" => getLL("groups_edit_datafield"), "type" => "html", "value" => $code);
						} else {
							$KOTA[$table][$col]["form"] = array("desc" => "-");
						}
					break;
				}
			}//if(MODULE)
			$do_1 = FALSE;
			$type = $KOTA[$table][$col]["form"]["type"];

			//Add description from LL
			if(!$KOTA[$table][$col]["form"]["desc"]) {
				$ll_value = getLL("kota_".$table."_".$col);
				$KOTA[$table][$col]["form"]["desc"] = $ll_value ? $ll_value : $col;
			}

			//Vorbehandlung fr versch. Typen
			if($type == "date") {  //no JS-DateSelect (used for multiedit)
				$type = "text";
			}
			
			else if($type == "jsdate" && is_object($js_calendar)) {  //use js-calendar
				$type = "html";
				//Prefill form for new entry with POST data
				$post_date = $_POST['koi'][$table][$col][$row['id']];
				if($new_entry && $KOTA[$table][$col]['form']['prefill_new'] && $post_date != '' && $post_date == format_userinput($post_date, 'date')) {
					$date = $_POST['koi'][$table][$col][$row['id']];
				} else {
					$date = $KOTA[$table][$col]["form"]["value"];
					if(strlen($date) > 10) $date = "";  //if several jsdate inputs are used on one page, value still contains HTML from the last one
				}
				if(!$date && $row[$col] != "0000-00-00") $date = sql2datum($row[$col]);
				$name = $keep_name ? $keep_name : "koi[$table][$col][".$row["id"]."]";
				$KOTA[$table][$col]["form"]["value"] = $js_calendar->make_input_field(array(), array("name" => $name, "value" => $date));
			}

			else if($type == 'multidateselect' && is_object($js_calendar)) {  //use js-calendar
				$name = $keep_name ? $keep_name : "koi[$table][$col][".$row['id'].']';
				$onchange = "double_select_add(this.value, this.value, 'sel_ds2_$name', '$name');";
				$KOTA[$table][$col]['form']['dateselect'] = $js_calendar->make_input_field(array('ifFormat' => '%Y-%m-%d', 'closeOnClick' => false, 'align' => 'Bl'), array('name' => 'txt_'.$name, 'onchange' => $onchange, 'size' => '10'));

				if(!$new_entry) {  //add entries from db if edit. If new, kota_assign_values() assigns avalue/adescs/avalues - if needed
					$KOTA[$table][$col]['form']['avalues'] = $KOTA[$table][$col]['form']['adescs'] = array();
					foreach(explode(',', $row[$col]) as $v) {
						$KOTA[$table][$col]['form']['avalues'][] = $v;
						$KOTA[$table][$col]['form']['adescs'][] = $v;
					}
					$KOTA[$table][$col]['form']['avalue'] = $row[$col];
				}
			}
			
			else if($type == "checkbox") {
				$KOTA[$table][$col]["form"]["params"] = $row[$col] ? 'checked="checked"' : '';
				$row[$col] = 1;  //Fr Checkboxen Value immer auf 1 setzen
			}
			
			else if($type == "textplus") {
				//Create a second input field as text input (but only when editing a single entry and not for multiedit)
				if($mode == "single") {
					$do_1 = TRUE;
					$do_1_array = array("desc" => getLL("form_textplus").":",
															"type" => "text",
															"name" => ($keep_name_PLUS ? $keep_name_PLUS : ("koi[".$table."][".$col."_PLUS][".$row["id"]."]")),
															"params" => $KOTA[$table][$col]["form"]["params_PLUS"],
															);
				}
				$type = "select";
				//set size of select to 0
				$KOTA[$table][$col]["form"]["params"] = 'size="0"';
				//get values for the select
				if(!$KOTA[$table][$col]["form"]["values"]) {
					$values = db_select_distinct($table, $col, "", "", $KOTA[$table][$col]["form"]["select_case_sensitive"] ? TRUE : FALSE);
					$KOTA[$table][$col]["form"]["values"] = $values;
					$KOTA[$table][$col]["form"]["descs"] = $values;
				}
			}
			
			else if($type == "doubleselect") {
				if(!$KOTA[$table][$col]["form"]["js_func_add"]) $KOTA[$table][$col]["form"]["js_func_add"] = "double_select_add";
				if(!$new_entry) {  //add entries from db if edit. If new, kota_assign_values() assigns avalue/adescs/avalues - if needed
					$KOTA[$table][$col]["form"]["avalues"] = $KOTA[$table][$col]["form"]["adescs"] = array();
					foreach(explode(",", $row[$col]) as $v) {
						$KOTA[$table][$col]["form"]["avalues"][] = $v;
						$valuesi = array_flip($KOTA[$table][$col]["form"]["values"]);
						$KOTA[$table][$col]["form"]["adescs"][] = $KOTA[$table][$col]["form"]["descs"][$valuesi[$v]];
					}
					$KOTA[$table][$col]["form"]["avalue"] = $row[$col];
				}
			}
			
			else if($type == "dyndoubleselect") {
				$type = "doubleselect";
				if(!$KOTA[$table][$col]["form"]["js_func_add"]) $KOTA[$table][$col]["form"]["js_func_add"] = "double_select_add";
				$KOTA[$table][$col]["form"]["avalues"] = $KOTA[$table][$col]["form"]["adescs"] = array();

				$values = $KOTA[$table][$col]["form"]["values"];
				$descs = $KOTA[$table][$col]["form"]["descs"];
				unset($KOTA[$table][$col]["form"]["values"]);
				unset($KOTA[$table][$col]["form"]["descs"]);
				if($row[$col]) { //Current value given
					foreach(explode(",", $row[$col]) as $v) {
						$KOTA[$table][$col]["form"]["avalues"][] = $v;
						$KOTA[$table][$col]["form"]["adescs"][] = $descs[$v];
					}
					$KOTA[$table][$col]["form"]["avalue"] = $row[$col];
				}
				//Build top level of select
				foreach($values as $vid => $value) {
					$KOTA[$table][$col]["form"]["values"][] = $vid;
					$suffix = is_array($value) ? "-->" : "";
					$KOTA[$table][$col]["form"]["descs"][] = $descs[$vid].$suffix;
				}
			}
			
			else if($type == "dynselect") {
				//Only works for single edit (not multiedit) because KOTA[..][values] would be different for each multiedit item, which doesn't work
				$type = "select";
				if(!$KOTA[$table][$col]["form"]["_done"]) {
					if($showForAll) {  //First time when multiediting
						list($values, $descs) = kota_convert_dynselect_select($KOTA[$table][$col]["form"]["values"], $KOTA[$table][$col]["form"]["descs"]);
						$KOTA[$table][$col]["form"]["params"] = ' size="0"';  //Set size to 0 for multiedit
						$KOTA[$table][$col]["form"]["values"] = $values;
						$KOTA[$table][$col]["form"]["descs"] = $descs;
						$KOTA[$table][$col]["form"]["_done"] = TRUE;  //So this conversion is only done once for the forAll entry and then used in all
					} else {  //Normal form, no multiediting
						$values = $KOTA[$table][$col]["form"]["values"];
						$descs = $KOTA[$table][$col]["form"]["descs"];
						unset($KOTA[$table][$col]["form"]["values"]);
						unset($KOTA[$table][$col]["form"]["descs"]);
						if($row[$col]) {  //Current value given
							$KOTA[$table][$col]["form"]["avalues"] = $KOTA[$table][$col]["form"]["adescs"] = array();
							$KOTA[$table][$col]["form"]["avalue"] = $row[$col];
							//If current value is not found on top level then go through all lower levels to find it and display this level
							if(!in_array($row[$col], array_keys($values))) {
								foreach($values as $vid => $value) {
									if(substr($vid, 0, 1) != "i") continue;
									if(in_array($row[$col], $value)) {
										$values = array("i-" => "i-");
										//Add all values from this level
										foreach($value as $v) $values[$v] = $v;
										//Add link to go back up to the index
										$descs["i-"] = getLL("form_peopleselect_up");
										break;
									}
								}
							}//if(!in_array(row[col], values))
						}//if(row[col])
						//Build top level of select
						foreach($values as $vid => $value) {
							$KOTA[$table][$col]["form"]["values"][] = $vid;
							$suffix = is_array($value) ? "-->" : "";
							$KOTA[$table][$col]["form"]["descs"][] = $descs[$vid].$suffix;
						}
					}//if..else(showForAll) (multiedit)
				}//if(!KOTA[form][_done])
			}
			
			else if($type == "peopleselect") {
				$type = "doubleselect";
				$KOTA[$table][$col]["form"]["js_func_add"] = "window.sid='".session_id()."';people_select_add";
				$lids = explode(",", $row[$col]);
				list($v, $d, $av, $ad) = kota_peopleselect($lids);
				$KOTA[$table][$col]["form"]["values"] = $v;
				$KOTA[$table][$col]["form"]["descs"] = $d;
				$KOTA[$table][$col]["form"]["avalues"] = $av;
				$KOTA[$table][$col]["form"]["adescs"] = $ad;

				$KOTA[$table][$col]["form"]["avalue"] = $row[$col];
			}
			
			else if($type == "file") {
				//add delete checkbox for files
				$KOTA[$table][$col]["form"]["value2"] = getLL("delete");
				$KOTA[$table][$col]["form"]["name2"] = "koi[$table][$col"."_DELETE][".$row["id"]."]";
			}//if..else(type==...)

			if($do_1 && $col_pos == 1) {
				$rowcounter++;
				$col_pos = 0;
			}

			$group[$gc]["row"][$rowcounter]["inputs"][$col_pos] = $KOTA[$table][$col]["form"];
			$group[$gc]["row"][$rowcounter]["inputs"][$col_pos]["type"] = $type;
			if(!$KOTA[$table][$col]["form"]["value"]) {
				$val = $row[$col];
				if($KOTA[$table][$col]["pre"] != "") {
					$data = array($col => $val);
					kota_process_data($table, $data, "pre", $_log);
					$val = $data[$col];
				}
				$group[$gc]["row"][$rowcounter]["inputs"][$col_pos]["value"] = $val;
			}
			if($keep_name) {
				$group[$gc]["row"][$rowcounter]["inputs"][$col_pos]["name"] = $keep_name;
			} else {
				$group[$gc]["row"][$rowcounter]["inputs"][$col_pos]["name"] = "koi[$table][$col][".$row["id"]."]";
			}

			//Zweite Spalte mit einer Eingabe erstellen
			if($do_1) {
				$group[$gc]["row"][$rowcounter]["inputs"][1] = $do_1_array;
			}

			if($col_pos == 1 || $do_1 || $KOTA[$table][$col]["form"]["new_row"]) {
				$rowcounter++;
				$col_pos = 0;
			} else {
				$col_pos = 1;
			}

		}//foreach(columns as col)
		$new_entry = FALSE;
		$showForAll = FALSE;
		$gc++;
	}//while(row)

	if($return_only_group) return $group;
	
	//Controll-Hash
	sort($columns);
	sort($ids);
	//print $mysql_pass.$table.implode(":", $columns).implode(":", $ids);
	$hash_code = md5(md5($mysql_pass.$table.implode(":", $columns).implode(":", $ids)));
	$hash = $table."@".implode(",", $columns)."@".implode(",", $ids)."@".$hash_code;

	//Add legend
	$legend = getLL("kota_formlegend_".$table);
	if($legend) {
		$smarty->assign("tpl_legend", $legend);
		$smarty->assign("tpl_legend_icon", getLL("kota_formlegend_".$table."_icon"));
	}

	$smarty->assign("tpl_titel", $form_data["title"] ? $form_data["title"] : getLL("multiedit_title"));
	$smarty->assign("tpl_submit_value", $form_data["submit_value"] ? $form_data["submit_value"] : getLL("save"));
	$smarty->assign("tpl_id", $hash);
	$smarty->assign("tpl_action", $form_data["action"] ? $form_data["action"] : "submit_multiedit");
	if($form_data['action_as_new']) {
		$smarty->assign('tpl_submit_as_new', ($form_data['label_as_new']?$form_data['label_as_new']:getLL('save_as_new')));
		$smarty->assign('tpl_action_as_new', $form_data['action_as_new']);
	}
	$smarty->assign("tpl_cancel", $form_data["cancel"]);
	$smarty->assign("tpl_groups", $group);
	$smarty->display("ko_formular.tpl");
}//ko_multiedit_formular()




function kota_peopleselect($ids) {
	$values = $descs = $avalues = $adescs = array();

	//fill in alphabet for selection
	foreach(array("a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z") as $letter) {
		$values[] = "i".strtoupper($letter);
		$descs[] = strtoupper($letter);
	}
	//get people from db
	$leute_rows = db_select_data("ko_leute", "WHERE `id` IN ('".implode("','", $ids)."')", "id,vorname,nachname,firm,department", "ORDER BY nachname,vorname ASC");
	foreach($leute_rows as $leute_row) {
		if($leute_row["nachname"]) {
			$value = $leute_row["nachname"]." ".$leute_row["vorname"];
		} else if($leute_row["firm"]) {
			$value = $leute_row["firm"]." (".$leute_row["department"].")";
		}
		$avalues[] = $leute_row["id"];
		$adescs[] = $value;
	}

	return array($values, $descs, $avalues, $adescs);
}//kota_peopleselect()










/************************************************************************************************************************
 *                                                                                                                      *
 * D B - F U N K T I O N E N                                                                                            *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
	* Get the enum values of a db column
	*
	* @param string Table where the enum column is defined
	* @param string Column to get the enum values from
	* @return array All the enum values as array
	*/
function db_get_enums($table, $col) {
	global $DEBUG_db;

	if(isset($GLOBALS["kOOL"]["db_enum"][$table][$col])) {
		return $GLOBALS["kOOL"]["db_enum"][$table][$col];
	}

	$query = "SHOW COLUMNS FROM $table LIKE '$col'";
	if(DEBUG_SELECT) $time_start = microtime(TRUE);
	$result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_get_enums): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
	if(DEBUG_SELECT) {
		$DEBUG_db->queryCount++;
		$DEBUG_db->queries[] = array('time' => (microtime(TRUE)-$time_start)*1000, 'sql' => $query);
	}
	if(mysql_num_rows($result)>0){
	  $row=mysql_fetch_row($result);
	  $options=explode("','",preg_replace("/(enum|set)\('(.+?)'\)/","\\2",$row[1]));
	}

	$GLOBALS["kOOL"]["db_enum"][$table][$col] = $options;

	return $options;
}//db_get_enums()




/**
	* Get the corresponding ll values for enum values of a db column
	*
	* @param string Table where the enum column is defined
	* @param string Column to get the enum values from
	* @return array All the localised enum values as array
	*/
function db_get_enums_ll($table, $col) {
	$ll = array();

	$options = db_get_enums($table, $col);
	foreach($options as $o) {
		$ll_value = getLL($table."_".$col."_".$o);
		$ll[$o] = $ll_value ? $ll_value : $o;
	}
	return $ll;
}//db_get_enums_ll()



/**
	* Get columns of a db table
	*
	* @param string Name of database
	* @param string Name of table
	* @param string A search string to only show columns that match this value
	* @return array Columns
	*/
function db_get_columns($table, $field="") {
	global $DEBUG_db;

	$r = array();

	//Get value from global cache array if already set
	if($field != "" && isset($GLOBALS["kOOL"]["db_columns"][$table][$field])) {
		return $GLOBALS["kOOL"]["db_columns"][$table][$field];
	}

	if($field != "") $like = "LIKE '$field'";
	else $like = "";

	$query = "SHOW COLUMNS FROM $table $like";
	if(DEBUG_SELECT) $time_start = microtime(TRUE);
  $result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_get_columns): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
	if(DEBUG_SELECT) {
		$DEBUG_db->queryCount++;
		$DEBUG_db->queries[] = array('time' => (microtime(TRUE)-$time_start)*1000, 'sql' => $query);
	}
	while($row = mysql_fetch_assoc($result)) {
    $r[] = $row;
	}

	//Store value in global cache array
	if($field) $GLOBALS["kOOL"]["db_columns"][$table][$field] = $r;

	return $r;
}//db_get_columns()



/**
	* Number of entries in a db table
	*
	* @param string Table
	* @param string Column to count the different values for
	* @param string WHERE statement to add
	* @return int Number of different entries
	*/
function db_get_count($table, $field = "id", $z_where = "") {
	global $DEBUG_db;

	$query = "SELECT COUNT(`$field`) as count FROM `$table` ".(($z_where)?" WHERE 1=1 $z_where":"");
	if(DEBUG_SELECT) $time_start = microtime(TRUE);
	$result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_get_count): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
	if(DEBUG_SELECT) {
		$DEBUG_db->queryCount++;
		$DEBUG_db->queries[] = array('time' => (microtime(TRUE)-$time_start)*1000, 'sql' => $query);
	}
	$row = mysql_fetch_assoc($result);
	return $row["count"];
}//db_get_count()



/**
  * Get the next auto_increment value for a table
	*
	* @param string Table
	* @return int Next auto_increment value
	*/
function db_get_next_id($table) {
	$query = "SHOW TABLE STATUS LIKE '$table'";
	$result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_get_next_id): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
	$row = mysql_fetch_assoc($result);
	return $row["Auto_increment"];
}



/**
  * Inserts data into a database table
	*
	* This should be used instead of issuing INSERT queries directly
	*
	* @param string Table where the data should be inserted
	* @param array Data array with the keys beeing the name of the db columns
	* @return int id of the newly inserted row
	*/
function db_insert_data($table, $data) {
	global $DEBUG_db;

	$query = "INSERT INTO `$table` ";
	//Alle Daten setzen
	foreach($data as $key => $value) {
		$query1 .= "`$key`, ";
		if((string)$value == "NULL") {
			$query2 .= "NULL, ";
		} else {
			$query2 .= "'".mysql_real_escape_string(stripslashes($value))."', ";
		}
	}
	$query .= "(".substr($query1, 0, -2).") VALUES (".substr($query2, 0, -2).")";

	if(DEBUG_INSERT) $time_start = microtime(TRUE);
	$result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_insert_data): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
	if(DEBUG_INSERT) {
		$DEBUG_db->queryCount++;
		$DEBUG_db->queries[] = array('time' => (microtime(TRUE)-$time_start)*1000, 'sql' => $query);
	}
	return Mysql_Insert_ID();
}//db_insert_data()


/**
  * Update data in the database
	*
	* This should be used instead of issuing UPDATE queries directly
	*
	* @param string Table where the data should be stored
	* @param string WHERE statement that defines the rows to be updated
	* @param array Data array with the keys beeing the name of the db columns
	*/
function db_update_data($table, $where, $data) {
	global $DEBUG_db;

	$query = "UPDATE $table SET ";
	//Alle Daten setzen
	foreach($data as $key => $value) {
		if((string)$value == "NULL") {
			$query .= "`$key` = NULL, ";
		} else {
			$query .= "`$key` = '".mysql_real_escape_string(stripslashes($value))."', ";
		}
	}
	$query = substr($query, 0, -2);

	//WHERE-Bedingung
	$query .= " $where ";

	if(DEBUG_UPDATE) $time_start = microtime(TRUE);
	$result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_update_data): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
	if(DEBUG_UPDATE) {
		$DEBUG_db->queryCount++;
		$DEBUG_db->queries[] = array('time' => (microtime(TRUE)-$time_start)*1000, 'sql' => $query);
	}
}//db_update_data()


/**
  * Delete data from the database
	*
	* This should be used instead of issuing DELETE queries directly
	*
	* @param string Table where the data should be deleted
	* @param string WHERE statement that defines the rows to be deleted
	*/
function db_delete_data($table, $where) {
	global $DEBUG_db;

	$query = "DELETE FROM $table $where";
	if(DEBUG_DELETE) $time_start = microtime(TRUE);
	$result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_delete_data): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
	if(DEBUG_DELETE) {
		$DEBUG_db->queryCount++;
		$DEBUG_db->queries[] = array('time' => (microtime(TRUE)-$time_start)*1000, 'sql' => $query);
	}
}//db_delete_data()


/**
  * Update data in the database
	*
	* This should be used instead of issuing SELECT queries directly
	*
	* @param string Table where the data should be selected from
	* @param string WHERE statement that defines the rows to be selected
	* @param string Comma seperated value with the columns to be selected. * for all of them
	* @param string ORDER BY statement
	* @param string LIMIT statement
	* @param boolean Returns a single entry if set, otherwise an array of entries is returned with their ids as keys
	*/
function db_select_data($table, $where, $columns="*", $order="", $limit="", $single=FALSE, $no_index=FALSE) {
	global $DEBUG_db;

	//Spalten
	if(is_array($columns)) {
		foreach($columns as $col_i => $col) $columns[$col_i] = "`".$col."`";
		$columns = implode(",", $columns);
	}

	$query = "SELECT $columns FROM $table $where $order $limit";
	if(DEBUG_SELECT) $time_start = microtime(TRUE);
	$result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_select_data): '.mysql_errno().': '.mysql_error(). ' QUERY: '.$query, E_USER_ERROR);
	if(DEBUG_SELECT) {
		$DEBUG_db->queryCount++;
		$DEBUG_db->queries[] = array('time' => (microtime(TRUE)-$time_start)*1000, 'sql' => $query);
	}
	if(mysql_num_rows($result) == 0) {
		return;
	} else if($single && mysql_num_rows($result) == 1) {
		$return = mysql_fetch_assoc($result);
		return $return;
	} else {
		if($no_index) {
			$index = '';
		} elseif($columns == '*' || FALSE !== strpos($columns, 'AS id') || in_array('id', explode(',', $columns)) || in_array('*', explode(',', $columns))) {
			$index = 'id';
		} else {
			$cols = explode(",", $columns);
			$index = trim(str_replace("`", "", $cols[0]));
		}
		$return = array();
		while($row = mysql_fetch_assoc($result)) {
			if($index) {
				$return[$row[$index]] = $row;
			} else {
				$return[] = $row;
			}
		}
		return $return;
	}
}//db_select_data()



/**
	* Get the value of a single column
	*
	* @param string Table to select data from
	* @param string WHERE statement
	* @param string Name of column to get value for
	* @return mixed Value from database
	*/
function db_get_column($table, $where, $column, $split=" ") {
	if(is_int($where)) {
		$where = "WHERE `id` = '$where'";
	} else if(substr($where, 0, 5) == "WHERE") {
		$where = $where;
	} else return FALSE;

	//Allow several columns
	if(strstr($column, ",")) {
		$new = array();
		foreach(explode(",", $column) as $col) {
			$new[] = "`".$col."`";
		}
		$column = implode(",", $new);
	} else {
		$column = "`".$column."`";
	}

	$row = db_select_data($table, $where, $column, '', '', TRUE);
	return implode($split, $row);
}//db_get_column()


/**
  * Execute a distinct select
	*
	* @param string Table to get the data from
	* @param string Column to get the values from
	* @param string ORDER BY statement
	* @return array All the different values
	*/
function db_select_distinct($table, $col, $order_="", $where="", $case_sensitive=FALSE) {
	global $DEBUG_db;

	$r = array();

	$order = $order_ ? $order_ : "ORDER BY $col ASC";

	if($case_sensitive) $query = "SELECT DISTINCT BINARY $col AS $col FROM $table $where $order";
	else $query = "SELECT DISTINCT $col FROM $table $where $order";
	if(DEBUG_SELECT) $time_start = microtime(TRUE);
	$result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_select_distinct): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
	if(DEBUG_SELECT) {
		$DEBUG_db->queryCount++;
		$DEBUG_db->queries[] = array('time' => (microtime(TRUE)-$time_start)*1000, 'sql' => $query);
	}
	while($row = mysql_fetch_assoc($result)) {
    $r[] = $row[$col];
	}
	return $r;
}//db_select_distinct()


/**
  * Execute an alter table statement
	*
	* @param string Table to alter
	* @param string new value
	*/
function db_alter_table($table, $change) {
	$query = "ALTER TABLE `$table` $change";
	$result = mysql_query($query);
	if($result === FALSE) trigger_error('DB ERROR (db_alter_table): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
}//db_alter_table()


/**
  * Parses an SQL string and updates the kOOL-database accordingly
	*
	* Used in /install/index.php and the plugins
	*
	* @param string SQL statement of the entry to be
	*/
function db_import_sql($tobe) {
	$create_code = 'CREATE TABLE `%s` (%s)';
	$alter_code  = 'ALTER TABLE `%s` CHANGE `%s` %s';
	$add_code    = 'ALTER TABLE `%s` ADD %s';

	//find tables in actual db
	$is_tables = NULL;
	$result = mysql_query("SHOW TABLES");
	while($row = mysql_fetch_row($result)) {
		$is_tables[] = $row[0];
	}

	$table = "";
	foreach(explode("\n", $tobe) as $line) {

		$line = trim($line);


		//don't allow any destructive commands
		if(strstr(strtoupper($line), "DROP ") || strstr(strtoupper($line), "TRUNCATE ") || strstr(strtoupper($line), "DELETE ")) {
			continue;
		}


		//INSERT Statement
		if(strtoupper(substr($line, 0, 11)) == "INSERT INTO") {
			$do_sql[] = $line;
			continue;
		}


		//UPDATE Statement
		if(strtoupper(substr($line, 0, 7)) == "UPDATE ") {
			$do_sql[] = $line;
			continue;
		}


		//ALTER Statement
    if(strtoupper(substr($line, 0, 6)) == "ALTER ") {
      $do_sql[] = $line;
      continue;
    }


		//start of a create table statement
		if(strtoupper(substr($line, 0, 12)) == "CREATE TABLE") {
			//find table-name to be edited
			$temp = explode(" ", $line);
			$table = str_replace("`", "", trim($temp[2]));

			//find table in current db
			if(in_array($table, $is_tables)) {
				//table already exists - get table create definition
				$result = mysql_query("SHOW CREATE TABLE $table");
				$row = mysql_fetch_row($result);
				$is = $row[1];
				$new_table = FALSE;
			} else {
				//create table
				$is = array();
				$new_table = TRUE;
				$new_table_sql = "";
			}
			continue;
		}

		//end of create table
		else if(substr($line, 0, 1) == ")") {
			if($new_table_sql != "") {
				$do_sql[] = sprintf($create_code, $table, $new_table_sql);
			}
			$new_table_sql = ""; $new_table = FALSE;
			$table = "";
			continue;
		}

		else if(strstr($line, "KEY")) {
			if($new_table) {
				$new_table_sql .= $line;
			}
			continue;
		}

		//empty or comment line
		else if(substr($line, 0, 1) == "#" || substr($line, 0, 1) == "-" || $line == "") {
			continue;
		}
			
		//line inside of a create table statement
		else {
			if(!$table) continue;

			//find field name
			$temp = explode(" ", $line);
			$field = $temp[0];

			//check for this field in db
			$found = FALSE;
			foreach(explode("\n", $is) as $is_line) {
				$is_line = trim($is_line);
				$temp = explode(" ", $is_line);
				$is_field = $temp[0];
				if($is_field == $field) {
					//field found
					$found = TRUE;
					//change if not the same
					if($is_line != $line) {
						$do_sql[] = sprintf($alter_code, $table, str_replace("`", "", $field), $line);
					}
				}
			}//foreach(is as is_line)

			//add field if not found in existing table definition
			if(!$found) {
				if($new_table) {
					$new_table_sql .= $line;
				} else {
					$do_sql[] = sprintf($add_code, $table, $line);
				}
			}

		}//if..else(line == CREATE TABLE)
	}//foreach(tobe as line)

	//print_d($do_sql);
	//return;

	foreach($do_sql as $query) {
		if($query) {
			if(substr($query, -1) == ",") $query = substr($query, 0, -1);
			$result = mysql_query($query);
			if($result === FALSE) trigger_error('DB ERROR (db_import_sql): '.mysql_errno().': '.mysql_error(), E_USER_ERROR);
		}
	}
}//db_import_sql()




/**
 * Performs a fuzzy search in a db table
 * The search is performed by concatenating the db field values to a single string
 * and calculating the Levenshtein difference.
 * The best match is returned if it is in the given limit.
 *
 * @param array Data array with column names as indizes
 * @param string DB table
 * @param int Maximum allowed errors per db column
 * @param boolean Set to false to ignore the case
 * @param int Levenshtein limit which must be reached to treat the best find as a valuable find
 *
 * return array IDs of db entries with the best levenshtein difference
 */
function ko_fuzzy_search($data, $table, $error=1, $case=FALSE, $lev_limit="") {
	//Get all DB columns
	foreach($data as $col => $value) {
		$cols[] = $col;
	}
	$num_cols = sizeof($cols);

	//Concatenate data to search for
	$orig = implode("", $data);
	$orig_length = strlen($orig);
	//Calculate limit for string length
	$limit = $num_cols*$error+1;

	//Calculate lev limit
	if(!$lev_limit) {
		$lev_limit = $limit;
		$lev_limit = $num_cols*$error-1;
	}

	//Only get db entries matching the total string length (+/- limit) of the original data
	$query  = "SELECT id, CONCAT(`".implode("`, `", $cols)."`) as teststring FROM `$table` ";
	$query .= "WHERE (CHAR_LENGTH(`".implode("`)+CHAR_LENGTH(`", $cols)."`)) > ".($orig_length-$limit)." ";
	$query .= "AND (CHAR_LENGTH(`".implode("`)+CHAR_LENGTH(`", $cols)."`)) < ".($orig_length+$limit)." ";
	$query .= "AND deleted = '0'";

	//Find the best matching db entry
	$result = mysql_query($query);
	$best = 100;
	while($row = mysql_fetch_assoc($result)) {
		if($case) {
			$lev = levenshtein($orig, $row["teststring"]);
		} else {
			$lev = levenshtein(strtolower($orig), strtolower($row["teststring"]));
		}
		if($lev <= $best) {
			$found[$lev][] = $row["id"];
			$best = $lev;
		}
	}

	//Return ID if levenshtein difference is smaller than limit
	if($best <= $lev_limit) {
		return $found[$best];
	} else {
		return FALSE;
	}
}//ko_fuzzy_search()









/************************************************************************************************************************
 *                                                                                                                      *
 * Export-FUNKTIONEN                                                                                                    *
 *                                                                                                                      *
 ************************************************************************************************************************/


/**
 * Creates an XLS file
 * Based upon php_writeexcel (http://www.bettina-attack.de/jonny/view.php/projects/php_writeexcel)
 * 
 * @param array header: Array holding the header row's cells
 * @param array data: Two dimensional array holding the cell's values
 * @param string filename: Filename two use for the xls file
 * @param string title: Title for the worksheet
 * @param string format: landscape or portrait
 */
function ko_export_to_excel($header, $data, $filename, $title, $format="landscape") {
	global $ko_path;

	require($ko_path.'inc/class.excelwriter.php');
	
	$workbook = new writeexcel_workbook($filename);
	$worksheet =& $workbook->addworksheet(substr($title, 0, 30));
	if($format == "landscape") $worksheet->set_landscape();
	else $worksheet->set_portrait();

	//set encoding
	//$worksheet->setInputEncoding('ISO-8859-1');

  $col = $row = 0;

	//Define formats
	$format_header =& $workbook->addformat(array('bold' => 1, 'color' => 'blue'));
	$format_title =& $workbook->addformat(array('bold' => 1, 'size' => '12'));
	$format_subtitle =& $workbook->addformat(array('bold' => 1));

	//Add header
	if(is_array($header)) {
		if(isset($header['header'])) {
			//Add title
			if($header['title']) {
				$worksheet->write($row++, 0, $header['title'], $format_title);
			}
			//Add subtitle
			if(is_array($header['subtitle']) && sizeof($header['subtitle']) > 0) {
				foreach($header['subtitle'] as $k => $v) {
					$worksheet->write($row, 0, $k.':', $format_subtitle);
					$worksheet->write($row++, 1, $v);
				}
			} else if($header['subtitle']) {
				$worksheet->write($row++, 0, $header['subtitle'], $format_subtitle);
			}
			$row++;
			//Add column headers
			$col = 0;
			foreach($header['header'] as $h) {
				$worksheet->write($row, $col++, ko_unhtml($h), $format_header);
			}
			$row++;
		}
		else {
			foreach($header as $h) {
				$worksheet->write($row, $col++, ko_unhtml($h), $format_header);
			}
			$row++;
		}
	}

	//Daten
	foreach($data as $dd) {
		$col=0;
		foreach($dd as $d) {
			$worksheet->write($row, $col++, ko_unhtml($d));
		}
		$row++;
	}
	$workbook->close();
	unset($workbook);

}//ko_export_to_excel()



/**
  * Erstellt PDf-Kalender der Wochenansicht
	*/
function ko_export_cal_pdf_week($filename, $daynames, $hour, $legende, $title) {
	global $BASE_URL, $BASE_PATH;

	define('FPDF_FONTPATH',$BASE_PATH.'fpdf/schriften/');
	require($BASE_PATH.'fpdf/fpdf.php');

	$pdf=new FPDF('L', 'mm', 'A4');
	$pdf->Open();
	$pdf->SetAutoPageBreak(true, 10);
	$pdf->SetMargins(5, 5, 5);  //left, top, right
	$pdf->AddFont('arial','','arial.php');
	$pdf->AddFont('arialb','','arialb.php');
	$pdf->AddPage();

	//Spaltenbreiten fr Tabelle
	$width_time = 12;
	$width_day = 37;
	$height_title = 10;
	//$height_day = 9;
	$hour_start = ko_get_setting("cal_woche_start");
  $hour_end = ko_get_setting("cal_woche_end");
	$height_day = (210*0.75)/($hour_end-$hour_start+1);
	$offset_x = 1;
	$offset_y = 5;

	$top = 13;
	$left = 7;


	//Titel
	$pdf->SetFont('arialb', '', 13);
	$pdf->Text($left, $top-3, $legende["titel"]." ".getLL("week")." ".$title);
	$pdf->SetFont('arial', '', 10);
	$pdf->Text(290-$pdf->GetStringWidth($BASE_URL), $top-3, $BASE_URL);

	//Tabellen-Header
	$pdf->SetFont('arialb', '', 11);
	$pdf->SetTextColor(0);
	$pdf->SetLineWidth(0.1);
	$pdf->SetDrawColor(160);
	$pdf->SetFillColor(200);

	$x = $left;
	$y = $top;
	//Zeit links
	$pdf->Rect($x, $y, $width_time, $height_title, "FD");
	$pdf->Text($x+$offset_x, $y+$offset_y, getLL("daten_time"));
	$x+=$width_time;
	//Tagesnamen
	foreach($daynames as $d) {
		$text = explode("<br />", $d);
		$pdf->Rect($x, $y, $width_day, $height_title, "FD");
		foreach($text as $i => $t) {
			$pdf->Text($x+($width_day-$pdf->GetStringWidth($t))/2, $y+$offset_y-1+$i*4, $t);
		}
		$x += $width_day;
	}
	//Zeit links
	$pdf->Rect($x, $y, $width_time, $height_title, "FD");
	$pdf->Text($x+$offset_x, $y+$offset_y, getLL("daten_time"));

	$y += ($height_title - $height_day);

	//Stunden-Zeile
	$pdf->SetFont('arial', '', 10);
	$pdf->SetTextColor(0);
	$done = array();
	foreach($hour as $h_i => $h) {
		//Eine Zeile nach unten
		$x = $left;
		$y += $height_day;

		$h = $h["day"];
		//Zeit-Spalte
		$pdf->SetFillColor(200);
		$time = ($h_i."-".((int)$h_i+1));
		$pdf->Rect($x, $y, $width_time, $height_day, "FD");
		$pdf->Text($x+$offset_x, $y+$offset_y, $time);
		$x += ($width_time-$width_day);
		$pdf->SetFillColor(0);

		for($t_inc = 0; $t_inc < 7; $t_inc++) {
			$x += $width_day;

			//Inhalt der Stunde ausgeben
			if($h[$t_inc]["empty"]) {
				//Leere Stunde einfach belassen
			} else {
				//Breite der einzelnen Termine berechnen
				$cols = $h[$t_inc]["cols"];
				$width_p = substr($h[$t_inc]["col_width"], 0, -1);  // % entfernen
				$width = ($width_day-0.2) / 100 * $width_p;
				$x_col = $x+0.1;
				//Alle Termine nebeneinander ausgeben
				foreach($cols as $col) {
					if(!$col["item_id"]) {
						$x_col += $width;
						continue;
					}
					//Farbe definieren
					$color_hex = $col["color"];
					if(!$color_hex) $color_hex = "999999";
					$pdf->SetFillColor(hexdec(substr($color_hex, 0, 2)), hexdec(substr($color_hex, 2, 2)), hexdec(substr($color_hex, 4, 2)));
					$pdf->Rect($x_col, ($y+0.1), $width-0.05, ($height_day-0.2), "F");
					//Bei der letzten Stunde die Eventgruppen-ID angeben, fr die Legende
					if($col["last"]) {
						$pdf->SetFont('arial', '', 8);
						$pdf->Text(($x_col+$width-$pdf->GetStringWidth($col["item_id"])-0.5), ($y+$height_day-0.5), $col["item_id"]);
						$pdf->SetFont('arial', '', 11);
					}
					//Eventgruppen-IDs speichern, fr die Legende
					$done[] = $col["item_id"];
					$x_col += $width;
				}
			}//if(!h[t_inc][empty])
			
			//Rahmen fr diese Stunde
			$pdf->Rect($x, $y, $width_day, $height_day);
		}//for(t_inc = 0..7)

		//Letzte Zeit-Spalte
		$pdf->SetFillColor(200);
		$x += $width_day;
		$pdf->Rect($x, $y, $width_time, $height_day, "FD");
		$pdf->Text($x+$offset_x, $y+$offset_y, $time);
		$pdf->SetFillColor(0);
	}//foreach(hour as h)

	$done = array_unique($done);
	sort($done);


	//Legende
	$x = $left;
	$y_legende = $y = ($y+$height_day+8);
	$pdf->SetFont('arialb', '', 11);
	$pdf->Text($x, $y-2, getLL("legend").":");
	$pdf->SetFont('arial', '', 11);

	$max = 0; $counter = 0;
	foreach($done as $i) {
		$counter++;
		$color_hex = $legende[$i]["color"];
		if(!$color_hex) $color_hex = "cccccc";
		$pdf->SetFillColor(hexdec(substr($color_hex, 0, 2)), hexdec(substr($color_hex, 2, 2)), hexdec(substr($color_hex, 4, 2)));
		$pdf->Rect($x, $y, $pdf->GetStringWidth("$i: ".$legende[$i]["name"])+1, 5, "F");
		$pdf->Text($x+0.5, $y+4, "$i: ".$legende[$i]["name"]);
		$max = max($max, $pdf->GetStringWidth("$i: ".$legende[$i]["name"]));
		$y += 5;
		if($y > 205) {
			$y = $y_legende;
			$x += $max+10;
		}
	}

	$file = $BASE_PATH."download/pdf/".$filename;
	$ret = $pdf->Output($file);
}//ko_export_cal_pdf_week()




/**
  * Exportiert einen Monat als PDF
	*/
function ko_export_cal_one_month(&$pdf, $monat, $jahr, $kw, $day, $titel, $show_comment=FALSE) {
	global $BASE_URL;

	$monthly_title = ko_get_setting('daten_monthly_title');

	//Datums-Berechnungen
	//Start des Monats
	$startdate = date($jahr."-".$monat."-01");
	$today = date("Y-m-d");
	$startofmonth = $date = $startdate;
	$month_name = strftime("%B", strtotime($date));
	$year_name = strftime("%Y", strtotime($date));

	//Den letzten Tag dieses Monats finden
	$endofmonth = add2date($date, "monat", 1, TRUE);
	$endofmonth = add2date($endofmonth, "tag", -1, TRUE);
	//Ende der letzten Woche dieses Monats finden
	$enddate = date_find_next_sunday($endofmonth);
	//Start der ersten Woche dieses Monats finden
	$date = date_find_last_monday($date);

	$testdate = $date;
	$dayofweek = $num_weeks = 0;
	while((int)str_replace("-", "", $testdate) <= (int)str_replace("-", "", $endofmonth)) {
		$dayofweek++;
		$testdate = add2date($testdate, "tag", 1, TRUE);
		if($dayofweek == 7) {
			$num_weeks++;
			$dayofweek = 0;
		}
	}
	//Falls Sonntag letzter Tag im Monat, wieder eine Woche abziehen
	if((int)$dayofweek == 0) $num_weeks--;


	$pdf->AddPage();

	//Spaltenbreiten fr Tabelle
	$width_kw = 12;
	$width_day = 39;
	$height_title = 7;
	//$height_day = 9;
	$height_day = (210*0.8)/($num_weeks+1);
	$height_dayheader = 5;
	$height_event_default = 5;
	$offset_x = 1;
	$offset_y = 4;

	$top = 18;
	$left = 7;



	//Titel
	$pdf->SetFont('arialb', '', 13);
	$pdf->Text($left, $top-3, "$titel $month_name $year_name");
	$pdf->SetFont('arial', '', 10);
	$pdf->Text(290-$pdf->GetStringWidth($BASE_URL), $top-3, $BASE_URL);

	//Tabellen-Header
	$pdf->SetFont('arialb', '', 11);
	$pdf->SetTextColor(0);
	$pdf->SetLineWidth(0.1);
	$pdf->SetDrawColor(160);
	$pdf->SetFillColor(200);

	$x = $left;
	$y = $top;
	//KW
	$pdf->Rect($x, $y, $width_kw, $height_title, "FD");
	$pdf->Text($x+$width_kw/2-$pdf->GetStringWidth("KW")/2, $y+5, "KW");
	$x+=$width_kw;
	//Tagesnamen
	$monday = date_find_last_monday(date("Y-m-d"));
	for($i=0; $i<7; $i++) {
		$t = strftime("%A", strtotime(add2date($monday, "tag", $i, TRUE)));
		$pdf->Rect($x, $y, $width_day, $height_title, "FD");
		$pdf->Text($x+($width_day-$pdf->GetStringWidth($t))/2, $y+5, $t);
		$x += $width_day;
	}

	$x = $left;
	$y += $height_title;

	//Alle anzuzeigenden Tage durchlaufen
	$dayofweek = $weekcounter = 0;
	while((int)str_replace("-", "", $date) <= (int)str_replace("-", "", $enddate)) {
		$pdf->SetTextColor(0);
		$thisday = $day[(int)substr($date, 8, 2)];
		$thisday['tag'] = (int)substr($date, 8, 2);
		//KW ausgeben
		if($dayofweek == 0) {
			$pdf->SetFillColor(200);
			$pdf->Rect($x, $y, $width_kw, $height_day, "FD");
			$pdf->SetFont('arialb', '', 11);
			$pdf->Text($x+$width_kw/2-$pdf->GetStringWidth($kw[$weekcounter])/2, $y+5, $kw[$weekcounter]);
			$weekcounter++;
			$x += $width_kw;
		}
		//Tag vor und nach aktuellem Monat
		if(substr($date, 5, 2) != $monat) {
			$pdf->SetFillColor(230);
			$pdf->Rect($x, $y, $width_day, $height_day, "FD");
		}
		//Tage dieses Monates
		else {
			$pdf->Rect($x, $y, $width_day, $height_day, "D");
			//Tages-Nummer
			$pdf->SetFont('arialb', '', 10);
			$pdf->Text( ($x+$width_day-$pdf->GetStringWidth($thisday["tag"])-$offset_x), $y+$offset_y, $thisday["tag"]);
			$y_day = $y+$height_dayheader;
			//Hhe der Termineintrge berechnen
			$num_events = sizeof($thisday["inhalt"]);
			//Add titles
			if($show_comment) {
				foreach($thisday["inhalt"] as $temp) {
					if($temp["kommentar"] != "") $num_events++;
				}
			}
			if($num_events > 0) {
				$height_event = $height_event_default;
				if( ($num_events*$height_event) > ($height_day-$height_dayheader) ) {
					$height_event = ($height_day-$height_dayheader)/$num_events;
				}
				$offset_y_events = 0.75 * $height_event;
				$height_event_1 = $height_event;
				foreach($thisday["inhalt"] as $c) {
					if($show_comment && $c["kommentar"] != "") $height_event = 2* $height_event_1;
					else $height_event = $height_event_1;

					$color_hex = $c["farbe"] ? $c["farbe"] : "999999";
					$pdf->SetFillColor(hexdec(substr($color_hex, 0, 2)), hexdec(substr($color_hex, 2, 2)), hexdec(substr($color_hex, 4, 2)));
					$pdf->Rect($x+0.1, $y_day, $width_day-0.2, $height_event, "F");
					if($num_events > 11) {
            $pdf->SetFont('arial', '', 7);
						$font2 = 7;
          } else if($num_events > 8) {
            $pdf->SetFont('arial', '', 8);
						$font2 = 7;
          } else {
            $pdf->SetFont('arial', '', 9);
						$font2 = 8;
					}
					$t = ($c["zeit"] != "" ? $c["zeit"].": " : "").ko_unhtml($c["text"]);
					while($pdf->GetStringWidth($t) > ($width_day-2*$offset_x)) {
						$t = substr($t, 0, -1);
					}
					$textcolor = ko_get_contrast_color($color_hex, '000000', 'ffffff');
					$pdf->SetTextColor(hexdec(substr($textcolor, 0, 2)), hexdec(substr($textcolor, 2, 2)), hexdec(substr($textcolor, 4, 2)));
					$pdf->Text($x+$offset_x, $y_day+$offset_y_events, $t);

					//Add title
					if($show_comment && $c["kommentar"]) {
						$y_day += $height_event/2;
						$t = " ".ko_unhtml($c["kommentar"]);
						$pdf->SetFont('arial', '', $font2);
						while($pdf->GetStringWidth($t) > ($width_day-2*$offset_x)) {
							$t = substr($t, 0, -1);
						}
						$pdf->Text($x+$offset_x, $y_day+$offset_y_events, $t);
						$y_day += $height_event/2;
					} else {
						$y_day += $height_event;
					}

				}
			}//if(num_events > 0)
		}//if(DAY(date) != monat)
		$x += $width_day;
		$dayofweek++;
		$date = add2date($date, "tag", 1, TRUE);
		if($dayofweek == 7) {
			$dayofweek = 0;
			$y += $height_day;
			$x = $left;
		}
	}//while(date < enddate)
}//ko_export_cal_pdf_month()





/**
	* Liefert alle Layouts fr den PDF-Daten-Export
	*/
function ko_get_pdf_daten_layout(&$layout, $id = "") {
	$where = $id ? "WHERE `id` = '$id'" : 'WHERE 1=1';
	$layout = db_select_data('ko_pdf_daten_layout', $z_where);
}//ko_get_pdf_daten_layout()


/**
	* Liefert ein einzelnes PDF-Daten-Export-Setting, das z.B. einen Titel oder eine Fusszeile enthlt
	*/
function ko_get_pdf_daten_setting($type, $key) {
	$row = db_select_data('ko_pdf_daten_settings', "WHERE `type`='$type' AND `key`='$key'", '*');;
	return $row['value'];
}//ko_get_pdf_setting()


/**
	* Speichert ein PDF-Daten-Export-Setting
	*/
function ko_save_pdf_daten_setting($type, $key, $value) {
	$type = format_userinput($type, "alphanum+");
	$key = format_userinput($key, "uint");
	$value = format_userinput($value, "text");

	if(db_get_count('ko_pdf_daten_settings', 'type', "AND `type` = '$type' AND `key` = '$key'") == 1) {
		db_update_data('ko_pdf_daten_settings', "WHERE `key` = '$key' AND `type` = '$type'", array('value' => $value));
  } else {
		db_insert_data('ko_pdf_daten_settings', array('type' => $type, 'key' => $key, 'value' => $value));
  }
}//ko_save_pdf_daten_setting()


/**
	* Liefert alle oder eine einzelne Gruppe eines PDF-Daten-Export Layouts
	*/
function ko_get_pdf_daten_group(&$group, $id = "") {
	$z_where = $id ? "WHERE `id` = '$id'" : 'WHERE 1=1';

	$group = db_select_data('ko_pdf_daten_groups', $z_where);
}//ko_get_pdf_daten_group()



/**
  * Generiert Personen-Liste gemss Einstellungen (Familie, Personen oder gemss "AlsFamilieExportieren")
	*/
function ko_generate_export_list($personen, $familien, $mode) {
	if($mode == "p") {
		return array(implode(",", $personen), "");
	}
	else if($mode == "f" || $mode == "def") {
		if(is_array($personen)) {
			foreach($personen as $pid) {
				if($pid) {
					ko_get_person_by_id(format_userinput($pid, "uint"), $p);
					if($p["famid"] > 0) {
						$f = ko_get_familie($p["famid"]);
						if($mode == "f" || ($f["famgembrief"] == "ja" || !isset($f["famgembrief"]))) {
							$fam[] = $p["famid"];
						} else {
							$person[] = $p["id"];
						}
					} else {
						$person[] = format_userinput($pid, "uint");
					}
				}//if(pid)
			}//foreach(personen as pid)
			$xls_auswahl = implode(",", $person);
		} else {
			$xls_auswahl = "";
		}

		if(is_array($familien)) {
			foreach($familien as $f) {
				if($f) $fam[] = format_userinput($f, "uint");
			}
		}
		$xls_fam_auswahl = is_array($fam) ? implode(",", array_unique($fam)) : "";
	}//if(mode == f)

	return array($xls_auswahl, $xls_fam_auswahl);
}//ko_generate_export_list()




function ko_export_etiketten($_vorlage, $_start, $_rahmen, $data, $fill_page=0, $return_address=FALSE) {
	global $BASE_PATH;

	ko_get_etiketten_vorlage(format_userinput($_vorlage, "js"), $vorlage);
	$start = format_userinput($_start, "uint");

	//Fill page if needed
	$fill_page = format_userinput($fill_page, "uint");
	if($fill_page > 0) {
		$total = sizeof($data);
		$available = $fill_page*(int)$vorlage["per_col"]*(int)$vorlage["per_row"]-$start+1;
		$new = $total;
		while($new < $available) {
			$data[$new] = $data[(int)fmod($new, $total)];
			$new++;
		}
	}//if(fill_page)


	//PDF starten
  define('FPDF_FONTPATH',$BASE_PATH.'fpdf/schriften/');
  require($BASE_PATH.'fpdf/mc_table.php');
  $pdf=new PDF_MC_Table('P', 'mm', 'A4');
  $pdf->Open();
  $pdf->SetAutoPageBreak(false);
  $pdf->calculateHeight(false);
	$pdf->SetMargins($vorlage["border_left"], $vorlage["border_top"], $vorlage["border_right"]);
	$pdf->AddFont('arial','','arial.php');
	$pdf->AddPage();

	//Spaltenbreiten ausrechnen
	$page_width = 210 - $vorlage["border_left"] - $vorlage["border_right"];
	$col_width = $page_width / $vorlage["per_row"];
	$cols = array();
	for($i = 0; $i < $vorlage["per_row"]; $i++) $cols[] = $col_width;
	$pdf->SetWidths($cols);

	//Zeilenhhe
	$page_height = 297 - $vorlage["border_top"] - $vorlage["border_bottom"];
	$row_height = $page_height / $vorlage["per_col"];
	$pdf->SetHeight($row_height);

	//Rahmen
	if($_rahmen == "ja") $pdf->border(TRUE);
	else $pdf->border(FALSE);

	//Text-Ausrichtung
	for($i = 0; $i < $vorlage["per_row"]; $i++) $aligns[$i] = $vorlage["align_horiz"]?$vorlage["align_horiz"]:"L";
	for($i = 0; $i < $vorlage['per_row']; $i++) {
		$valigns[$i] = $vorlage['align_vert']?$vorlage['align_vert']:'T';
		//Don't allow center align with return address, as this may lead to overlapping text
		if($return_address && $valigns[$i] == 'C') $valigns[$i] = 'T';
	}

	//Prepare return address
	if($return_address) {
		$ra  = ko_get_setting('info_name') ? ko_get_setting('info_name').', ' : '';
		$ra .= ko_get_setting('info_address') ? ko_get_setting('info_address').', ' : '';
		$ra .= ko_get_setting('info_zip') ? ko_get_setting('info_zip').' ' : '';
		$ra .= ko_get_setting('info_city') ? ko_get_setting('info_city').', ' : '';
		if(substr($ra, -2) == ', ') $ra = substr($ra, 0, -2);

		$ra_aligns = $ra_valigns = array();
		for($c = 1; $c <= $vorlage['per_row']; $c++) {
			$ra_aligns[] = 'L';
			$ra_valigns[] = 'T';
		}
	}

	//Etiketten schreiben
	$all_cols = sizeof($data);
	$last = FALSE;
	$firstpage = TRUE;
	$do_label = FALSE;
	$done = 0;
	$page_counter = 0;
	while(!$last) {
		for($r = 1; $r <= $vorlage["per_col"]; $r++) {  //ber alle Zeilen
			$row = array();
			if($return_address) $ra_row = array();
			$do_row = FALSE;
			if(!$last) {
				for($c = 1; $c <= $vorlage["per_row"]; $c++) {  //ber alle Spalten
					$cell_counter++;
					if($firstpage) {  //Auf erster Seite nach erster zu druckenden Etikette suchen
						if($cell_counter >= $start) $do_label = TRUE;
					}//if(firstpage)

					if($do_label) {
						if($done >= $all_cols) $last = TRUE;
						if(!$last) {
							$row[] = $data[$done];
							if($return_address) $ra_row[] = $ra;
							$do_row = TRUE;
							$done++;
						}//if(!last)
					}//if(do_label)
					else {
						$row[] = ' ';
						if($return_address) $ra_row[] = ' ';
					}

				}//for(c=1..vorlage[per_row])

				//Print return address on each label of this row
				if($return_address && $do_row) {
					//Store coordinates and line height
					$save['x'] = $pdf->GetX();
					$save['y'] = $pdf->GetY();
					$save['zeilenhoehe'] = $pdf->zeilenhoehe;

					//Print return address
					$ra_margin_left = $vorlage['ra_margin_left'] ? $vorlage['ra_margin_left'] : 3;
					$ra_margin_top = $vorlage['ra_margin_top'] ? $vorlage['ra_margin_top'] : 5;
					$ra_textsize = $vorlage['ra_textsize'] ? $vorlage['ra_textsize'] : 8;

					$pdf->SetFont('arial', '', $ra_textsize);
					$pdf->SetZeilenhoehe(3.5);
					$pdf->SetAligns($ra_aligns);
					$pdf->SetvAligns($ra_valigns);
					$pdf->SetInnerBorders($ra_margin_left, $ra_margin_top);
					$pdf->Row($ra_row);
					//Add a line beneath the return address
					$lines = $pdf->NbLines($col_width-2*$ra_margin_left, $ra);
					$line_top = $save['y']+$ra_margin_top+3.5*$lines;
					$pdf->Line($vorlage['border_left'], $line_top, 210-$vorlage['border_right'], $line_top);

					//Restore coordinates and line height 
					$pdf->SetXY($save['x'], $save['y']);
					$pdf->SetZeilenhoehe($save['zeilenhoehe']);
				} else {
					$ra_margin_top = 0;
				}

				//Set aligns, font and border for actual address content
				$pdf->SetAligns($aligns);
				$pdf->SetvAligns($valigns);
				if($return_address && $valigns[0] == 'T') {
					$spacing_vert = max($vorlage['spacing_vert'], $line_top-$save['y']+2);
				} else {
					$spacing_vert = $vorlage['spacing_vert'];
				}
				$pdf->SetInnerBorders($vorlage['spacing_horiz'], $spacing_vert);
				$pdf->SetFont('arial', '', $vorlage["textsize"]?$vorlage["textsize"]:11 );
				$pdf->Row($row);
			}//if(!last)
		}//for(r=1..vorlage[per_col])
		$page_counter++;
		$firstpage = FALSE;
		if($done < $all_cols) $pdf->AddPage();
		$cell_counter = 0;
	}//while(!$last)

	$filename = $BASE_PATH."download/pdf/".getLL("leute_labels_filename").strftime("%d%m%Y_%H%M%S", time()).".pdf";
	$pdf->Output($filename);

	return "download/pdf/".basename($filename);
}//ko_export_etiketten()





function ko_get_pdf_fonts() {
	global $BASE_PATH;

	$fonts = array();
	$files_php = $files_z = array();

	$font_path = $BASE_PATH."fpdf/schriften";
	if($dh = opendir($font_path)) {
		while(($file = readdir($dh)) !== false) {
			if(substr($file, -2) == ".z") {
				$files_z[] = substr($file, 0, -2);
			} else if(substr($file, -4) == ".php") {
				$files_php[] = substr($file, 0, -4);
			}
		}
		closedir($dh);
	}

	foreach($files_z as $font) {
		if(!in_array($font, $files_php)) continue;
		$fonts[$font] = array("file" => $font.".php", "name" => getLL("fonts_".$font), "id" => $font);
	}

	return $fonts;
}//ko_get_pdf_fonts()





/**
 * Checks whether LaTeX is installed and pdflatex may be called
 */
function ko_latex_check() {
	exec('pdflatex -version', $ret);
	if(sizeof($ret) == 0) return FALSE;
	if(FALSE !== strpos($ret[0], 'TeX')) return TRUE;
	return FALSE;
}//ko_latex_check()




/**
 * Get all LaTeX layouts stored in latex/layouts for the given type (*.lco files)
 */
function ko_latex_get_layouts($type) {
	global $ko_path;

	$layouts = array();
	if($handle = opendir($ko_path.'latex/layouts/')) {
		while(false !== ($file = readdir($handle))) {
			if($file == '.' || $file == '..' || substr($file, -4) != '.lco' || substr($file, 0, strlen($type)) != $type) continue;
			$layouts[] = substr($file, strlen($type)+1, -4);
		}
	}
	closedir($handle);

	sort($layouts, SORT_LOCALE_STRING);
	return $layouts;
}//ko_latex_get_layouts()




/**
 * Escape charachters from user input so they will show correctly in LaTeX
 */
function ko_latex_escape_chars($text) {
	$map = array(
		'<' => '\textless{}',
		'>' => '\textgreater{}',
		'~' => '\textasciitilde{}',
		'^' => '\textasciicircum{}',
		'&' => '\&',
		'#' => '\#',
		'_' => '\_',
		'$' => '\$',
		'%' => '\%',
		'|' => '\docbooktolatexpipe{}',
		'{' => '\{',
		'}' => '\}',
	);

	return strtr(stripslashes($text), $map);
}//ko_latex_escape_chars()









/************************************************************************************************************************
 *                                                                                                                      *
 * Import-FUNKTIONEN                                                                                                    *
 *                                                                                                                      *
 ************************************************************************************************************************/

/**
  * Parses a vCard file (.vcf) and assigns the values to an array to be imported into ko_leute
	*/
function ko_parse_vcf($content) {
	$data = array();

	foreach($content as $line) {
		//Check for encodings
		$quoted = strstr($line, ";ENCODING=QUOTED-PRINTABLE");
		$utf8 = strstr($line, ";CHARSET=UTF-8");

		$line = preg_replace("/;ENCODING=QUOTED-PRINTABLE/", "", $line);
		$line = preg_replace("/;CHARSET=ISO-\d{4}-\d{1,2}/", "", $line);
		$line = preg_replace("/;CHARSET=UTF-8/", "", $line);

		//Find prop and value
		$temp = explode(":", $line);
		$prop = strtoupper($temp[0]);
		unset($temp[0]);
		$value = trim(implode(":", $temp));
		if($quoted) $value = quoted_printable_decode($value);
		if($utf8) $value = utf8_decode($value);

		//Begin of a vCard
		if($prop == "BEGIN" && $value == "VCARD") {
			$new_data = array();
		}
		//Name
		else if($prop == "N") {
			list($new_data["nachname"], $new_data["vorname"], $temp1, $new_data["anrede"], $temp2) = explode(";", $value);
		}
		//address
		else if(substr($prop, 0, 3) == "ADR") {
			$values = explode(";", $value);
			list($temp1, $new_data["adresse_zusatz"], $new_data["adresse"], $new_data["ort"], $temp2, $new_data["plz"], $new_data["land"]) = $values;
		}
		//Phone
		else if(substr($prop, 0, 3) == "TEL") {
			if(strstr($prop, "HOME")) {
				$new_data["telp"] = $value;
			} else if(strstr($prop, "WORK")) {
				$new_data["telg"] = $value;
			} else if(strstr($prop, "CELL")) {
				$new_data["natel"] = $value;
			} else if(strstr($prop, "FAX")) {
				$new_data["fax"] = $value;
			}
		}
		//email
		else if(substr($prop, 0, 5) == "EMAIL") {
			$new_data["email"] = $value;
		}
		//Birthdate
		else if(substr($prop, 0, 4) == "BDAY") {
			$new_data["geburtsdatum"] = substr($value, 0, 10);
		}
		//note
		else if(substr($prop, 0, 4) == "NOTE") {
			$new_data["memo1"] = $value;
		}
		//url
		else if(substr($prop, 0, 3) == "URL") {
			$new_data["web"] = $value;
		}
		//End of a vCard
		else if($prop == "END" && $value == "VCARD") {
			$data[] = $new_data;
		}
	}

	//prepare for mysql
	foreach($data as $key => $value) {
		foreach($value as $k => $v) {
			$return[$key][$k] = mysql_real_escape_string($v);
		}
	}
	return $return;
}//ko_parse_vcf()



/**
  * Runs some checks, before a csv import can be performed
	*/
function ko_parse_csv($content, $options, $test=FALSE, &$error) {
	$separator = $options["separator"];
	$content_separator = $options["content_separator"];
	$first_line = $options["first_line"];
	$dbcols = $options["dbcols"];
	$num_cols = sizeof($dbcols);

	//find date-cols
	$date_cols = $enum_cols = array();
	$table_cols = db_get_columns("ko_leute");
	foreach($table_cols as $col) {
		if($col["Type"] == "date") $date_cols[] = $col["Field"];
		if(substr($col["Type"],0,4) == "enum") $enum_cols[] = $col["Field"];
	}


	$error = 0;
	$data = array();
	$first = TRUE;
	foreach($content as $line) {
		$line = trim($line);

		//ignore first line if set
		if($first && $first_line) {
			$first = FALSE;
		} else {
			$first = FALSE;

			//get values from one line
			$parts = ko_get_csv_values($line, $separator, $content_separator);
	
			if($test) {
				if(sizeof($parts) < $num_cols) $error = 1;
				if(sizeof($parts) > $num_cols) $error = 2;
			} else {
				$new_data = array();
				foreach($dbcols as $col) {
					$new_data[$col] = mysql_real_escape_string(array_shift($parts));
					//create sql-date
					if(in_array($col, $date_cols)) {
						$new_data[$col] = sql_datum($new_data[$col]);
					}
					//Check for LL values in enum fields
					if(in_array($col, $enum_cols)) {
						$enums = db_get_enums("ko_leute", $col);
						//If not in English then try to find it in the ll version
						if(!in_array($new_data[$col], $enums)) {
							$enums_ll = db_get_enums_ll("ko_leute", $col);
							foreach($enums_ll as $key => $value) {
								if(strtolower($value) == strtolower($new_data[$col])) {
									$new_data[$col] = $key;
								}
							}
						}//if(!in_array(enums))
					}//if(enum_cols)
				}
				$data[] = $new_data;
			}//if..else(test)
		}//if..else(first)
	}//foreach(content as line)

	if($test) {
		if($error) return FALSE;
		else return TRUE;
	} else {
		return $data;
	}
}//ko_parse_csv()




/**
  * parses a csv line and returns the values as array
	* recognises values separated by sep and embraced between csep
	* from usercomments on php.net for function split()
	*/
function ko_get_csv_values($string, $sep=",", $csep="") {
	//no content separator, so just explode it
	if(!$csep) {
		$elements = explode($sep, $string);
	}
	else {
		$elements = explode($sep, $string);
		for ($i = 0; $i < count($elements); $i++) {
			$nquotes = substr_count($elements[$i], '"');
			if ($nquotes %2 == 1) {
				for ($j = $i+1; $j < count($elements); $j++) {
					if (substr_count($elements[$j], $csep) > 0) {
						// Put the quoted string's pieces back together again
						array_splice($elements, $i, $j-$i+1, implode($sep, array_slice($elements, $i, $j-$i+1)));
						break;
					}
				}
			}
			if ($nquotes > 0) {
				// Remove first and last quotes, then merge pairs of quotes
				$qstr =& $elements[$i];
				$qstr = substr_replace($qstr, '', strpos($qstr, $csep), 1);
				$qstr = substr_replace($qstr, '', strrpos($qstr, $csep), 1);
				$qstr = str_replace('""', '"', $qstr);
			}
		}
	}
	return $elements;
}//ko_get_csv_values()









/************************************************************************************************************************
 *                                                                                                                      *
 * Util-FUNKTIONEN                                                                                                      *
 *                                                                                                                      *
 ************************************************************************************************************************/


function ko_get_help($module, $type) {
	global $ko_path;

	//Map kOOL languages to TYPO3-Language uids
	$map_lang = array("en" => 0, "de" => 1, "nl" => 2);

	if($type == '') $type = '_notype';
	$help = FALSE;

	//Get help entry from cache
	if(isset($GLOBALS['kOOL']['ko_help'][$_SESSION['lang']][$type])) {
		$help = $GLOBALS['kOOL']['ko_help'][$_SESSION['lang']][$type];
	} else {
		$help = $GLOBALS['kOOL']['ko_help']['en'][$type];
	}
	if(!$help["id"]) return FALSE;


	//Help text given in DB - display as tooltip
	if($help["text"]) {
		$text = str_replace("\r", "", str_replace("\n", "", nl2br(ko_html($help["text"]))));
		$link = '<span onmouseover="tooltip.show(\''.$text.'\');" onmouseout="tooltip.hide();"><img src="'.$ko_path.'images/icon_help.png" border="0" alt="help" /></span>';
	}
	//Create link to online documentation
	else {
		if(!$help["t3_page"]) return FALSE;
		$href  = 'http://www.churchtool.org/?id='.$help["t3_page"];
		$href .= '&L='.$map_lang[$help["language"]];
		if($help["t3_content"]) $href .= "#c".$help["t3_content"];

		$link = '<a href="'.$href.'" target="_blank"><img src="'.$ko_path.'images/icon_help.png" border="0" alt="help" title="'.getLL("help_link_title").'" /></a>';
	}

	return array("show" => TRUE, "link" => $link);
}//ko_get_help()




function ko_leute_sort(&$data, $sort_col, $sort_order, $dont_apply_limit=FALSE, $forceDatafields=FALSE) {
	global $all_groups, $FAMFUNCTION_SORT_ORDER, $access;

	//Check for columns which don't need second sorting as they can be sorted by MySQL directly (see ko_get_leute)
	if(!is_array($sort_col)) $sort_col = array($sort_col);
	if(!is_array($sort_order)) $sort_order = array($sort_order);
	if(!ko_manual_sorting($sort_col)) return $data;

	//get all datafields (used in map_leute_daten)
	$all_datafields = db_select_data("ko_groups_datafields", "WHERE 1=1", "*");

	//build sort-array
	foreach($data as $i => $v) {
		foreach($sort_col as $col) {
			if(!$col) continue;

			$col_value = NULL;
			$map_col = $col;  //Used for map_leute_daten()
			$df_index = 0;  //Defaults to first element (role/x) for groups. Will be set to higher value for datafields below

			//Sort by birthday instead of age (only used from tx_koolleute_pi1)
			if($col == "MODULEgeburtsdatum") {
				$map_col = "geburtsdatum";
			}
			//find datafield-index, if sorted for a datafield column
			else if($pos = strpos($col, "datafield")) {
				$df_index = (int)substr($col, ($pos+9));
				$col_ = substr($col, 0, $pos);
				$col_value = map_leute_daten($v[$col_], $col_, $v, $all_datafields, $forceDatafields);
			//otherwise take first column, where the role (or just x) ist stored
			}

			if(!$col_value) $col_value = map_leute_daten($v[$map_col], $map_col, $v, $all_datafields, $forceDatafields);
			//Birthday
			switch($col) {
				case "MODULEgeburtsdatum":
					$col_value = strftime('%m%d%Y', strtotime($v[$map_col]));
				break;
				case 'famid':
					//Only use the family name without "from city (A,B,C) M"
					if(FALSE !== strpos($col_value, (' '.getLL('from').' '))) {
						$col_value = substr($col_value, 0, strpos($col_value, (' '.getLL('from').' ')));
					} else if(FALSE !== strpos($col_value, '(')) {
						$col_value = substr($col_value, 0, strpos($col_value, '('));
					}
				break;
				case 'famfunction':
					if(isset($FAMFUNCTION_SORT_ORDER[$v[$col]])) $col_value = $FAMFUNCTION_SORT_ORDER[$v[$col]];
					else $col_value = 9;  //Add entires with no famfunction at the end
				break;
			}
			if(is_array($col_value)) {
				$col_value = $col_value[$df_index];
			}

			//Build sort arrays for array_multisort()
			${"sort_".$col}[$i] = strtolower($col_value);
		}
	}
	foreach($sort_col as $i => $col) {
		$sort[] = '$sort_'.$col.', SORT_'.strtoupper($sort_order[$i]);
	}
	eval('array_multisort('.implode(", ", $sort).', $data);');

	if(!$dont_apply_limit) {
		$data = array_slice($data, ($_SESSION["show_start"]-1), $_SESSION["show_limit"]);
	}

	//Correct array index (numeric indizes get rearranged by array_multisort())
	foreach($data as $key => $value) {
		$r[$value["id"]] = $value;
	}
	return $r;
}//ko_leute_sort()




function ko_get_map_links($data) {
	$code = "";
	$hooks = hook_get_by_type("leute");
	if(sizeof($hooks) > 0) {
		foreach($hooks as $hook) {
			if(function_exists("my_map_".$hook)) {
				$code .= call_user_func("my_map_".$hook, $data);
			}
		}
	}

	return $code;
}//ko_get_map_links()




function ko_check_fm_for_user($fm_id, $uid) {
	global $FRONTMODULES;

	$allow = FALSE;
	$fm = $FRONTMODULES[$fm_id];

	ko_get_user_modules($uid, $user_modules);

	if(!$fm["modul"]) {  //no module needed, to display this FM
		$allow = TRUE;
	} else {  //One of the given modules must be installed for this FM
		foreach(explode(",", $fm["modul"]) as $m) {
			if(in_array($m, $user_modules)) $allow = TRUE;
		}
	}
	return $allow;
}//ko_check_fm_for_user()

/**
  * Check, whether LDAP ist active for this kOOL
	*/
function ko_do_ldap() {
	global $ldap_enabled, $ldap_dn;

	$do_ldap = ($ldap_enabled && trim($ldap_dn) != "");
	return $do_ldap;
}//ko_do_ldap()



/**
	* Connect and bind to the LDAP-Server
	*/
function ko_ldap_connect() {
	global $ldap_server, $ldap_admin, $ldap_dn, $ldap_admin_pw;

	ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);
	$ldap = ldap_connect($ldap_server);
	if($ldap) {
		//Bind (Login)
		$r = ldap_bind($ldap, ("cn=".$ldap_admin.",ou=login,".$ldap_dn), $ldap_admin_pw);
		if(!$r) return FALSE;
		else return $ldap;
	}
	return FALSE;
}//ko_ldap_connect()



/**
  * Disconnect from the LDAP-Server
	*/
function ko_ldap_close() {
	global $ldap;

	ldap_close($ldap);
}//ko_ldap_close()



/**
  * LDAP: Add Person Entry
	*/
function ko_ldap_add_person($data, $edit=FALSE) {
	global $ldap_dn, $ldap;

	if($ldap) {
		//Data vorbehandeln, damit es mit z.B. Umlauten keine Probleme gibt.
		foreach($data as $i => $d) {
			if(!$i) unset($data[$i]);  //Unset entries with no key
			else if(trim($d) == "") $data[$i] = array();  //Set empty values to array(), so they get deleted in LDAP
			else $data[$i] = utf8_encode($d);  //Encode normal values with UTF-8
		}
		$data["objectclass"][0] = "top";
		$data["objectclass"][1] = "person";
		$data["objectclass"][2] = "organizationalPerson";
		$data["objectclass"][3] = "inetOrgPerson";

		if($edit) 
			$r = ldap_modify($ldap, ("uid=".$data["uid"].",".$ldap_dn), $data);
		else 
			$r = ldap_add($ldap, ("uid=".$data["uid"].",".$ldap_dn), $data);

		return $r;
	}
	return FALSE;
}//ko_ldap_add_person()



/**
  * LDAP: Delete Person Entry
	*/
function ko_ldap_del_person($id) {
	global $ldap_dn, $ldap;

	if($ldap) {
		$r = ldap_delete($ldap, ("uid=".$id.",".$ldap_dn));
		return $r;
	}
	return FALSE;
}//ko_ldap_del_person()




/**
  * LDAP: Check for a person
	*/
function ko_ldap_check_person($id) {
	global $ldap_dn, $ldap;

	if($ldap) {
		$result = ldap_search($ldap, $ldap_dn, "uid=".$id);
		$num = ldap_count_entries($ldap, $result);

		if($num >= 1) return TRUE;
		else return FALSE;
	}
	return FALSE;
}//ko_ldap_check_person()




/**
  * LDAP: Check for a login
	*/
function ko_ldap_check_login($cn) {
	global $ldap_dn, $ldap;

	if($ldap) {
		$result = ldap_search($ldap, "ou=login,".$ldap_dn, "cn=".$cn);
		$num = ldap_count_entries($ldap, $result);

		if($num >= 1) return TRUE;
		else return FALSE;
	}
	return FALSE;
}//ko_ldap_check_login()




/**
  * LDAP: Add Login Entry
	*/
function ko_ldap_add_login($data) {
	global $ldap_dn, $ldap;

	if($ldap) {
		//Data vorbehandeln, damit es mit z.B. Umlauten keine Probleme gibt.
		foreach($data as $i => $d) {
			if($d == "") $data[$i] = array();
			else if($i == "userPassword") $data[$i] = '{md5}'.base64_encode(pack('H*', $d));
			else $data[$i] = utf8_encode($d);
		}
		$data["objectclass"][0] = "top";
		$data["objectclass"][1] = "person";
		$data["objectclass"][2] = "organizationalPerson";
		$data["objectclass"][3] = "inetOrgPerson";

		$r = ldap_add($ldap, ("cn=".$data["cn"].",ou=login,".$ldap_dn), $data);

		return $r;
	}
	return FALSE;
}//ko_ldap_add_login()





/**
  * LDAP: Delete Login Entry
	*/
function ko_ldap_del_login($cn) {
	global $ldap_dn, $ldap;

	if($ldap) {
		$r = ldap_delete($ldap, ("cn=".$cn.",ou=login,".$ldap_dn));
		return $r;
	}
	return FALSE;
}//ko_ldap_del_login()





/**
  * Speichert SMS-Balance von ClickaTell-Account in DB (Caching)
	*/
function set_cache_sms_balance($balance) {
	db_update_data('ko_settings', "WHERE `key` = 'cache_sms_balance'", array('value' => $balance));;
}


/**
  * Holt den gecachten SMS-Balance-Wert
	*/
function get_cache_sms_balance() {
	$query = "SELECT `value` FROM `ko_settings` WHERE `key` = 'cache_sms_balance'";
	$result = mysql_query($query);
	$value = mysql_fetch_assoc($result);
	return $value["value"];
}


/**
  * Sendet SMS-Mitteilung
	*/
function send_sms($recipients, $text, $from, $climsgid, $msg_type, &$success, &$done, &$problems, &$charges) {
	global $SMS_PARAMETER, $BASE_PATH;

	require($BASE_PATH."inc/Clickatell.php");
  set_time_limit(0);

	//Text
  $sms_message["text"] = substr($text, 0, 160);

  //Sender ID
  $sms_message["from"] = "kOOL";  //Default value
	if(isset($SMS_PARAMETER["sender_id"])) {  //Check for sender_id set in ko-config.php
		if(is_array($SMS_PARAMETER["sender_id"])) {
			if(in_array($from, $SMS_PARAMETER["sender_id"])) $sms_message["from"] = $from;
		} else if($SMS_PARAMETER["sender_id"] != "") {
			$sms_message["from"] = $SMS_PARAMETER["sender_id"];
		}
	}

  //Client-Message-ID
  $sms_message["climsgid"] = $climsgid;

  //Message-Type
  $sms_message["msg_type"] = $msg_type;


	$done = $success = $charges = 0;
	$problems = "";
  $sms = new SMS_Clickatell;
  $sms->init($SMS_PARAMETER);
  $log_message = "";


  if($sms->auth()) {
    foreach($recipients as $e) {
      if(check_natel($e)) {
        $sms_message["to"] = $e;
        $status = $sms->sendmsg($sms_message);

				//Get Api-Msg-ID and store it
        $temp = explode(" ", $status[1]);
        $apimsgid = $temp[0];

				//Get Status and Charge of sent SMS
        $charge = $sms->getmsgcharge($apimsgid);     //Array ( [0] => 1.5 [1] => 003 )
				//002: Queued, 003: Sent, 004: Received, 008: OK
        if(in_array($charge[1], array("002", "003", "004", "008"))) {
					$success++;
        } else {
          $problems .= $e.", ";
        }
        $charges += $charge[0];
        $done++;
        $log_message .= $e.", ";
      }//if(check_natel(e))
    }//foreach(empfaenger as e)

		//Neue Balance speichern
    set_cache_sms_balance($sms->getbalance());

		$log_message = format_userinput($sms_message["text"], "text") . " - " . substr($log_message, 0, -2) . " - $success/$done - " . substr($problems, 0, -2) . " - $charges";
    ko_log("sms_sent", $log_message);

		return TRUE;
  }//if(sms->auth())
  else {
    return FALSE;
	}
}//send_sms()





/**
 * ezmlm mailinglist management
 */
function ko_ezmlm_subscribe($list, $moderator, $email) {
	if($list == "" || $moderator == "" || !check_email($email)) return FALSE;
	ko_send_email(str_replace("@", "-subscribe-".str_replace("@", "=", $email)."@", $list), " ", " ", array("From" => $moderator));
}//ko_ezmlm_subscribe()

function ko_ezmlm_unsubscribe($list, $moderator, $email) {
	if($list == "" || $moderator == "" || !check_email($email)) return FALSE;
	ko_send_email(str_replace("@", "-unsubscribe-".str_replace("@", "=", $email)."@", $list), " ", " ", array("From" => $moderator));
}//ko_ezmlm_unsubscribe()




function ko_get_contrast_color($hexcolor, $dark = '#000000', $light = '#FFFFFF') {
	$sum3 = hexdec(substr($hexcolor, 0, 2)) + hexdec(substr($hexcolor, 2, 2)) + hexdec(substr($hexcolor, 4, 2));
  return ($sum3 > 3*0x000088 || $hexcolor == '') ? $dark : $light;
}





/**
	* berprft und korrigiert ein Datum
	* Basiert auf PEAR-Klasse zur berprfung der Richtigkeit des Datums
	*/
function check_datum(&$d) {
	$d = format_userinput($d, "date");

	get_heute($tag, $monat, $jahr);

	//Trennzeichen testen (. oder ,)
  $date_ = explode(".", $d);
  $date__ = explode(",", $d);
  $date___ = explode("-", $d);
	if(sizeof($date_) >= 2) $date = $date_;
	else if(sizeof($date__) >= 2) $date = $date__;
	else if(sizeof($date___) >= 2) {  //SQL-Datum annehmen
		$date = $date___;
		$temp = $date[0]; $date[0] = $date[2]; $date[2] = $temp;
	}

	//Angaben ohne Jahr erlauben, dann einfach aktuelles Jahr einfgen
	if(sizeof($date) == 2) $date[2] = $jahr;
	if($date[2] == "") $date[2] = $jahr;  //Falls noch kein Jahr gefunden, dann einfach auf aktuelles setzen

	//Jahr auf vier Stellen ergnzen, falls ntig (immer 20XX verwenden)
	if(strlen($date[2]) == 2) $date[2] = (int)("20".$date[2]);
	else if(strlen($date[2]) == 1) $date[2] = (int)("200".$date[2]);

	$d = strftime('%d.%m.%Y', mktime(1,1,1, $date[1], $date[0], $date[2]));
	return ($date[0] > 0 && $date[1] > 0 && $date[2] > 0);
}//check_datum()


/**
	* berprft eine Zeit auf syntaktische Richtigkeit
	*/
function check_zeit(&$z) {
	$z = format_userinput($z, "date");

  $z_1 = explode(":", $z);
  $z_2 = explode(".", $z);
  if(sizeof($z_1) == 2) $z_ = $z_1;
  else if(sizeof($z_2) == 2) $z_ = $z_2;
  else $z_ = explode(":", ($z . ":00"));

	$z = implode(":", $z_);
  if($z_ != "" && $z_[0] >= 0 && $z_[0] <= 24 && $z_[1] >=0 && $z_[1] <=60) return true;
  else return false;
}//check_zeit()


/**
  * berprft auf syntaktisch korrekte Emailadresse
	*/
function check_email($email) {
	set_time_limit(2);

	if (eregi("^[0-9a-z]([-_.]?[0-9a-z])*@[0-9a-z]([-.]?[0-9a-z])*\\.[a-wyz][a-z](g|l|m|pa|t|u|v)?$", $email, $check)) {
	  if (checkdnsrr(substr(strstr($check[0], '@'), 1), "ANY")) {
	    return TRUE;
	  }
	}
	return FALSE;
}//check_email()


/**
  * Formatiert eine Natelnummer ins internationale Format fr clickatell
	*/
function check_natel(&$natel) {
	if(trim($natel) == "") return FALSE;

	$natel = format_userinput($natel, "uint");
	if(substr($natel, 0, 2) == '00') {  //Area code given as 00XY
		$natel = substr($natel, 2);
		if($natel) return TRUE;
		else return FALSE;
	} else if(substr($natel, 0, 1) == "0") {
		$natel = ko_get_setting("sms_country_code").substr($natel, 1);
		if($natel) return TRUE;
		else return FALSE;
	}
	if($natel) return TRUE;
	else return FALSE;
}//check_natel()



/**
	* Fgt einem String eine "0" vorne hinzu, falls der String nur 1 Zeichen enthlt
	*/
function str_to_2($s) {
	while(strlen($s) < 2) {
		$s = "0" . $s;
	}
	return $s;
}


/**
	* Wandelt die angegebene Zeit in eine SQL-Zeit um
	*/
function sql_zeit($z) {
  if($z != "") {
		$z = str_replace(".", ":", $z);
    $z_1 = explode(":", $z);
		switch(sizeof($z_1)) {
			case 1: $r = "$z:00"; break;
			case 2: $r = $z; break;
			case 3: $r = substr($z, 0, -3); break;
		}
  } else {
    $r = "";
	}
	if($r == "00:00") $r = "";
  return format_userinput($r, "date");
}//sql_zeit()



/**
	* Wandelt das angegebene Datum in ein SQL-Datum um
	*/
function sql_datum($d) {
	//Testen, ob Datum schon im SQL-Format ist:
	$temp = explode("-", $d);
	if(sizeof($temp) == 3) return format_userinput($d, "date");

  if($d != "") {
    $date = explode(".", $d);
		$r = $date[2] . "-" . $date[1] . "-" . $date[0];
  } else {
    $r = "";
  }
  return format_userinput($r, "date");
}//sql_datum()


/**
	* Wandelt ein SQL-Datum ins Format TG.MT.JAHR um
	*/
function sql2datum($s) {
	if($s=="" || $s=="0000-00-00") return "";
	$s_ = explode("-", $s);
	if(sizeof($s_) == 3) {
		$r = $s_[2].".".$s_[1].".".$s_[0];
  	return $r;
	} else {
		return $s;
	}
}//sql2datum()



/**
 * Converts an SQL date (YYYY-MM-DD) into a unix timestamp
 */
function sql2timestamp($s) {
	if($s=="" || $s=="0000-00-00") return "";
	else return strtotime($s);
}//sql2timestamp()



/**
	* Wandelt ein SQL-DateTime ins Format TG.MT.JAHR hh:mm:ss um
	*/
function sqldatetime2datum($s) {
	if($s=="" || $s=="0000-00-00 00:00:00") return "";
	$temp = explode(" ", $s);
	$date = $temp[0];
	$time = $temp[1];

	$s_ = explode("-", $date);
	if(sizeof($s_) == 3) {
		$r = $s_[2].".".$s_[1].".".$s_[0];
  	return $r." ".$time;
	} else {
		return $s;
	}
}//sqldatetime2datum()


/**
	* Addiert zu einem angegebenen Datum s Monate (inkl. berlauf-Check)
	*/
function addmonth(&$m, &$y, $s) {
  $m = (int)$m; $y = (int)$y; $s = (int)$s;

  $m += $s;
  while($m < 1) {
    $m += 12;
    $y--;
	}
	while($m > 12) {
    $m -= 12;
    $y++;
  }
}//addmonth()


/**
	* Liefert Tag, Monat und Jahr des aktuellen Datums
	*/
function get_heute(&$t, &$m, &$j) {
  $heute = getdate(time());
  $t = $heute["mday"];
  $m = $heute["mon"];
  $j = $heute["year"];
}


/**
	* Formaitert eine Emailadresse fr die anzeige im Web
	*/
function format_email($m) {
	return strtr($m, array('@' => ' (at) ', '.' => ' (dot) '));
}//format_email()


/**
	* Entfernt alle mglichen "gefhrlichen" Zeichen aus User-Strings (z.B. bei der Speicherung von Filter-Vorlagen)
	*/
function format_userinput($s, $type, $enforce=FALSE, $length=0, $replace=array(), $add_own="") {
	if($replace['umlaute']) $s = strtr($s, array(''=>'a',''=>'o',''=>'u',''=>'e',''=>'e',''=>'a',''=>'A',''=>'O',''=>'U'));

	if($replace['singlequote'] || $replace["allquotes"]) $s = strtr($s, array("'" => '', '`' => ''));
	if($replace["doublequote"] || $replace["allquotes"]) $s = str_replace('"', "", $s);
	if($replace["backquote"] || $replace["allquotes"]) $s = str_replace("`", "", $s);

	//Bei falscher Lnge abbrechen
	if($length != 0) {
		if(substr($length, 0, 1) == "=") {  //Falls exakte Lnge verlangt...
			if(strlen($s) != $length) {
				if($enforce) {
					$s = "";
					return FALSE;
				} else {
					$s = substr($s, 0, $length);
				}
			}
		} else {  //...sonst auf maximale Lnge prfen
			if(strlen($s) > $length) {
				if($enforce) {
					$s = "";
					return FALSE;
				} else {
					$s = substr($s, 0, $length);
				}
			}
		}
	}//if(length)

	//Type testen
	switch($type) {
		case "uint":
			$allowed = "1234567890";
		break;

		case "int":
			$allowed = "-1234567890";
		break;

		case "int@":
			$allowed = "1234567890@";
		break;

		case "intlist":
			$allowed = "1234567890,";
		break;

		case "alphanumlist":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_-,";
		break;

		case "float":
			$allowed = "-1234567890.";
		break;

		case "alphanum":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
		break;

		case "alphanum+":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890+-_";
		break;

		case "alphanum++":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890+-_ ";
		break;

		case "email":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.+-_@&";
		break;

		case "dir":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890-_ ";
		break;

		case "js":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890-_?+&.;/ ";
		break;

		case "alpha":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
		break;

		case "alpha+":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ+-_";
		break;

		case "alpha++":
			$allowed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ+-_ ";
		break;

		case "date":
			$allowed = "1234567890-.: ";
		break;

		case "text":
			//Falls schon ein addslashes angewendet worden ist, diese erst wieder entfernen.
			$s = str_replace("\\", "", $s);
			$new = addslashes($s);
			return $new;
		break;

		case "all":
			return TRUE;
		break;
	}//switch(type)

	if($add_own) $allowed .= $add_own;

  $new = "";
  for($i=0; $i<strlen($s); $i++) {
    if(FALSE !== strstr($allowed, substr($s, $i, 1))) {
      $new .= substr($s, $i, 1);
    } else {
			if($enforce) {
				return FALSE;  //Bei ungltigen Zeichen nur abbrechen, wenn enforce true ist.
			}
		}
  }
  return $new;
}



/**
  * Formatiert Sonderzeichen in ihre HTML-Entsprechungen
	* Damit soll XSS in Formularen und sonst verhindert werden
	*/
function ko_html($string) {
	return strtr($string, array('&' => "&amp;",
															"'" => "&lsquo;",
															'"' => "&quot;",
															'>' => "&gt;",
															'<' => "&lt;",
															'' => "&ouml;",
															'' => "&auml;",
															'' => "&uuml;",
															'' => "&Ouml;",
															'' => "&Auml;",
															'' => "&Uuml;",
															)
							);
}//ko_html()



/**
  * Wendet ko_html-Funktion zweimal an. Z.B. fr Overlib-Code
	*/
function ko_html2($string) {
	$r = ko_html(ko_html($string));
	return $r;
}



function ko_unhtml($string) {
	return strtr($string, array("&amp;" => "&",
															"&lsquo;" => "'",
															"&quot;" => '"',
															"&gt;" => '>',
															"&lt;" => '<',
															"&ouml;" => '',
															"&auml;" => '',
															"&uuml;" => '',
															"&Ouml;" => '',
															"&Auml;" => '',
															"&Uuml;" => '',
															)
	);
}//ko_unhtml()



/**
  * Bereitet einen Text fr ein Email auf, indem jeder Zeile schliessende \n entfernt werden
	*/
function ko_emailtext($input) {
	$lines = explode("\n", $input);
  $text = "";
  foreach($lines as $l) {
    $text .= rtrim($l)."\n";
  }
	return $text;
}//ko_emailtext()



/**
  * Trimmt jedes Element eines Arrays
	*/
function array_trim($arr){
	unset($result);
	foreach($arr as $key => $value){
    if (is_array($value)) $result[$key] = array_trim($value);
    else $result[$key] = trim($value);
  }
  return $result;
}




/**
  * Erwartet Array eines Datums mit den Eintrgen 0=>Tag, 1=>Monat, 2=>Jahr (4-stellig)
  * Gibt einen Code in der Form JJJJMMTT zurck
  * Geeignet fr Int-Vergleiche von Daten
  */
function date2code($d) {
	$return = $d[2] . str_to_2($d[1]) . str_to_2($d[0]);
	return $return;
}

function code2date($d) {
	$r[2] = substr($d, 0, 4);
	$r[1] = substr($d, 4, 2);
	$r[0] = substr($d, 6, 2);
	return $r;
}


/**
  * Erwartet Datum als .-getrennter String, einen Modus (tag, woche, monat) und ein Inkrement
  * Gibt Datum als Array zurck (0=>Tag, 1=>Monat, 2=>Jahr)
	*/
function add2date($datum, $mode, $inc, $sqlformat=FALSE) {
	if($sqlformat) {
		$d[0] = substr($datum, 8, 2);
		$d[1] = substr($datum, 5, 2);
		$d[2] = substr($datum, 0, 4);
	} else {
		if(is_array($datum)) $d = $datum;
		else $d = explode('.', $datum);
	}

	switch($mode) {
		case 'tag':
		case 'day':
			$d[0] = (int)$d[0] + (int)$inc;
		break;
		case 'woche':
		case 'week':
			$d[0] = (int)$d[0] + ( 7*(int)$inc );
		break;
		case 'monat':
		case 'month':
			$d[1] = (int)$d[1] + (int)$inc;
		break;
	}//switch(mode)

	//Ueberlufe korrigieren
	if($sqlformat) {
		$r = strftime('%Y-%m-%d', mktime(1, 1, 1, $d[1], $d[0], $d[2]));
	} else {
		$r_ = strftime('%d.%m.%Y', mktime(1, 1, 1, $d[1], $d[0], $d[2]));
		$r = explode('.', $r_);
	}
	return $r;
}



function add2time($time, $inc) {
	list($hour, $minute) = explode(':', $time);
	$new = 60*(int)$hour + (int)$minute + (int)$inc;
	return intval($new/60).':'.($new%60);
}//add2time()


/**
  * Liefert den ersten Montag vor dem bergebenen Datum (YYYY-MM-DD)
	*/
function date_find_last_monday($date) {
	$wd = date("w", strtotime($date));
	if($wd == 0) $wd = 7;
	$r = add2date($date, "tag", (-1*($wd-1)), TRUE);
	return $r;
}//date_find_last_monday()



/**
  * Liefert den nchsten Sonntag nach dem bergebenen Datum (YYYY-MM-DD)
	*/
function date_find_next_sunday($date) {
	$wd = date("w", strtotime($date));
	if($wd == 0) $wd = 7;
	$r = add2date($date, "tag", (7-$wd), TRUE);
	return $r;
}//date_find_next_sunday()




function date_convert_timezone($date_str, $tz, $date_format = 'Ymd\THis\Z') {
  $time = strtotime($date_str);
  $tz_bak = getenv('TZ');
  putenv('TZ='.$tz);
  $ret = date($date_format, $time);
  putenv('TZ'.($tz_bak?'='.$tz_bak:''));
  return $ret;
}//date_convert_timezone()




function ko_calendar_mwselect($mode) {
	global $DATETIME;

	$r = '';

	if($mode == 'month') {
		$r .= '<select name="sel_mwselect" size="1" onchange="val=this.options[this.selectedIndex].value; sendReq(\'inc/ajax.php\', \'action,ymd\', \'fcsetdate,\'+val); $(\'#ko_calendar\').fullCalendar(\'gotoDate\', val.substring(0,4), (val.substring(5,7)-1), val.substring(8));">';
		$today = date('Y-m-').min(28, date('d'));
		$view_stamp = mktime(1,1,1, $_SESSION['cal_monat'], $_SESSION['cal_tag'], $_SESSION['cal_jahr']);
		$cur_month = date('m-Y');
		for($i=-12; $i<25; $i++) {
			$temp = strtotime(add2date($today, 'monat', $i, TRUE));
			$label = strftime('%m-%Y', $temp);
			$value = strftime('%Y-%m-%d', $temp);
			$sel = $label == strftime('%m-%Y', $view_stamp) ? 'selected="selected"' : '';
			$mark = $label == $cur_month ? ' * ' : '&nbsp;&nbsp;&nbsp;';
			$mark = $label == $cur_month ? 'style="background: #c0c0c0;"' : '';
			$r .= '<option value="'.$value.'" '.$sel.' '.$mark.'>'.$label.'</option>';
		}
		$r .= '</select>';
	}
	else if($mode == 'agendaWeek') {
		$r .= '<select name="sel_mwselect" size="1" onchange="val=this.options[this.selectedIndex].value; sendReq(\'inc/ajax.php\', \'action,ymd\', \'fcsetdate,\'+val); $(\'#ko_calendar\').fullCalendar(\'gotoDate\', val.substring(0,4), (val.substring(5,7)-1), val.substring(8));">';
		$today = date('Y-m-d');
		$view_stamp = mktime(1,1,1, $_SESSION['cal_monat'], $_SESSION['cal_tag'], $_SESSION['cal_jahr']);
		$cur_week = strftime('%V-%G', time());
		for($i=-52; $i<105; $i++) {
			$temp = strtotime(add2date($today, 'woche', $i, TRUE));
			$label = strftime('%V-%G', $temp);
			$value = strftime('%Y-%m-%d', $temp);
			$sel = $label == strftime('%V-%G', $view_stamp) ? 'selected="selected"' : '';
			$mark = $label == $cur_week ? 'style="background: #c0c0c0;"' : '';
			$r .= '<option value="'.$value.'" '.$sel.' '.$mark.'>'.$label.'</option>';
		}
		$r .= '</select>';
	}
	else if($mode == 'agendaDay') {
		$r .= '<select name="sel_mwselect" size="1" onchange="val=this.options[this.selectedIndex].value; sendReq(\'inc/ajax.php\', \'action,ymd\', \'fcsetdate,\'+val); $(\'#ko_calendar\').fullCalendar(\'gotoDate\', val.substring(0,4), (val.substring(5,7)-1), val.substring(8));">';
		$today = date('Y-m-d');
		$view_stamp = mktime(1,1,1, $_SESSION['cal_monat'], $_SESSION['cal_tag'], $_SESSION['cal_jahr']);
		$cur_day = strftime($DATETIME['ddmy'], time());
		for($i=-60; $i<300; $i++) {
			$temp = strtotime(add2date($today, 'tag', $i, TRUE));
			$label = strftime($DATETIME['ddmy'], $temp);
			$value = strftime('%Y-%m-%d', $temp);
			$sel = $label == strftime($DATETIME['ddmy'], $view_stamp) ? 'selected="selected"' : '';
			//Mark sundays
			if(strftime('%w', $temp) == 0) $mark = 'style="background: #e6e6e6;"';
			 //Mark current date
			else if($label == $cur_day) $mark = 'style="background: #c0c0c0;"';
			else $mark = '';
			$r .= '<option value="'.$value.'" '.$sel.' '.$mark.'>'.$label.'</option>';
		}
		$r .= '</select>';
	}

	return $r;
}//ko_calendar_mwselect()



/**
	* Liefert wiederholte Termine nach verschiedenen Modi. (fr Reservationen und Termine verwendet)
	* d1 und d2 sind Start- und Enddatum des einzelnen Anlasses (wiederholte mehrtgige Anlsse sind mglich)
	* repeat_mode enthlt den Modus der Wiederholung (keine, taeglich, wochentlich, monatlich1, monatlich2)
	* bis_monat und bis_jahr stellen das Ende der Wiederholung dar (inkl.)
	*/
function ko_get_wiederholung($d1, $d2, $repeat_mode, $inc, $bis_tag, $bis_monat, $bis_jahr, &$r, $max_repeats="") {
	//Resultat-Array leeren
	$r = array();
	$num_repeats = 1;

	$d1 = format_userinput($d1, "date");
	$d2 = format_userinput($d2, "date");
	$repeat_mode = format_userinput($repeat_mode, "alphanum");
	$bis_tag = format_userinput($bis_tag, "uint");
	$bis_monat = format_userinput($bis_monat, "uint");
	$bis_jahr = format_userinput($bis_jahr, "uint");

	//Datum vorbereiten und Dauer fr ein mehrtgiges Ereignis berechnen
	$d1e = explode(".", $d1);
	$sd_string = date2code($d1e);
	if($d2 != "") {
		$d2e = explode(".", $d2);
		$ed_string = date2code($d2e);
		$d_diff = (int)($sd_string - $ed_string);
	} else $d_diff = 0;

	//Enddatum in Code umwandeln
	if($max_repeats == "") {  //Keine Anzahl Wiederholungen angegeben --> Enddatum verwenden
		$max_repeats = 1000;
		$until_string = date2code(array($bis_tag, $bis_monat, $bis_jahr));
	} else {  //Sonst Anzahl Wiederholungen verwenden und Datum in ferne Zukunft legen
		$until_string = date2code(array("31", "12", "3000"));
	}

	switch($repeat_mode) {
		case "taeglich":
		case "woechentlich":
		case "monatlich2":  //Immer am gleichen Datum

			//Inkrement wird vor dem Aufruf richtig gesetzt, also muss nur noch definiert werden, was inkrementiert werden soll
			if($repeat_mode == "taeglich") $add_mode = "tag";
			else if($repeat_mode == "woechentlich") $add_mode = "woche";
			else if($repeat_mode == "monatlich2") $add_mode = "monat";

			$r[] = $d1;
			$r[] = $d2;
			$new_code1 = date2code(add2date($d1, $add_mode, $inc));
			$new_code2 = ($d_diff == 0) ? "" : date2code(add2date($d2, $add_mode, $inc));
			while($new_code1 <= $until_string && $num_repeats < $max_repeats) {
				$num_repeats++;

				$code1 = code2date($new_code1);
				$r[] = $code1[0] . "." . $code1[1] . "." . $code1[2];
				$code2 = code2date($new_code2);
				if($code2[0] != "") $r[] = $code2[0] . "." . $code2[1] . "." . $code2[2];
				else $r[] = "";

				$new_code1 = date2code(add2date(code2date($new_code1), $add_mode, $inc));
				$new_code2 = ($d_diff == 0) ? "" : date2code(add2date(code2date($new_code2), $add_mode, $inc));

			}//while(new_code1 < until_string)
		break;

		case "monatlich1":  //z.B. "Jeden 3. Montag"
			$nr_ = explode("@", $inc);
			$nr = $nr_[0];
			$tag = $nr_[1];

			$erster = $d1e;
			$erster[0] = 1;
			$new_code = date2code($erster);

			while($new_code <= $until_string && $num_repeats < $max_repeats) {
				$num_repeats++;
				$found = FALSE;
				while(!$found && $erster[0] < 8) {
					$wochentag = strftime("%w", mktime(1, 1, 1, $erster[1], $erster[0], $erster[2]));
					if($wochentag == $tag) $found = TRUE;
					else $erster[0] += 1;
				}
				$neues_datum = add2date($erster, "tag", ($nr-1)*7);
				$r[] = $neues_datum[0] . "." . $neues_datum[1] . "." . $neues_datum[2];
				$neues_datum2 = add2date($neues_datum, "tag", $d_diff);
				$r[] = ($d_diff > 0) ? ($neues_datum2[0] . "." . $neues_datum2[1] . "." . $neues_datum2[2]) : "";

				$erster[0] = 1;
				$erster = add2date($erster, "monat", 1);
				$new_code = date2code($erster);

			}//while(new_code < until_string)
			
		break;

		default:  //case 'keine'
			$r[] = $d1;
			$r[] = $d2;
	}//switch(repeat_mode)
	return TRUE;
}



function ko_get_new_serie_id($table) {
	$max1 = db_select_data("ko_".$table, "", "MAX(`serie_id`) as max", "", "", TRUE);
	$max2 = db_select_data("ko_".$table."_mod", "", "MAX(`serie_id`) as max", "", "", TRUE);
	$max = max($max1["max"], $max2["max"]);
	return ($max+1);
}//ko_get_new_serie_id()


/**
	* Erstellt einen Log-Eintrag zu definierten Typ. Timestamp und UserID werden automatisch eingefgt
	*/
function ko_log($type, $msg) {
	db_insert_data('ko_log', array('type' => format_userinput($type, 'alphanum+', FALSE, 0, array(), '@'), 'comment' => mysql_real_escape_string($msg), 'user_id' => $_SESSION['ses_userid'], 'date' => date('Y-m-d H:i:s')));
}//ko_log()



/**
  * Erstellt Log-Meldung anhang zwei bergebener Arrays, und gibt die Differenzen an
	*/
function ko_log_diff($type, $data, $old=array()) {
	$msg = "";
	foreach($data as $key => $value) {
		if($old[$key] != $value) {
			$msg .= "$key: ".$old[$key]." --> ".$value.", ";
		}
	}
	if(isset($old["id"])) $msg = "id: ".$old["id"].", ".$msg;
	ko_log($type, substr($msg, 0, -2));
}//ko_log_diff()



/**
  * Erstellt Log-Meldung, falls in einem Modul ein behandelter Error auftritt.
	* Dient der Verfolgbarkeit von User-Meldungen, wenn sie einen Error erhalten.
	*/
function ko_error_log($module, $error, $error_txt, $action) {
	$log_message  = "$module Error $error: '$error_txt' - Action: $action - ";
  $log_message .= "User: ".$_SESSION["ses_username"]." (".$_SESSION["ses_userid"].") - ";
  $log_message .= "POST: (".var_export($_POST, TRUE).")";
  $log_message .= " - GET: (".var_export($_GET, TRUE).")";

	ko_log("error", $log_message);
}//ko_error_log()





/**
	* Liefert einen einzelnen Logeintrag
	*/
function ko_get_log(&$logs, $z_where="", $z_limit="") {
	if($_SESSION["sort_logs"] && $_SESSION["sort_logs_order"]) {
		$sort = " ORDER BY ".$_SESSION["sort_logs"]." ".$_SESSION["sort_logs_order"];
	} else {
		$sort = "";
	}

	$logs = db_select_data('ko_log', 'WHERE 1=1 '.$z_where, '*', $sort, $z_limit);
}//ko_get_log()


/**
	* Versucht, die IP, des aktuellen Users zu ermitteln
	*/
function ko_get_user_ip() {
	if(isset($HTTP_X_FORWARDED_FOR) && $HTTP_X_FORWARDED_FOR != NULL) {  //Bei Proxy
		$ip = $HTTP_X_FORWARDED_FOR;
	} else {
		$ip = $_SERVER['REMOTE_ADDR'];
	}
	return $ip;
}//ko_get_user_ip()



/**
  *
	*/
function ko_menuitem($module, $show) {
	global $ko_menu_akt;

	$pre = '<b>'; $post = '</b>';

	$ll_item = getLL('submenu_'.$module.'_'.$show);
	//Mark active entry
	if($_SESSION['show'] == $show && $ko_menu_akt == $module) {
		return $pre.$ll_item.$post;
	} else {
		return $ll_item;
	}
}//ko_menuitem()



function ko_get_filename($file_name) {
  $newfile = basename($file_name);
  if (strpos($newfile,'\\') !== false) {
     $tmp = preg_split("[\\\]",$newfile);
     $newfile = $tmp[count($tmp) - 1];
     return($newfile);
   } else {
     return($file_name);
	}
}




function ko_returnfile($file_, $path_="download/pdf/", $filename_="") {
  $file_ = basename(format_userinput($file_, "alphanum+", FALSE, 0, array(), "."));
	$file = $path_.$file_;
  $filename = $filename_ ? $filename_ : $file_;

  $fp = @fopen($file, "r");
  if (!$fp) {
    header("HTTP/1.0 404 Not Found");
    print "Not found!";
    return false;
  }

  if (isset($_SERVER["HTTP_USER_AGENT"]) && strpos($_SERVER["HTTP_USER_AGENT"], "MSIE")) {
	  // IE cannot download from sessions without a cache
   	header("Cache-Control: public");

		 // q316431 - Don't set no-cache when over HTTPS
		 if (  !isset($_SERVER["HTTPS"]) || $_SERVER["HTTPS"] != "on") {
			 header("Pragma: no-cache");
		 }
	}
  else {
    header("Cache-Control: no-cache, must-revalidate");
    header("Pragma: no-cache");
  }

  $mime = exec("/usr/bin/file -bin ".$file." 2>/dev/null");
  if ($mime == "") $mime = "application/octet-stream";
  header("Content-Type: ".$mime);

  // Inline text files, don't separatly save them
  $ext = substr($file, -3);
  if ($ext != "txt") {
    header("Content-Disposition: attachment; filename=\"".$filename."\"");
  }

  header("Content-Length: ".filesize($file));
  header("Content-Description: kOOL");
  fpassthru($fp);
  exit;
}//ko_returnfile()



function dirsize($path) {
	global $ko_path;

  $old_path = getcwd();
  if(!is_dir($ko_path."/".$path)) return -1;
  $size = trim(shell_exec("cd \"".$ko_path."/".$path."\"; du -sb; cd \"".$old_path."\";"), "\x00..\x2F\x3A..\xFF");

  return $size;
}




/**
  * Liefert ein Array aller im Browser eingestellten Sprachen in der Reihenfolge der Prioritten
	*/
function getBrowserLanguages() {
	$languages = array();
	$strAcceptedLanguage = explode(',',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
  foreach ($strAcceptedLanguage as $languageLine) {
    list ($languageCode, $quality) = explode (';',$languageLine);
	  $arrAcceptedLanguages[$languageCode] = $quality ? substr ($quality,2) : 1;
  }

  // Now sort the accepted languages by their quality and create an array containing only the language codes in the correct order.
  if (is_array ($arrAcceptedLanguages)) {
    arsort ($arrAcceptedLanguages);
    $languageCodes = array_keys ($arrAcceptedLanguages);
    if (is_array($languageCodes)) {
      reset ($languageCodes);
      while (list ($languageCode,$quality) = each ($languageCodes)){
        $quality = substr ($quality,0,5);
        $languages[$languageCode] = str_replace("-", "_", $quality);
      }
    }
  }
	return $languages;
}//getBrowserLanguages()


/**
  * Liefert die bersetzung zu dem bergegebenen String in der aktuellen Sprache. Mit dem zweiten Parameter kann eine Sprache definiert werden.
	*/
function getLL($string) {
	global $LOCAL_LANG;

	if(!$string) return "";
	return $LOCAL_LANG[$_SESSION["lang"]][$string];
}//getLL()



function ko_update_ko_config($mode, $data) {
	global $ko_path;

	$start = $ignore = $found = FALSE;
	//Open config file
	$config_file = $ko_path."config/ko-config.php";
	$fp = @fopen($config_file, "r");
	if($fp) {
		//Go through all the lines
		while (!feof($fp)) {
			$line = fgets($fp);
			switch($mode) {
				case "plugins":
					if(!$start && substr(trim($line), 0, 8) == '$PLUGINS') {
						$found = TRUE;
						$start = TRUE;
						$ignore = TRUE;
					} else if($start == TRUE && trim($line) == ');') {
						$start = FALSE;
						$ignore = FALSE;
						$line = $data;
					}
				break;  //plugins

				case "db":
					if(!$start && substr(trim($line), 0, 11) == '$mysql_user') {
						$found = TRUE;
						$start = TRUE;
						$ignore = TRUE;
					} else if($start == TRUE && substr(trim($line), 0, 9) == '$mysql_db') {
						$start = FALSE;
						$ignore = FALSE;
						$line = $data;
					}
				break;  //db

				case "html_title":
					$found = TRUE;
					if(substr(trim($line), 0, 11) == '$HTML_TITLE') $line = $data;
				break;

				case "base_url":
					$found = TRUE;
					if(substr(trim($line), 0, 9) == '$BASE_URL') $line = $data;
				break;

				case "base_path":
					$found = TRUE;
					if(substr(trim($line), 0, 10) == '$BASE_PATH') $line = $data;
				break;

				case "modules":
					$found = TRUE;
					if(substr(trim($line), 0, 8) == '$MODULES') $line = $data;
				break;

				case "web_langs":
					$found = TRUE;
					if(substr(trim($line), 0, 10) == '$WEB_LANGS') $line = $data;
				break;

				case "get_lang_from_browser":
					$found = TRUE;
					if(substr(trim($line), 0, 22) == '$GET_LANG_FROM_BROWSER') $line = $data;
				break;

				case "sms":
					$found = TRUE;
					if(substr(trim($line), 0, 14) == '$SMS_PARAMETER') $line = $data;
				break;  //sms

				case "warranty":
					if(!$start && substr(trim($line), 0, 22) == 'define("WARRANTY_GIVER') {
						$found = TRUE;
						$start = TRUE;
						$ignore = TRUE;
					} else if($start == TRUE && substr(trim($line), 0, 20) == 'define("WARRANTY_URL') {
						$start = FALSE;
						$ignore = FALSE;
						$line = $data;
					}
				break;  //warranty

				case "webfolders":
					$found = TRUE;
					if(substr(trim($line), 0, 18) == 'define("WEBFOLDERS') $line = $data;
				break;
			}//switch(mode)

			//Check whether the data could be updated before the last line
			if(trim($line) == '?>') {
				if(!$found) {  //else insert the data right before the end
					$new_config .= "\n".$data;
				}
			}

			//Build new config-file
			if(!$ignore) {
				$new_config .= $line;
			}

		}//while(!feof(fp))
		fclose($fp);
	} else {
		return FALSE;
	}

	//Write new config
	$fp = @fopen($config_file, "w");
	fputs($fp, $new_config);
	fclose($fp);
}//ko_update_ko-config()




function ko_send_email($to, $subject, $message, $headers) {
	if(defined('ALLOW_SEND_EMAIL') && ALLOW_SEND_EMAIL == FALSE) return FALSE;

	//Check for Reply-To header
	if(isset($headers["From"]) && !isset($headers["Reply-To"])) {
		$headers["Reply-To"] = $headers["From"];
	}

	$mail_headers = NULL;
	foreach($headers as $k => $v) {
		$mail_headers[] = trim($k).": ".trim($v);
	}
	//Add Return-Path for error messages
	if(defined('EMAIL_SET_RETURN_PATH') && EMAIL_SET_RETURN_PATH == TRUE) $mail_headers[] = 'Return-Path: <'.ko_get_setting('info_email').'>';
	$mail_headers[] = 'X-Mailer: '.getLL('kool');

	if(defined('DEBUG_EMAIL') && DEBUG_EMAIL) {
		print '<h2>Email sent</h2>';
		foreach($mail_headers as $h) {
			print ko_html($h).'<br />';
		}
		print '<b>To: '.ko_html($to).'</b><br />';
		print '<b>Subject: '.ko_html($subject).'</b><br />';
		print '<hr>'.nl2br($message).'<hr>';
		return TRUE;
	} else {
		$return_path = defined('EMAIL_SET_RETURN_PATH') && EMAIL_SET_RETURN_PATH == TRUE ? '-f'.ko_get_setting('info_email') : '';
		$sent = mail($to, $subject, $message, implode("\n", $mail_headers), $return_path);
		return $sent;
	}
}//ko_send_email()





function ko_die($msg) {
	print '<div style="border: 2px solid; padding: 10px; background: #3282be; color: white; font-weight: 900;">'.$msg.'</div>';
	exit;
}//ko_die()



function ko_round05($amount) {
	$value = (floor(20*$amount+0.5)/20);
	return $value;
}//ko_round05()



function ko_guess_date(&$v, $mode="first") {
	if(!$v) return $v;
	$r = "";

	$v = str_replace("-", ".", $v);
	$v = str_replace("/", ".", $v);
	$parts = explode(".", $v);
	if(sizeof($parts) == 3) {
		//TODO: first value could also be month (USA)!
		if($parts[0] > 31) {  //assume sql date
			$r = intval($parts[0])."-".intval($parts[1])."-".intval($parts[2]);
		} else {  //assume date dd.mm.yyyy
			$r = intval($parts[2])."-".intval($parts[1])."-".intval($parts[0]);
		}
	} else if(sizeof($parts) == 2) {
		$r = intval($parts[1])."-".intval($parts[0]).($mode=="first"?"-01":"-31");
	} else {  //only one value --> year
		if($v < 1900) {
			if($v < 20) {
				$v += 2000;
			} else {
				$v += 1900;
			}
		}
		$r = intval($v).($mode=="first"?"-01-01":"-12-31");
	}

	$v = strftime('%Y-%m-%d', strtotime($r));
}//ko_guess_date()




function ko_bar_chart($data, $legend, $mode="", $total_width=600) {
	//find max value
	$max = 0;
	foreach($data as $value) {
		$max = max($value, $max);
	}
	//find width of values
	$num_data = sizeof($data);
	$width1 = round($total_width/$num_data, 0);
	$width2 = round(0.75*$total_width/$num_data, 0);
	//build table
	$c = '<table style="border:1px solid #aaa;" cellpadding="0" cellspacing="0"><tr height="100">';
	foreach($data as $value) {
		if($mode == "log") {
			$value = $value == 1 ? 1.5 : $value;
			$height = floor(log($value)/log($max)*100);
			$value = $value == 1.5 ? 1 : $value;
		} else {
			$height = $max == 0 ? 0 : floor($value/$max*100);
		}
		$c .= '<td align="center" valign="bottom" style="height:100px; width:'.$width1.'px;">';
		$c .= '<div style="text-align:center; color: white; width:'.$width2.'px; height:'.$height.'px; background-color:#9abdea;">'.$value.'</div>';
		$c .= '</td>';
	}
	$c .= '</tr><tr>';
	foreach($legend as $value) {
		$c .= '<td align="center">'.$value.'</td>';
	}
	$c .= '</tr></table><br />';

	return $c;
}//ko_bar_chart()



function ko_truncate($s, $l, $l2=0, $add="..") {
	if(strlen($s) <= $l) {
		return $s;
	} else {
		return substr($s, 0, $l-$l2).$add.($l2 > 0 ? substr($s, -$l2) : "");
	}
}//ko_truncate()




/**
  * Stopwatch
	*/
function sw($do="", $tag="") {
	global $sw, $sws;

  list($usec, $sec) = explode(" ", microtime());
  $time = ((float)$usec + (float)$sec);

	switch($do) {
		case "init":
			$sw = $time;
		break;

		case "tag":
			$sws[] = array("tag" => $tag, "value" => ($time - $sw));
		break;

		case "print":
			print "\n<!--\n";
			foreach($sws as $s) {
				print ($s["tag"] ? '"'.$s["tag"].'"' : "").': '.$s["value"]."\n";
			}
			print "\n-->\n";
		break;

		case "printout":
			print '<br /><hr width="100%" /><b>Time:</b><br />';
			foreach($sws as $s) {
				print ($s["tag"] ? '"'.$s["tag"].'"' : "").': '.$s["value"]."<br />";
			}
		break;

		default:
			return $time;
		break;
	}//switch(do)
}


/**
  * Debug-Print
	*/
function print_d($array) {
	print '<pre>';
	print_r($array);
	print '</pre>';
}//print_d()

?>
